// k is the dispenser index (from the sorter in point) to bring the
// full signal out from
void FullSignal(CBasicObject &bo, unsigned n, unsigned sep, unsigned k)
{
  std::string tmp;

  bo.Layer();

  unsigned i;

  tmp += "{nor {e n} f e}";

  for(i=0; i<k; i++)
  {
    if (i==0) // first one will have signal from nor
    {
      tmp += "{del {e n} f e} {del {s e} f}";
    }
    else
    {
      tmp += "{del {e n} f} {del {s e} f}";
    }

    tmp += "{del {e n} f} {nor {e n} f e} {nor {e n} f}";

    for(unsigned j = 0; j<sep-5; j++)
    {
      tmp += "{del {e n} f}";
    }
  }

  tmp += "{del {e n} f} {del {s e} f} {nor {e n} f e} {nor {s e} f} {nor {w n} f w}";

  for(unsigned j=0; j<sep-5; j++)
  {
    tmp += "{del {w n} f}";
  }


  for(i = k; i<n-2; i++)
  {
    tmp += "{del {s e} f}";

    tmp += "{del {w n} f} {del {w n} f} {nor {w n} f} {nor {w n} f w}";

    for(unsigned j = 0; j<sep-5; j++)
    {
      tmp += "{del {w n} f}";
    }
  }

  tmp += "{del {s e} f} {del {w n} f w} {nor {w n} f w}";

  bo.String(tmp.c_str());

  bo.Terminal("a",2,0,0,true,north);
  bo.Terminal("o",k*sep+4,0,0,false,south);
}

// make a block exit path that brings dispensed blocks to a common point
//  n is the number of dispensers
//  i is the dispenser index (from the sorter in point) to make the exit
//     after
//  sep is the separation between dispensers
//  bpal is the length of the back path before the encoded dispense signal
//    input
//  bpbl is the length of the back path after the encoded dispense signal
void BlockExitPath(CCompoundObject &co, unsigned n, unsigned i, unsigned sep, unsigned bpal,unsigned bpbl)
{
  if (sep<1)
    return;

  if (n<2)
    return;

  std::string tmpsb,tmpsf;

  CBasicObject *eastwestpath;

  eastwestpath = new CBasicObject;

  eastwestpath->Layer();

  tmpsb.erase();
  tmpsf.erase();

  {for(unsigned j = 0; j<n-1; j++)
  {
    for(unsigned k=0; k<sep; k++)
    {
      if (k==0)
        tmpsf += std::string("{del {f n}}");
      else
        tmpsf += std::string("{nul {n e}}");

      if (j<i || j==i && k<(sep/2))
        tmpsb += std::string("{del {w n}}");
      else if (j==i && k==(sep/2))
        tmpsb += std::string("{del {f n}}");
      else
        tmpsb += std::string("{del {e n}}");
    }
  }}

  tmpsb += std::string("{del {e n}} {del {e n}} {del {e n}}");
  tmpsf += std::string("{del {f n}} {nul {n e}} {nul {n e}}");

  eastwestpath->String(tmpsb.c_str());
  eastwestpath->String(tmpsf.c_str());

  eastwestpath->Layer();

  tmpsb.erase();
  tmpsf.erase();

  {for(unsigned j = 0; j<n-1; j++)
  {
    for(unsigned k=0; k<sep; k++)
    {
      if (j==0 && k<2)
        tmpsb += std::string("{nul {n e}}");
      else
        if (j<i || j==i && k<(sep/2))
          tmpsb += std::string("{sli {n e}}");
        else if (j==i && k==(sep/2))
          tmpsb += std::string("{sli {n b}}");
        else
          tmpsb += std::string("{sli {n w}}");

      if (k==0)
        tmpsf += std::string("{del {n e}}");
      else
        tmpsf += std::string("{nul {n e}}");
    }
  }}

  tmpsb += std::string("{sli {n w}} {sli {n w}} {sli {n w}}");
  tmpsf += std::string("{del {n e}} {nul {n e}} {nul {n e}}");

  eastwestpath->String(tmpsb.c_str());
  eastwestpath->String(tmpsf.c_str());

  char tmp[8];

  {for(unsigned j=0; j<n-1; j++)
  {
    for(unsigned k=0; k<sep; k++)
    {
      eastwestpath->SetOutputs(j*sep+k,0,0,true);        
    }
    eastwestpath->SetOutputs(j*sep,0,1,true);        
    eastwestpath->SetOutputs(j*sep,1,1,true);        

    sprintf(tmp,"o%d",j);

    eastwestpath->Terminal(tmp,j*sep,1,1,false,north);
  }}

  sprintf(tmp,"o%d",n-1);
  eastwestpath->Terminal(tmp,(n-1)*sep,1,1,false,north);

  eastwestpath->Terminal("i",i*sep + (sep/2),0,0,true,back);

  eastwestpath->SetOutputs((n-1)*sep,0,0,true);
  eastwestpath->SetOutputs((n-1)*sep,0,1,true);
  eastwestpath->SetOutputs((n-1)*sep,1,1,true);
  eastwestpath->SetOutputs((n-1)*sep+1,0,0,true);
  eastwestpath->SetOutputs((n-1)*sep+2,0,0,true);

  CBasicObject *backpath = new CBasicObject();

  backpath->Layer();
  {for(unsigned j = 0; j<bpbl-1; j++)
  {
    backpath->String("{del {b n}}");
  }}
  backpath->String("{del {w n}}");
  backpath->String("{del {w n}}");
  {for(unsigned j = 0; j<bpal-1; j++)
  {
    backpath->String("{del {f n}}");
  }}
  backpath->Layer();
  {for(unsigned j = 0; j<bpbl-1; j++)
  {
    backpath->String("{sli {n b}}");
  }}
  backpath->String("{sli {n b}}");
  backpath->String("{sli {n b}}");
  {for(unsigned j = 0; j<bpal-1; j++)
  {
    backpath->String("{sli {n b}}");
  }}

  {for(unsigned j = 0; j<bpal; j++)
  {
    backpath->SetOutputs(0,0,bpbl+bpal-j-1,true);
  }}

  backpath->Terminal("ob",0,0,0,false,back);
  backpath->Terminal("of",0,0,bpbl+bpal-1,false,front);
  backpath->Terminal("ireq",0,0,bpbl,true,east);
  backpath->Terminal("ipul",0,0,bpbl-1,true,east);

  co.AddObject(eastwestpath,"ewp",0,0,0);
  co.AddObject(backpath,"bp","of","ewp.i");
}
