#ifndef blockmanager_cpp
#define blockmanager_cpp

#include "sorter\slidefilter2.cpp"
#include "sorter\rotatefilter.cpp"
#include "sorter\fusefilter.cpp"
#include "sorter\unfusefilter.cpp"
#include "sorter\delfilter.cpp"
#include "sorter\norfilter.cpp"
#include "sorter\rotmech3.cpp"
#include "sorter\sorterback.cpp"
#include "sorter\sorterjunction.cpp"
#include "sorter\sorterexit.cpp"
#include "sorter\exitsignal.cpp"

#include "hopper.cpp"
#include "blockexitpath.cpp"
#include "orientation.cpp"
#include "signalpath.cpp"
#include "sflipflop.cpp"

void Gap(CBasicObject &bo, unsigned n)
{
  char tmps[256];

  bo.Layer();

  tmps[0] = (char)0;
  {for(unsigned i = 0; i<n; i++)
  {
    strcat(tmps,"{del {e n}}");
  }}
  bo.String(tmps);

  tmps[0] = (char)0;
  {for(unsigned i = 0; i<n; i++)
  {
    strcat(tmps,"{sli {f e}}");
  }}
  bo.String(tmps);

  bo.Terminal("signal-feed-in",0,0,0,true,west);
  bo.Terminal("signal-feed-out",n-1,0,0,false,east);
}

void TestBlocks(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {b n}}");
  bo.String("{del {b n}} {del {e n}} {del {e n}} {del {e n}} {del {e n}} {del {e n}} {del {e n}} {del {e n}}");
  bo.String("{del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {b n}}");
  bo.String("{del {b n}} {del {e n}} {del {e n}} {del {e n}} {del {e n}} {del {e n}} {del {e n}} {del {e n}}");
  bo.String("{del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {b n}}");
  bo.String("{del {b n}} {del {e n}} {del {e n}} {del {e n}} {del {e n}} {del {e n}} {del {e n}} {del {e n}}");
  bo.String("{del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {b n}}");
  bo.String("{del {b n}} {del {e n}} {del {e n}} {del {e n}} {del {e n}} {del {e n}} {del {e n}} {del {e n}}");
  bo.String("{del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {b n}}");
  bo.String("{del {b n}} {del {e n}} {del {e n}} {del {e n}} {del {e n}} {del {e n}} {del {e n}} {del {e n}}");
  bo.String("{del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {b n}}");
  bo.String("{del {b n}} {del {e n}} {del {e n}} {del {e n}} {del {e n}} {del {e n}} {del {e n}} {del {e n}}");
  bo.String("{del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}}");

  bo.Layer();
  bo.String("{sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n f}}");
  bo.String("{sli {n f}} {sli {n w}} {sli {n w}} {sli {n w}} {sli {n w}} {sli {n w}} {sli {n w}} {sli {n w}}");
  bo.String("{sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n f}}");
  bo.String("{sli {n f}} {sli {n w}} {sli {n w}} {sli {n w}} {sli {n w}} {sli {n w}} {sli {n w}} {sli {n w}}");
  bo.String("{sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n f}}");
  bo.String("{sli {n f}} {sli {n w}} {sli {n w}} {sli {n w}} {sli {n w}} {sli {n w}} {sli {n w}} {sli {n w}}");
  bo.String("{sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n f}}");
  bo.String("{sli {n f}} {sli {n w}} {sli {n w}} {sli {n w}} {sli {n w}} {sli {n w}} {sli {n w}} {sli {n w}}");
  bo.String("{sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n f}}");
  bo.String("{sli {n f}} {sli {n w}} {sli {n w}} {sli {n w}} {sli {n w}} {sli {n w}} {sli {n w}} {sli {n w}}");
  bo.String("{sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n f}}");
  bo.String("{sli {n f}} {sli {n w}} {sli {n w}} {sli {n w}} {sli {n w}} {sli {n w}} {sli {n w}} {sli {n w}}");
  bo.String("{sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}} {sli {n e}}");

  char tmps[256],tmps2[32];
  static char *block[7] = {"sli","psh","rot","del","ufs","fus","nor"};
  static char *dir[6] = {"n","e","s","w","f","b"};
  unsigned bn,d1,d2;

  bo.Layer();
  for(unsigned i = 0; i<13; i++)
  {
    tmps[0] = (char)0;
    for(unsigned j = 0; j<8; j++)
    {
      bn = rand()%6;
      d1 = rand()%6;
      d2 = rand()%6;

      while((d1==0 || d1==2) && (d2==0 || d2==2) ||
		    (d1==1 || d1==3) && (d2==1 || d2==3) ||
			(d1==4 || d1==5) && (d2==4 || d2==5))
      {
        d2 = rand()%6;
      }

      sprintf(tmps2,"{%s {%s %s} ewfbs}",block[bn],dir[d1],dir[d2]);
      strcat(tmps,tmps2);
    }

    bo.String(tmps);
  }

  bo.Terminal("i",7,0,12,true,east);
}

void BlockManager(CCompoundObject &co, unsigned fullz, unsigned columns, unsigned numnor)
{
  CBasicObject *sf,*rf,*ff,*uf,*df,*nf,*srm,*sbp,*sj,*se,*es;
  CCompoundObject *srms;
  CBasicObject *gap[6];
  CBasicObject *fuls;
  unsigned seps[6] = {9,9,9,9,9,9};
  CCompoundObject *hop[6];
  CCompoundObject *bep;
//  CCompoundObject *finh;
  CBasicObject *ontator;
  CBasicObject *ontatori;
  CBasicObject *ontatorp[5];
  CBasicObject *fulout1,*fulout2;

  sf = new CBasicObject();
  rf = new CBasicObject();
  ff = new CBasicObject();
  uf = new CBasicObject();
  df = new CBasicObject();
  nf = new CBasicObject();
  srm = new CBasicObject();
  sbp = new CBasicObject();
  sj = new CBasicObject();
  se = new CBasicObject();
  es = new CBasicObject();
  srms = new CCompoundObject();
  fuls = new CBasicObject();
  ontator = new CBasicObject();
  ontatori = new CBasicObject();
  fulout1 = new CBasicObject();
  fulout2 = new CBasicObject();

  {for(unsigned i = 0; i<6; i++)
  {
    gap[i] = new CBasicObject();
    hop[i] = new CCompoundObject();
  }}

  bep = new CCompoundObject();
//  finh = new CCompoundObject();

  {for(unsigned i = 0; i<5; i++)
  {
    ontatorp[i] = new CBasicObject();
  }}

  SlideFilter(*sf);
  RotateFilter(*rf);
  FuseFilter(*ff);
  UnfuseFilter(*uf);
  DeltaFilter(*df);
  NorFilter(*nf);
  SorterRotatorMechanism(*srm);
  SignalPathJointed(*srms,"f 42 s 8");
//  SorterRotatorSignals(*srms,7,4);
  SorterBackPath(*sbp,59);
  SorterJunctionV2(*sj);
  SorterExit(*se,seps);
  ExitSignal(*es);

  Gap(*(gap[0]),6);
  Gap(*(gap[1]),6);
  Gap(*(gap[2]),5);
  Gap(*(gap[3]),5);
  Gap(*(gap[4]),5);
  Gap(*(gap[5]),1);

  Hopper(*(hop[0]),"sli",true,true,true,columns,numnor,fullz,true);
  Hopper(*(hop[1]),"rot",false,true,false,columns,numnor,fullz,true);
  Hopper(*(hop[2]),"nor",false,false,true,columns,numnor,fullz,true);
  Hopper(*(hop[3]),"del",true,true,false,columns,numnor,fullz,false);
  Hopper(*(hop[4]),"fus",true,false,true,columns,numnor,fullz,false);
  Hopper(*(hop[5]),"ufs",false,true,true,columns,numnor,fullz,false);

  BlockExitPath(*bep,6,2,9,16,5);
  FullSignal(*fuls,6,9,2);
  SignalPath(*fulout2,1,13,1,north,east,back,south,back);
  SignalPath(*fulout1,1,1,30-fullz,south,back,west,north,north);
//  FeedInhibit(*finh,1);

  Orientator(*ontator);
  OrientatorInputs(*ontatori);
  {for(unsigned i = 0; i<5; i++)
  {
    SignalPath(*ontatorp[i],3,1,1,west,north,back,east,west);
  }}

  co.AddObject(sf,"slidefilter",0,0,0);
  co.AddObject(gap[0],"gap0","signal-feed-in","slidefilter.signal-feed-out");
  co.AddObject(rf,"rotatefilter","signal-feed-in","gap0.signal-feed-out");
  co.AddObject(gap[1],"gap1","signal-feed-in","rotatefilter.signal-feed-out");
  co.AddObject(nf,"norfilter","signal-feed-in","gap1.signal-feed-out");
  co.AddObject(gap[2],"gap2","signal-feed-in","norfilter.signal-feed-out");
  co.AddObject(df,"delfilter","signal-feed-in","gap2.signal-feed-out");
  co.AddObject(gap[3],"gap3","signal-feed-in","delfilter.signal-feed-out");
  co.AddObject(ff,"fusefilter","signal-feed-in","gap3.signal-feed-out");
  co.AddObject(gap[4],"gap4","signal-feed-in","fusefilter.signal-feed-out");
  co.AddObject(uf,"unfusefilter","signal-feed-in","gap4.signal-feed-out");
  co.AddObject(gap[5],"gap5","signal-feed-in","unfusefilter.signal-feed-out");
  co.AddObject(srm,"srm","signal-feed-in","gap5.signal-feed-out");
  co.AddObject(sbp,"back","signal-feed-in","srm.signal-feed-out");
  co.AddObject(sj,"junction","signal-feed-in","back.signal-feed-out");
  co.AddObject(se,"exit","slide-exit-in","slidefilter.signal-detect-out");
  co.AddObject(es,"exitsig","signal-in","exit.signal-out");
  co.AddObject(srms,"srms","o","srm.sig-in");

  co.AddObject(hop[0],"hop0","i","slidefilter.signal-detect-out2");
//  co.AddObject(hop[1],"hop1","i","pushfilter.signal-detect-out");
  co.AddObject(hop[1],"hop1","i","rotatefilter.signal-detect-out");
  co.AddObject(hop[2],"hop2","i","norfilter.signal-detect-out");
  co.AddObject(hop[3],"hop3","i","delfilter.signal-detect-out");
  co.AddObject(hop[4],"hop4","i","fusefilter.signal-detect-out");
  co.AddObject(hop[5],"hop5","i","unfusefilter.signal-detect-out");

  co.AddObject(bep,"bep","ewp.o0","hop0.disp.track2.i");
  co.AddObject(fuls,"fuls","a","hop0.disp.track2.a");
//  co.AddObject(finh,"finh","ff.s","fuls.o");
  co.AddObject(fulout1,"fulout1","i","fuls.o");
  co.AddObject(fulout2,"fulout2","i","fulout1.o");

  co.AddObject(ontator,"ottr","i","bep.bp.ob");
  co.AddObject(ontatori,"ottri","o0","ottr.r0");
  co.AddObject(ontatorp[0],"ottrp0","o","ottri.i0");
  co.AddObject(ontatorp[1],"ottrp1","o","ottri.i1");
  co.AddObject(ontatorp[2],"ottrp2","o","ottri.i2");
  co.AddObject(ontatorp[3],"ottrp3","o","ottri.i3");
  co.AddObject(ontatorp[4],"ottrp4","o","ottri.i4");

}

#endif