#ifndef CALL
#define CALL

void CallFlipFlop(CBasicObject &bo, bool set, bool forward, char setin = 's', char resetin = 'w')
{
  bo.Layer();

  if (set && !forward)
  {
    bo.String("{nul {n e}}");
    bo.String("{del {f e} eswb}");
    bo.String("{nor {s e} eswf s}");
    bo.String("{nul {n e}}");
    bo.Layer();
    bo.String("{nul {n e}}");
    bo.String("{nul {n e}}");
    bo.String("{nor {f e} newfb f}");
    bo.String("{nul {n e}}");
  }
  else if (!set && forward)
  {
    bo.String("{nul {n e}}");
    bo.String("{nor {s e} eswb s}");
    bo.String("{del {f e} eswf}");
    bo.String("{nul {n e}}");
    bo.Layer();
    bo.String("{nul {n e}}");
    bo.String("{nor {f e} newfb f}");
    bo.String("{nul {n e}}");
    bo.String("{nul {n e}}");
  }
  else if (!set && !forward)
  {
    bo.String("{del {f e} eswb}");
    bo.String("{nor {s e} eswf s}");
    bo.String("{nul {n e}}");
    bo.String("{nul {n e}}");
    bo.Layer();
    bo.String("{nul {n e}}");
    bo.String("{nor {f e} newfb f}");
    bo.String("{nul {n e}}");
    bo.String("{nul {n e}}");
  }
  else if (set && forward)
  {
    bo.String("{nul {n e}}");
    bo.String("{nul {n e}}");
    bo.String("{nor {s e} eswb s}");
    bo.String("{del {f e} eswf}");
    bo.Layer();
    bo.String("{nul {n e}}");
    bo.String("{nul {n e}}");
    bo.String("{nor {f e} newfb f}");
    bo.String("{nul {n e}}");
  }

  char tmps[16] = "{del {s f}}";
  char tmps2[16] = "{del {w n}}";

  tmps[6] = setin;
  tmps2[6] = resetin;

  if (setin == 'f' || setin == 'b')
  {
    tmps[8] = 'e';
  }
  if (resetin == 'n' || resetin == 's')
  {
    tmps2[8] = 'e';
  }

  bo.Layer();
  bo.String("{nul {n e}}");
  bo.String("{sli {s f}}");
  bo.String("{sli {s b}}");
  bo.String("{nul {n e}}");
  bo.Layer();
  bo.String("{nul {n e}}");
  bo.String(tmps2);
  bo.String(tmps);
  bo.String("{nul {n e}}");
  bo.Layer();
  bo.String("{nul {n e}}");
  bo.String("{nul {n e}}");
  if (setin == 's')
    bo.String(tmps);
  else
    bo.String("{nul {n e}}");
  bo.String("{nul {n e}}");

  bo.Terminal("reset-in",0,3,1,true,OppositeDir(CharToDirection(resetin)));
  bo.Terminal("reset-out",0,3,1,false,back);
  bo.Terminal("set-in",0,4,2,true,OppositeDir(CharToDirection(setin)));
  
  if (!forward)
    bo.Terminal("out",0,1,2,false,front);
  else
    bo.Terminal("out",0,1,3,false,front);
}

void CallJoinDelta(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{del {b e}}");

  bo.Terminal("i",0,0,0,true,front);
  bo.Terminal("o",0,0,0,false,west);
}

void CallGuard(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{nul {n e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {del {s e}} {del {s e}} {del {s e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {del {s e}} {del {s e}} {del {s e}} {del {s e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {del {s e}} {del {s e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {del {s e}} {nul {n e}} {nul {n e}}");
  bo.Layer();
  bo.String("{nul {n e}} {del {b e}} {del {b e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{del {w n}} {nul {n e}} {nul {n e}} {del {b e}} {del {b e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {del {f e}} {del {f e}} {nul {n e}} {nul {n e}} {del {b e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {del {f e}} {del {f e}} {nul {n e}}");
  bo.Layer();
  bo.String("{nul {n e}} {del {b e}} {del {b e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{del {w n}} {nul {n e}} {nul {n e}} {del {b e}} {del {b e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {del {f e}} {del {f e}} {nul {n e}} {nul {n e}} {del {b e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {del {f e}} {del {f e}} {nul {n e}}");

  // 'input' is a misnomer here, since these terminals are simply used for alignment
  bo.Terminal("ig",4,2,6,true,back);
  bo.Terminal("i2",3,2,6,true,back);
  bo.Terminal("i3",2,2,4,true,back);
  bo.Terminal("i4",1,2,4,true,back);

}

void CallRegister(CCompoundObject &co)
{
  CBasicObject *off[4];
  CBasicObject *jd[3];
  CBasicObject *grd;

  for(unsigned i = 0; i<4; i++)
  {
    off[i] = new CBasicObject;
    CallFlipFlop(*(off[i]),true,i%2!=0,((i==0)?'w':'s'),((i==0)?'s':'w'));

    if (i<3)
    {
      jd[i] = new CBasicObject;
      CallJoinDelta(*(jd[i]));
    }
  }

  grd = new CBasicObject;

  CallGuard(*grd);

  co.AddObject(off[0],"offg",0,0,0);
  co.AddObject(jd[0],"jd2","i","offg.reset-out");
  co.AddObject(off[1],"off2","reset-in","jd2.o");
  co.AddObject(jd[1],"jd3","i","off2.reset-out");
  co.AddObject(off[2],"off3","reset-in","jd3.o");
  co.AddObject(jd[2],"jd4","i","off3.reset-out");
  co.AddObject(off[3],"off4","reset-in","jd4.o");

  co.AddObject(grd,"grd","ig","offg.out");
}

// This is the temporary register that is used to make sure that signals
// coming along the bus are buffered for at least four cycles. It was
// designed for use with the CALL register, but could be used for
// anything else requiring a persistant signal.
void CallRegister2(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{del {w s}} {nor {s e}} {nor {s e}} {nor {s e}} {nor {s e}} {nor {s e}} {del {e n}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.Layer();
  bo.String("{del {s e}} {del {s e}} {del {s e}} {del {s e}} {del {s e}} {del {s e}} {del {s e}}");
  bo.String("{del {s e}} {nor {s e} neswb} {nor {s e} neswb} {nor {s e} neswb} {nor {s e} neswb} {nor {s e} neswb} {del {s e}}");
  bo.String("{del {f e}} {del {b e} neswf} {del {b e} neswf} {del {b e} neswf} {del {b e} neswf} {del {b e} neswf} {del {s e}}");
  bo.String("{del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {s e}}");
  bo.String("{del {s e}} {del {s e}} {del {s e}} {del {s e}} {del {s e}} {del {s e}} {del {s e}}");
  bo.Layer();
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{del {s e}} {sli {s f}} {sli {s f}} {sli {s f}} {sli {s f}} {sli {s f}} {del {s e}}");
  bo.String("{del {f e}} {sli {s b}} {sli {s b}} {sli {s b}} {sli {s b}} {sli {s b}} {nul {n e}}");
  bo.String("{del {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.Layer();
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{del {s e}} {del {s e}} {del {s e}} {del {s e}} {del {s e}} {del {s e}} {del {s e}}");
  bo.String("{del {b e}} {del {e s}} {del {e s}} {del {e s}} {del {e s}} {del {e s}} {nul {s e}}");
  bo.String("{del {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");

  bo.Terminal("reset",1,3,3,true,north);
  bo.Terminal("i0",0,3,2,true,north);
  bo.Terminal("i1",1,3,2,true,north);
  bo.Terminal("i2",2,3,2,true,north);
  bo.Terminal("i3",3,3,2,true,north);
  bo.Terminal("i4",4,3,2,true,north);
  bo.Terminal("i5",5,3,2,true,north);

  bo.Terminal("o1",1,0,2,false,south);
  bo.Terminal("o2",2,0,2,false,south);
  bo.Terminal("o3",3,0,2,false,south);
  bo.Terminal("o4",4,0,2,false,south);
  bo.Terminal("o5",5,0,2,false,south);
}

// This is an adapter that fits underneath underneath the call register and
// call flip flops and brings the signals forward to be gated with another
// signal (derived from call and read signals) and then passed forward to
// the call stack.
void CallSignalsAdapter(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{del {f e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{del {f e}} {del {f e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{del {f e}} {del {f e}} {del {f e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{del {f e}} {del {f e}} {del {f e}} {del {f e}} {del {s e}} {del {s e}} {del {s e}} {del {s e}} {nul {n e}}");
  bo.String("{nor {f e}} {nor {f e}} {nor {f e}} {nor {f e}} {nor {f e}} {nor {f e}} {nor {f e}} {nor {f e}} {nul {n e}}");
  bo.Layer();
  bo.String("{del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{del {s e}} {del {e n}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{del {s e}} {del {e n}} {del {e n}} {nul {n e}} {nul {n e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{del {s e}} {del {e n}} {del {e n}} {del {e n}} {nul {n e}} {del {f e}} {del {s e}} {nul {n e}} {nul {n e}}");
  bo.String("{del {s e}} {del {e n}} {del {e n}} {del {e n}} {del {e n}} {del {f e}} {del {f e}} {del {s e}} {nul {n e}}");
  bo.String("{del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {s e}}");
  bo.Layer();
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nor {s e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nor {s e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nor {s e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {s e}}");

  bo.Terminal("i5",0,1,0,true,north);
  bo.Terminal("i4",0,1,1,true,north);
  bo.Terminal("i3",0,1,2,true,north);
  bo.Terminal("i2",0,1,3,true,north);
  bo.Terminal("i1",0,1,4,true,north);

  bo.Terminal("o0",0,0,5,false,front);
  bo.Terminal("o1",1,0,5,false,front);
  bo.Terminal("o2",2,0,5,false,front);
  bo.Terminal("o3",3,0,5,false,front);
  bo.Terminal("o4",4,0,5,false,front);
  bo.Terminal("o5",5,0,5,false,front);
  bo.Terminal("o6",6,0,5,false,front);
  bo.Terminal("o7",7,0,5,false,front);

  bo.Terminal("oc",8,1,5,false,front);
}

void CallSignalsGate(CCompoundObject &co)
{
  CBasicObject *sp[8];

  {for(unsigned i = 0; i<8; i++)
  {
    sp[i] = new CBasicObject();
    SignalPath(*sp[i],1,2,7,front,north,east,back,north);
  }}

  co.AddObject(sp[0],"sp0",0,0,0);
  co.AddObject(sp[1],"sp1",1,0,0);
  co.AddObject(sp[2],"sp2",2,0,0);
  co.AddObject(sp[3],"sp3",3,0,0);
  co.AddObject(sp[4],"sp4",4,0,0);
  co.AddObject(sp[5],"sp5",5,0,0);
  co.AddObject(sp[6],"sp6",6,0,0);
  co.AddObject(sp[7],"sp7",7,0,0);

  CBasicObject *gate = new CBasicObject();

  gate->Layer();
  gate->String("{nor {n e}} {nor {n e}} {nor {n e}} {nor {n e}} {nor {n e}} {nor {n e}} {nor {n e}} {nor {n e}}");
  gate->Layer();
  gate->String("{nor {f e}} {nor {f e}} {nor {f e}} {nor {f e}} {nor {f e}} {nor {f e}} {nor {f e}} {nor {f e}}");
  gate->Layer();
  gate->String("{del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {s w}}");

  {for(unsigned i = 0; i<8; i++)
  {
    gate->SetOutputs(i,2,0,true);
  }}

  gate->Terminal("i0",0,0,0,true,south);
  gate->Terminal("i1",1,0,0,true,south);
  gate->Terminal("i2",2,0,0,true,south);
  gate->Terminal("i3",3,0,0,true,south);
  gate->Terminal("i4",4,0,0,true,south);
  gate->Terminal("i5",5,0,0,true,south);
  gate->Terminal("i6",6,0,0,true,south);
  gate->Terminal("i7",7,0,0,true,south);
  gate->Terminal("g",7,2,0,true,north);

  gate->Terminal("o0",0,1,0,true,front);
  gate->Terminal("o1",1,1,0,true,front);
  gate->Terminal("o2",2,1,0,true,front);
  gate->Terminal("o3",3,1,0,true,front);
  gate->Terminal("o4",4,1,0,true,front);
  gate->Terminal("o5",5,1,0,true,front);
  gate->Terminal("o6",6,1,0,true,front);
  gate->Terminal("o7",7,1,0,true,front);

  co.AddObject(gate,"gate","i0","sp0.o");

  CBasicObject *gp = new CBasicObject();

  SignalPath(*gp,1,9,4,front,south,west,front,south,true,true);

  co.AddObject(gp,"gp","o","gate.g");
}

void CallPulseGate(CCompoundObject &co)
{
  CBasicObject *callsigpath,*gate,*callpulsepath;
  CBasicObject *countgatepath;

  callsigpath = new CBasicObject();
  gate = new CBasicObject();
  callpulsepath = new CBasicObject();
  countgatepath = new CBasicObject();

  gate->Layer();
  gate->String("{nor {f e}}");
  gate->Terminal("i1",0,0,0,true,back);
  gate->Terminal("i2",0,0,0,true,east);
  gate->Terminal("o",0,0,0,false,front);
  // This is used to take a copy of the call signal upto the count signal to
  // to be used for gating the count signal.
  gate->Terminal("oc",0,0,-1,false,north); 
                                           

  SignalPath(*callsigpath,1,4,6,front,north,east,back,front);
  SignalPath(*callpulsepath,1,1,4,front,south,west,back,north);
  SignalPath(*countgatepath,2,5,1,north,front,east,south,east,true,true);

  co.AddObject(gate,"gate",0,0,0);
  co.AddObject(callsigpath,"callsigpath","o","gate.i1");
  co.AddObject(callpulsepath,"callpulsepath","i","gate.o");
  co.AddObject(countgatepath,"countgatepath","i","gate.oc");
}

void CallStackInputPaths(CCompoundObject &co)
{
  CCompoundObject *p[8];
  CBasicObject *frame = new CBasicObject();

  for(unsigned i = 0; i<8; i++)
  {
    p[i] = new CCompoundObject;
  }

  SignalPathJointed(*(p[7]),"f 4 s 1"); // 5
  SignalPathJointed(*(p[6]),"f 3 s 1 w 1 f 1"); // 6
  SignalPathJointed(*(p[5]),"f 3 w 2 f 1 s 1"); // 7
  SignalPathJointed(*(p[4]),"f 2 s 1 f 1 w 3 f 1"); // 8
  SignalPathJointed(*(p[3]),"f 2 s 1 w 4 f 2"); // 9
  SignalPathJointed(*(p[2]),"f 3 w 5 f 1 s 1"); // 10
  SignalPathJointed(*(p[1]),"f 2 w 6 f 2 s 1"); // 11
  SignalPathJointed(*(p[0]),"f 1 w 7 f 3 s 1"); // 12

  frame->Layer();
  frame->String("{nul {n e}}");
  frame->Terminal("0",0,0,0,false,front);
  frame->Terminal("1",1,0,0,false,front);
  frame->Terminal("2",2,0,0,false,front);
  frame->Terminal("3",3,0,0,false,front);
  frame->Terminal("4",4,0,0,false,front);
  frame->Terminal("5",5,0,0,false,front);
  frame->Terminal("6",6,0,0,false,front);
  frame->Terminal("7",7,0,0,false,front);

  co.AddObject(frame,"frame",0,0,0);
  co.AddObject(p[0],"csip0","i","frame.0");
  co.AddObject(p[1],"csip1","i","frame.1");
  co.AddObject(p[2],"csip2","i","frame.2");
  co.AddObject(p[3],"csip3","i","frame.3");
  co.AddObject(p[4],"csip4","i","frame.4");
  co.AddObject(p[5],"csip5","i","frame.5");
  co.AddObject(p[6],"csip6","i","frame.6");
  co.AddObject(p[7],"csip7","i","frame.7");
}


#endif
