void Selector(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{del {w n}} {del {w n}} {del {w n}} {del {f n}} {del {e n}} {del {e n}} {nor {f n}}");
  bo.String("{del {f n}} {del {e n}} {del {e n}} {nul {n e}} {del {w n}} {del {w n}} {del {f n}}");
  bo.String("{del {f n}} {ufs {e f}} {del {f n}} {nul {n e}} {del {f n}} {ufs {w f}} {del {f n}}");
  bo.String("{nor {e n} fns} {fus {e b} fwbns} {sli {f e} bns} {sli {f w} bns} {fus {w b} bns} {nul {n e}} {nor {w n}}");
  bo.String("{nul {n e}} {nul {n e}} {del {s e} wns} {del {s e} ns} {nul {n e}} {nul {n e}} {nul {n e}}");

  bo.SetOutputs(6,0,0,true);
  bo.SetOutputs(6,0,1,true);
  bo.SetOutputs(5,0,1,true);
  bo.SetOutputs(4,0,1,true);
  bo.SetOutputs(4,0,2,true);
  bo.SetOutputs(6,0,2,true);
  bo.SetOutputs(1,0,3,true);

  bo.Terminal("i",3,0,0,true,back);

  bo.Terminal("a",3,0,4,true,front);

  bo.Terminal("amb",2,0,4,true,north); // attachment for joining memory bank selector
}

void SelectorTop(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{del {b e}} {del {e n}} {del {e n}} {del {e n}} {del {e n}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{del {b e}} {nul {n e}} {del {b e}} {del {e n}} {del {e n}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{del {b e}} {nul {n e}} {del {b e}} {nul {n e}} {del {w n}} {del {w n}} {del {w n}} {nor {w n}} {nor {w n}}");
  bo.String("{del {b e}} {nul {n e}} {del {b e}} {nul {n e}} {del {w n}} {del {w n}} {del {b n}} {nul {n e}} {del {b e}}");
  bo.String("{del {b e}} {nul {n e}} {del {b e}} {nul {n e}} {del {b e}} {nul {n e}} {del {b n}} {nul {n e}} {del {b e}}");

  bo.SetOutputs(8,0,2,true);

  bo.Terminal("i0",0,0,3,true,front);
  bo.Terminal("i1",2,0,3,true,front);
  bo.Terminal("i2",4,0,3,true,front);
  bo.Terminal("i3",6,0,3,true,front);
  bo.Terminal("i4",8,0,3,true,front);

  bo.Terminal("o0",4,0,0,false,south);
  bo.Terminal("o1",4,0,1,false,south);
  bo.Terminal("o2",4,0,2,false,south);
  bo.Terminal("o3",4,0,3,false,south);
  bo.Terminal("o4",4,0,4,false,south);
}

#if 0
void MemBankSelector(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {del {b e}} {del {e n}} {del {e n}} {del {e n}} {del {e n}}");
  bo.String("{del {b e}} {del {e n}} {del {e n}} {del {e n}} {ufs {e f} f} {del {f n}} {fus {w f}} {del {f n}}");
  bo.String("{del {b e}} {nul {n e}} {nul {n e}} {nul {n e}} {sli {f w} b} {sli {f e} ns} {nul {n e}} {nul {n e}}");
  bo.String("{del {b e} f} {nul {n e}} {nul {n e}} {nul {n e}} {del {b n} ns} {del {b n} ns} {nul {n e}} {nul {n e}}");

  bo.Terminal("a",5,0,3,true,front);
  bo.Terminal("amb",4,0,3,false,south);
  bo.Terminal("i",3,0,1,true,west);
}
#endif

void DecoderLine(CBasicObject &bo, unsigned p, unsigned m,bool signal)
{
  std::string tmp;

  for(unsigned j = 0; j<p; j++)
  {
    {for(unsigned i = 0; i<m; i++)
    {
      if (!signal)
        tmp += "{del {b e} fbns}";
      else
        tmp += "{nor {b e} fbs b}";

      tmp += " {del {n e} fbs} {del {n e} fbs} {del {n e} fbs} {del {n e} fbs}";

      if (i!=m-1) tmp += " {del {n e} fbs}";
    }}

    {for(unsigned i = 0; i<m; i++)
    {
      if (!signal)
        tmp += "{del {b e} fbs}";
      else
        tmp += "{nor {b e} fbs b}";

      if (i!=m-1 || j!=p-1) tmp += " {del {n e} fbs} {del {n e} fbs} {del {n e} fbs} {del {n e} fbs} {del {n e} fbs}";
    }}

    if (j != p-1) tmp += "{del {n e} fbs}";
  }

  bo.Layer();
  bo.String(tmp.c_str());

  bo.Terminal("a",11,0,0,false,north);

  std::string outputstring = "oa";

  {for(unsigned i = 0; i<16; i++)
  {
    outputstring[1] = (char)('a'+i);

    bo.Terminal(outputstring.c_str(),i*6,0,0,false,back);    
  }}

}

void Decoder4To16(CCompoundObject &co)
{
  CBasicObject *s0 = new CBasicObject;
  CBasicObject *s1 = new CBasicObject;
  CBasicObject *s2 = new CBasicObject;
  CBasicObject *s3 = new CBasicObject;
  CBasicObject *s4 = new CBasicObject;
  CBasicObject *st = new CBasicObject;

  CBasicObject *dl0 = new CBasicObject;
  CBasicObject *dl1 = new CBasicObject;
  CBasicObject *dl2 = new CBasicObject;
  CBasicObject *dl3 = new CBasicObject; 
  CBasicObject *dl4 = new CBasicObject;

  Selector(*s0);
  Selector(*s1);
  Selector(*s2);
  Selector(*s3);
  Selector(*s4);
  SelectorTop(*st);

  DecoderLine(*dl0,16,1,false);
  DecoderLine(*dl1,8,2,false);
  DecoderLine(*dl2,1,16,false);
  DecoderLine(*dl3,2,8,false);
  DecoderLine(*dl4,4,4,true);

  s0->Rotate(west);
  s1->Rotate(west);
  s2->Rotate(west);
  s3->Rotate(west);
  s4->Rotate(west);

  co.AddObject(st,"st",0,0,0);
  co.AddObject(s0,"s0","i","st.o0");
  co.AddObject(s1,"s1","i","st.o1");
  co.AddObject(s2,"s2","i","st.o2");
  co.AddObject(s3,"s3","i","st.o3");
  co.AddObject(s4,"s4","i","st.o4");
  co.AddObject(dl0,"dl0","a","s0.a");
  co.AddObject(dl1,"dl1","a","s1.a");
  co.AddObject(dl2,"dl2","a","s2.a");
  co.AddObject(dl3,"dl3","a","s3.a");
  co.AddObject(dl4,"dl4","a","s4.a");

  std::string aliasstring = "oa";
  std::string terminalstring = "dl0.oa";

  {for(unsigned i = 0; i<16; i++)
  {
    aliasstring[1] = (char)('a'+i);
    terminalstring[5] = (char)('a'+i);

    co.Terminal(aliasstring.c_str(),terminalstring.c_str());    
  }}

}