#include <string>
#include "serialdecoder.cpp"

void TestTrack(CBasicObject &bo, bool westoffull)
{
  bo.Layer();
  bo.String("{nul {n e}} {del {b n}} {del {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {del {b n}} {sli {e f}} {nul {n e}}");
  bo.String("{nul {n e}} {del {b n}} {sli {e f}} {nul {n e}}");
  bo.String("{nul {n e}} {del {b n}} {sli {e f}} {nul {n e}}");
  bo.String("{nul {n e}} {del {b n}} {sli {e f}} {nul {n e}}");
  bo.String("{nul {n e}} {del {b n}} {sli {e f}} {nul {n e}}");
  bo.String("{nul {n e}} {del {b n}} {sli {e f}} {nul {n e}}");
  bo.String("{nul {n e}} {del {b n}} {sli {e f}} {nul {n e}}");
  bo.String("{nul {n e}} {del {b n}} {sli {e f}} {nul {n e}}");
  bo.String("{nul {n e}} {del {b n}} {sli {e f}} {nul {n e}}");
  bo.String("{nul {n e}} {del {b n}} {sli {e f}} {nul {n e}}");
  bo.String("{nul {n e}} {del {b n}} {sli {e f}} {nul {n e}}");
  bo.String("{nul {n e}} {del {b n}} {sli {e f}} {nul {n e}}");
  bo.String("{nul {n e}} {del {b n}} {sli {e f}} {nul {n e}}");
  bo.String("{del {n e}} {del {b n} f} {sli {e f} f} {nul {n e}}");
  bo.String("{del {n e} e} {nul {n e}} {nul {n e}} {nul {n e}}");

  // deal with the signal path for the full signal
  if (!westoffull)
    bo.String("{del {w n}} {del {b e} b} {del {f e} b} {nor {e n} e e}");
  else
    bo.String("{del {b e}} {del {e n} b} {del {f e} b} {nor {e n} e e}");

  for(unsigned i = 1; i<15; i++)
    bo.SetOutputs(1,0,i,true);

  bo.Terminal("i",1,0,14,true,front);
  bo.Terminal("a",2,0,0,true,back);
  bo.Terminal("o",1,0,12,false,south);
  bo.Terminal("c",0,0,15,true,east);
  bo.Terminal("d",0,0,14,true,north);
  bo.Terminal("rj",2,0,16,false,north);
}

// This attaches to TestTrack and deals with getting rid of unwanted parts
// when the hopper is full.
void RejectPath(CBasicObject &bo, unsigned l)
{
  std::string tmps[4];

  tmps[0] = "{sli {n w} wfbn} {sli {n w} fbn} {sli {n w} efbn}";
  tmps[1] = "{nor {n w} wfbs n} {nor {n w} fbs n} {nor {n w} efb n}";
  tmps[2] = "{nul {n e}} {nul {n e}} {del {e n} ewfb}";
  tmps[3] = "{nul {n e}} {nul {n e}} {del {e n} wsfb}";

  {for(unsigned i = 0; i<l; i++)
  {
    tmps[0] += "{nul {n e}}";
    tmps[1] += "{nul {n e}}";
    tmps[2] += "{nul {n e}}";
    tmps[3] += "{del {e n} nsfb}";
  }}

  bo.Layer();
  bo.String(tmps[3].c_str());
  bo.Layer();
  bo.String(tmps[2].c_str());
  bo.Layer();
  bo.String(tmps[1].c_str());
  bo.Layer();
  bo.String(tmps[0].c_str());

  bo.Terminal("rj",2+l,0,0,false,east);
}

void BottomStopper(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{del {b n} wens}");
  bo.String("{del {s e} wens}");
  bo.String("{del {b n} wens}");
  bo.String("{del {b n} wens}");
  bo.String("{del {b n} wens}");
  bo.String("{del {b n} wens}");
  bo.String("{del {b n} n}");

  bo.Terminal("d",0,0,6,false,south);
}

// When increasing or decreasing the maximum capacity of the hoppers, the numbers here need to be changed, nothing
// else needs to be done for the dispenser.
void Track2(CBasicObject &bo,unsigned z,unsigned fullz)
{
  bo.Layer();
  bo.String("{del {n e}} {sli {e b}}");
  bo.String("{del {f n}} {sli {e b}}");
  bo.String("{del {f n}} {sli {e b}}");
  bo.String("{del {f n}} {sli {e b}}");
  bo.String("{del {f n}} {sli {e b}}");
  bo.String("{del {f n}} {sli {e b}}");
  bo.String("{del {f n}} {sli {e b}}");
  bo.String("{del {f n}} {sli {e b}}");
  bo.String("{del {f n}} {sli {e b}}");
  bo.String("{del {f n}} {sli {e b}}");
  bo.String("{del {f n}} {sli {e b}}");
  bo.String("{del {f n}} {sli {e b}}");
  bo.String("{del {f n}} {sli {e b}}");
  bo.String("{del {f n}} {sli {e b}}");
  bo.String("{del {f n}} {sli {e b}}");
  bo.String("{del {f n}} {sli {e b}}");
  bo.String("{del {f n}} {sli {e b}}");
  bo.String("{del {f n}} {sli {e b}}");

  for(unsigned i = 0; i<18; i++)
    bo.SetOutputs(0,0,i,true);

  bo.Terminal("i",0,0,0,true,south);
  bo.Terminal("c",0,0,17-z,false,west);
  bo.Terminal("a",0,-1,17-fullz,true,south);
  bo.Terminal("f",0,0,17,false,front);

  // This special terminal is away from the track and is used for the full
  // signal path which signals back to the hopper adder
  bo.Terminal("fsp",2,-1,17-fullz,false,east);
}

void Stopper(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{del {w n} b} {del {w n} b} {nor {w n} b}");
  bo.String("{nul {n e}} {nul {n e}} {del {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {del {n e}}");

  bo.Terminal("a",2,0,2,false,front);

  bo.SetOutputs(0,0,0,true);
  bo.SetOutputs(1,0,0,true);
  bo.SetOutputs(2,0,0,true);
}

void DispenserPart(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nor {f n}} {nor {w n} e w} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {del {f e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nor {e n} e e} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.Layer();
  bo.String("{nul {n e}} {nul {n e}} {del {b e}} {del {e n}} {del {e n}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {del {b e}} {sli {b w}} {nor {n e} x w} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {del {b e}} {del {n e} s} {del {e n}} {nor {n e} e n}");
  bo.String("{nul {n e}} {nul {n e}} {del {w n}} {del {b e}} {del {n e}} {del {b e} e}");
  bo.String("{del {n e}} {sli {w b}} {del {f e}} {del {b e}} {del {f e}} {del {e n} e}");
  bo.String("{nul {n e}} {nul {n e}} {nul {w n}} {del {w n} f} {del {f e} f} {nul {n e}}");
  bo.Layer();
  bo.String("{nul {n e}} {nul {n e}} {del {w n} n} {del {w n} n} {nul {n e} n} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {del {f n} n} {del {e n} n} {nor {f e} wn} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {del {w n} n} {del {f n} n} {fus {f n} n} {ufs {n f} ne}");
  bo.String("{nul {n e}} {nul {n e}} {del {f n} n} {del {e n} n} {ufs {n e}} {sli {n e} ne}");
  bo.String("{nul {n e}} {nul {n e}} {del {w n} n} {del {f n} n} {ufs {b n} n} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {del {f n} fn} {sli {e f} fn} {del {n e} fn} {nul {n e}}");

  bo.Terminal("i",4,1,3,true,south);
  bo.Terminal("j",5,2,3,true,north);
}

void DecoderDispGap(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{del {n e}}");

  bo.Terminal("i",0,0,0,true,south);
  bo.Terminal("o",0,0,0,true,north);
}

void DecoderInput(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {del {e n} w}");
  bo.String("{nul {n e}} {nul {n e}} {del {n e} bn} {del {f n}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {del {f n}}");
  bo.String("{nul {n e}} {nul {n e}} {nor {w n}} {del {f n}}");

  bo.SetOutputs(3,0,3,true);
  bo.SetOutputs(3,0,2,true);
  bo.SetOutputs(3,0,1,true);
  bo.SetOutputs(3,0,0,true);

  bo.Terminal("i",3,0,0,true,west);
  bo.Terminal("o",2,0,3,false,west);
}

// z specifies how far back the dispenser head is (measured from the minimum
// position)
void Dispenser(CCompoundObject &co, bool b1, bool b2, bool b3, unsigned z, unsigned fullz, bool westoffull)
{
  CBasicObject *track,*rp,*stop,*botstop,*disp;
  CBasicObject *sdec,*ddg,*deci;
  CBasicObject *track2;

  track = new CBasicObject();
  rp = new CBasicObject();
  stop = new CBasicObject();
  botstop = new CBasicObject();
  disp = new CBasicObject();
  sdec = new CBasicObject();
  ddg = new CBasicObject();
  deci = new CBasicObject();
  track2 = new CBasicObject();

  TestTrack(*track,westoffull);
  RejectPath(*rp,fullz+2);
  Stopper(*stop);
  BottomStopper(*botstop);
  DispenserPart(*disp);
  SerialDecoderCompact(*sdec,b1,b2,b3);
  DecoderDispGap(*ddg);
  DecoderInput(*deci);
  Track2(*track2,z,fullz);

  track->Rotate(back);
  rp->Rotate(east);
  botstop->Rotate(back);
  sdec->Rotate(back);
  deci->Rotate(west);
  track2->Rotate(back);
  track2->Rotate(north);

  co.AddObject(track,"track",0,0,0);
  co.AddObject(rp,"rp","rj","track.rj");
  co.AddObject(stop,"stop","a","track.a");
  co.AddObject(botstop,"botstop","d","track.d");
  co.AddObject(deci,"deci","i","track.o");
  co.AddObject(sdec,"sdec","i","deci.o");
  co.AddObject(ddg,"ddg","i","sdec.o");
  co.AddObject(disp,"disp","i","ddg.o");
  co.AddObject(track2,"track2","c","track.c");

  co.Terminal("j","disp.j");
  co.Terminal("i","track2.i");
}
