#ifndef GATES_CPP
#define GATES_CPP

// This gate should not be used where it is necessary to keep
// parallel signal-fronts in step with each other.
void NXorGate(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{nul {n e}}     {nor {e n}}         {del {e n}} {del {e n}}");
  bo.String("{nor {e n} x e} {del {e n} x nesfb} {nul {e n}} {nor {e n} x e}");
  bo.String("{nul {n e}}     {nor {e n}}         {del {e n}} {del {e n}}");

  bo.Terminal("a",1,0,0,true,west);
  bo.Terminal("b",1,0,2,true,west);
  bo.Terminal("o",3,0,1,false,east);
}

void NXorGateInStep(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{del {b e}} {del {e n}} {del {e n}} {nul {n e}} {nul {n e}}");
  bo.String("{del {e n}} {nul {n e}} {nor {e n}} {del {e n}} {del {e n}}");
  bo.String("{nor {e n}} {del {e n}} {del {e n}} {nul {e n}} {nor {e n}}");
  bo.String("{del {e n}} {nul {n e}} {nor {e n}} {del {e n}} {del {e n}}");
  bo.String("{del {f e}} {del {e n}} {del {e n}} {nul {n e}} {nul {n e}}");

  bo.SetOutputs(1,0,2,true);
  bo.SetOutputs(2,0,2,true);
  bo.SetOutputs(4,0,2,true);

  bo.Terminal("a",0,0,1,true,west);
  bo.Terminal("b",0,0,3,true,west);
  bo.Terminal("o",4,0,2,false,east);
}

void NXorGateInStep0(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{del {b e}} {del {e n}} {del {e n}} {nul {n e}} {nul {n e}}");
  bo.String("{del {e n}} {nul {n e}} {nor {e n}} {del {e n}} {del {e n}}");
  bo.String("{nor {e n}} {del {e n}} {del {e n}} {nul {e n}} {nor {e n}}");
  bo.String("{del {e n}} {nul {n e}} {nor {e n}} {del {e n}} {del {e n}}");
  bo.String("{del {f e}} {del {e n}} {del {e n}} {nul {n e}} {nul {n e}}");

  bo.SetOutputs(0,0,1,true);
  bo.SetOutputs(0,0,0,true);
  bo.SetOutputs(1,0,0,true);
  bo.SetOutputs(2,0,0,true);
  bo.SetOutputs(2,0,3,true);
  bo.SetOutputs(3,0,3,true);
  bo.SetOutputs(4,0,3,true);

  bo.Terminal("a",0,0,1,true,west);
  bo.Terminal("b",0,0,3,true,west);
  bo.Terminal("o",4,0,2,false,east);
}

#endif
