#include "dispenser.cpp"
#include "signalpath.cpp"

void HopperFeed(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{nor {n e} n n} {nor {f e} n f} {del {f e} n} {sli {e f} n}");
  bo.String("{nul {n e}}     {del {f e} n neswf} {nor {e n} n} {sli {e f} n}");
  bo.String("{nul {n e}}     {del {f e} n neswf} {nor {e n} n} {sli {e f} n}");
  bo.String("{nul {n e}}     {del {f e} n neswf} {nor {e n} n} {sli {e f} n}");
  bo.String("{nul {n e}}     {del {f e} n neswf} {nor {e n} n} {sli {e f} n}");
  bo.String("{nul {n e}}     {del {f e} n neswf} {nor {e n} n} {sli {e f} n}");
  bo.String("{nul {n e}}     {del {f e} n neswf} {nor {e n} n} {sli {e f} n}");
  bo.String("{nul {n e}}     {del {f e} n neswf} {nor {e n} n} {sli {e f} n}");
  bo.String("{nul {n e}}     {del {f e} n neswf} {nor {e n} n} {sli {e f} n}");
  bo.String("{nul {n e}}     {del {f e} n neswf} {nor {e n} n} {sli {e f} n}");
  bo.String("{nul {n e}}     {del {f e} n neswf} {nor {e n} n} {sli {e f} n}");
  bo.String("{nul {n e}}     {del {f e} n neswf} {nor {e n} n} {sli {e f} n}");
  bo.String("{nul {n e}}     {del {f e} n neswf} {nor {e n} n} {sli {e f} x}");
  bo.String("{nul {n e}}     {del {f e} n neswf} {nor {e n} n} {sli {e f} n}");
  bo.String("{nul {n e}}     {del {f e} n neswf} {nor {e n} n} {sli {e s} n}");

  bo.Terminal("i",2,0,0,true,back);

  bo.Terminal("a",3,0,14,false,front);

  bo.Terminal("hasp",0,0,10,true,north);
}

// z specifies the number of extra columns of parts (above the minimum)
// that are present.
// numnor specifies the number of dummy nor parts to put into the hopper.
void ExistingParts(CBasicObject &bo, char *part, unsigned z, unsigned numnor)
{
  char tmps[16];

  sprintf(tmps,"{%s {s f}}",part);

  for(unsigned j = 0; j<12; j++)
  {
    bo.Layer();
    {for(unsigned i = 0; i<z; i++)
    {
      if (i*12 + j < numnor)
        bo.String("{nor {s f}}");
      else
        bo.String(tmps);
    }}
    bo.String(tmps);

    if (j<2)
      bo.String(tmps);
    else
      bo.String("{nul {n e}}");
  }

  bo.Terminal("c",0,0,z,false,south);
  bo.Terminal("j",0,0,0,false,west);
}

void HopperFeedEnd(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {del {b n}} {nul {n e}} {nul {e n}} {nul {e n}}");
  bo.String("{nul {n e}} {nul {n e}} {del {b n}} {nul {b n}} {nul {n e}} {nul {n e}}");
  bo.String("{del {e n} n} {del {e n} n} {del {e n} n} {nul {b n}} {nul {n e}} {nul {n e}}");
  bo.Layer();
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {del {n e}} {del {e n}} {del {e n}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {f n}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {f n}} {nul {n e}}");
  bo.Layer();
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {del {n e}} {del {n e}} {ufs {e n} n} {sli {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {fus {b n}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {n e}} {nul {n e}}");
  bo.Layer();
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nor {w n} w w} {nul {n e}}");
  bo.Layer();
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nor {w n} w w} {nul {n e}}");

  bo.Terminal("a",1,2,2,true,north);
  bo.Terminal("c",4,2,2,true,north);
}

void HopperAdder(CBasicObject &bo)
{                
  bo.Layer();
  bo.String("{del {n e}} {nul {n e}} {nul {n e}} {nor {f n} s} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {ufs {f s} s} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nor {n e} sf} {nor {s e} s} {del {n e}} {sli {s e} s} {fus {s e} se}");
  bo.String("{nul {n e}} {nul {n e}} {del {e n} sw} {fus {b s} s} {nul {n e}} {fus {s f} se}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nor {b n} s} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");

  bo.Layer();
  bo.String("{del {n e}} {del {e n}} {del {e n}} {nor {s e} x s} {nul {n e}} {nul {n e}}");
  bo.String("{del {w n}} {del {w n}} {del {f e}} {del {b e}} {del {e n}} {del {e n} e}");
  bo.String("{del {f n}} {del {n e}} {del {e n}} {del {e n}} {del {e n}} {del {f e} e}");
  bo.String("{del {f n}} {sli {w b} s} {del {w n}} {del {w n}} {del {f n}} {nor {s e} e s}");
  bo.String("{del {f n}} {del {e n} s} {sli {e f}} {nor {s e} x s} {del {f n}} {nul {n e}}");
  bo.String("{nul {n e}} {del {f n} es} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");

  bo.Terminal("hasp",0,0,0,false,south);
}

void HopperFullPath(CCompoundObject &co, unsigned fullz)
{
  CBasicObject *path = new CBasicObject;
  CBasicObject *orgate = new CBasicObject;

  orgate->Layer();
  orgate->String("{nor {w n}} {nor {w n} x w}");
  orgate->Terminal("o",0,0,0,false,west);
  orgate->Terminal("i",1,0,0,true,south);

  SignalPath(*path,fullz+5,1,4,north,west,back,east,back);

  co.AddObject(path,"path",0,0,0);
  co.AddObject(orgate,"orgate","o","path.i");

  co.Terminal("i","orgate.i");
  co.Terminal("o","path.o");
}

// Make a hopper for the specified part, which will dispense it when
// the signal encoded by b1, b2, b3 is sent up the signal wire.
// z specifies the number of columns of parts, in addition to the minimum
// required for operation.
void Hopper(CCompoundObject &co, char *part, bool b1, bool b2, bool b3, unsigned z, unsigned numnor, unsigned fullz, bool westoffull)
{
  CBasicObject *hf,*hfe;
  CBasicObject *ha;
  CBasicObject *ep;
  CCompoundObject *hfp;
  CCompoundObject *disp;

  hf = new CBasicObject();
  hfe = new CBasicObject();
  ha = new CBasicObject();
  ep = new CBasicObject();
  disp = new CCompoundObject();
  hfp = new CCompoundObject();

  HopperFeed(*hf);
  HopperFeedEnd(*hfe);
  HopperAdder(*ha);
  ExistingParts(*ep,part,z,numnor);
  Dispenser(*disp,b1,b2,b3,z,fullz,westoffull);
  HopperFullPath(*hfp,fullz);

  hf->Rotate(front);
  hf->Rotate(west);
  hfe->Rotate(east);
  hfe->Rotate(front);
  hfe->Rotate(west);
  ha->Rotate(front);
  ha->Rotate(west);
  hfp->Rotate(front);
  hfp->Rotate(west);
  disp->Rotate(west);
  disp->Rotate(south);

  co.AddObject(hf,"hf",0,0,0);
  co.AddObject(hfe,"hfe","a","hf.a");
  co.AddObject(ha,"ha","hasp","hf.hasp");
  co.AddObject(ep,"ep","c","hfe.c");
  co.AddObject(disp,"disp","j","ep.j");
  co.AddObject(hfp,"hfp","i","disp.track2.fsp");

  co.Terminal("i","hf.i");
}
