#include "pulsegen.cpp"

void InhibitGateWest(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{nor {w n}} {nor {w n} x w}");

  bo.Terminal("i",1,0,0,true,east);
  bo.Terminal("i2",1,0,0,true,south);
  bo.Terminal("o",0,0,0,false,west);
  bo.Terminal("g",0,0,0,true,front);
}

void InhibitGateBack(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{nor {b n}}");
  bo.String("{nor {b n} x b}");

  bo.Terminal("i",0,0,1,true,front);
  bo.Terminal("i2",0,0,1,true,south);
  bo.Terminal("o",0,0,0,false,back);
  bo.Terminal("g",0,0,0,true,east);
}

void InhibitLineWest(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{del {s e}}");
  bo.Layer();
  bo.String("{del {w n}}");

  for(unsigned i = 0; i<3; i++)
  {
    bo.Layer();
    bo.String("{del {n e}}");
  }


  bo.Terminal("i",0,1,0,true,east);
  bo.Terminal("o0",0,4,0,false,back);
  bo.Terminal("o1",0,0,0,false,back);
 
}

void InhibitLineFront(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {n e}}");

  bo.Terminal("i",9,0,0,true,south);
  bo.Terminal("o",0,0,0,false,west);
  bo.Terminal("j",9,0,0,false,back);
  bo.Terminal("oe",9,0,0,false,east);
}

void InhibitLineEast(CBasicObject &bo)
{
  bo.Layer();
  for(unsigned i = 0; i<9; i++)
  {
    bo.String("{del {b e}}");
  }

  bo.Terminal("o",0,0,0,false,back);
  bo.Terminal("j",0,0,8,true,front);
}

void InhibitLineBack(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{del {s e}}");
  bo.Layer();
  bo.String("{del {b n}}");

  for(unsigned i = 0; i<3; i++)
  {
    bo.Layer();
    bo.String("{del {n e}}");
  }

  bo.Terminal("i",0,1,0,true,front);
  bo.Terminal("o0",0,4,0,false,east);
  bo.Terminal("o1",0,0,0,false,east);
 
}

void InhibitLogic(CCompoundObject &co)
{
  CBasicObject *inhibitff = new CBasicObject();
  CBasicObject *setpulse = new CBasicObject();
  CBasicObject *setor = new CBasicObject();

  inhibitff->Layer();
  inhibitff->String("{nor {f e}} {del {b e}} {del {e n}}");
  inhibitff->String("{nor {e n}} {nor {b e}} {nor {w n}}");
  inhibitff->String("{nor {b e}} {nul {n e}} {nul {n e}}");

  inhibitff->SetOutputs(0,0,0,true);
  inhibitff->SetOutputs(2,0,1,true);
  inhibitff->SetOutputs(0,0,2,true);

  inhibitff->Terminal("o",1,0,0,false,north);
  inhibitff->Terminal("r",0,0,2,true,north);
  inhibitff->Terminal("s",2,0,1,true,east);

  PulseGen(*setpulse);
  setpulse->Rotate(back);
  setpulse->Rotate(back);

  setor->Layer();
  setor->String("{nor {w n}} {nor {w n}}");
  setor->SetOutputs(1,0,0,true);
  setor->Terminal("o",0,0,0,false,west);
  setor->Terminal("ie",1,0,0,true,east);
  setor->Terminal("is",1,0,0,true,south);

  co.AddObject(inhibitff,"inhibitff",0,0,0);
  co.AddObject(setpulse,"setpulse","o2","inhibitff.s");
  co.AddObject(setor,"setor","o","setpulse.i");
}

