// lowest six bits of d determine the value to decode, with bit 0 being
// the bit that is always 1 - i.e. the gated read signal
void InstructionDecode(CBasicObject &bo, unsigned d)
{
  bo.Layer();
  bo.String("{del {w n}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");

  if (d&0x00000020)
    bo.String("{nor {f n}} {nul {n e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  else
    bo.String("{del {f n}} {nul {n e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");

  if (d&0x00000010)
    bo.String("{nor {f e}} {nor {w n}} {del {f e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  else
    bo.String("{nor {f e}} {del {w n}} {del {f e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}}");


  bo.String("{nor {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {s e}} {nul {n e}} {nul {n e}}");
  bo.String("{nor {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {w n}} {del {s e}} {nul {n e}}");

  if (d&0x00000002)
    bo.String("{nor {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {nor {f n}} {nul {n e}} {del {s e}}");
  else
    bo.String("{nor {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {f n}} {nul {n e}} {del {s e}}");

  if (d&0x00000001)
    bo.String("{nor {w n}} {del {w n}} {del {w n}} {nor {w n}} {nor {w n}} {nor {w n}} {del {f n}}");
  else
    bo.String("{nor {w n}} {del {w n}} {del {w n}} {nor {w n}} {nor {w n}} {del {w n}} {del {f n}}");

  bo.Layer();
  bo.String("{nul {n e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {del {w n}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}}");

  if (d&0x00000008)
    bo.String("{nul {n e}} {nul {n e}} {nor {f n}} {nul {n e}} {del {s e}} {nul {n e}} {nul {n e}}");
  else
    bo.String("{nul {n e}} {nul {n e}} {del {f n}} {nul {n e}} {del {s e}} {nul {n e}} {nul {n e}}");

  if (d&0x00000004)
    bo.String("{del {w n}} {nor {w n}} {nor {w n}} {nor {w n}} {del {f n}} {del {s e}} {nul {n e}}");
  else
    bo.String("{del {w n}} {nor {w n}} {nor {w n}} {del {w n}} {del {f n}} {del {s e}} {nul {n e}}");

  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {s e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");

  bo.Terminal("i4",1,1,0,true,north);
  bo.Terminal("i3",2,1,1,true,north);
  bo.Terminal("i2",3,1,2,true,north);
  bo.Terminal("i1",4,1,3,true,north);
  bo.Terminal("i0",5,1,4,true,north);
  bo.Terminal("ig",6,1,5,true,north);

  bo.Terminal("o4",1,0,0,false,south);
  bo.Terminal("o3",2,0,1,false,south);
  bo.Terminal("o2",3,0,2,false,south);
  bo.Terminal("o1",4,0,3,false,south);
  bo.Terminal("o0",5,0,4,false,south);
  bo.Terminal("og",6,0,5,false,south);

  bo.Terminal("d",0,0,6,false,west);

  bool x,y,z,u,v,w,s,t,r;

  x = d&0x00000020;
  y = d&0x00000010;
  z = !(x||y);
  v = d&0x00000008;
  w = d&0x00000004;
  u = !(v||w);
  s = d&0x00000002;
  t = d&0x00000001;
  r = !(s||t);

  bo.SetOutputs(0,0,1,x);
  bo.SetOutputs(1,0,2,y);
  bo.SetOutputs(0,0,2,z);
  bo.SetOutputs(0,0,3,!z);
  bo.SetOutputs(0,0,4,z&&u);
  bo.SetOutputs(0,0,5,!(z&&u));
  bo.SetOutputs(2,1,3,v);
  bo.SetOutputs(3,1,4,w);
  bo.SetOutputs(2,1,4,u);
  bo.SetOutputs(1,1,4,!u);
  bo.SetOutputs(0,1,4,!u);
  bo.SetOutputs(4,0,5,s);
  bo.SetOutputs(5,0,6,t);
  bo.SetOutputs(4,0,6,r);
  bo.SetOutputs(3,0,6,!r);
  bo.SetOutputs(2,0,6,!r);
  bo.SetOutputs(1,0,6,!r);
  bo.SetOutputs(0,0,6,z&&u&&r);
}

// lowest six bits of da,db determine the value to decode, with bit 0 being
// the bit that is always 1 - i.e. the gated read signal
// da is for the west,front decoder, db is for the other
//
// You can also specify which direction the output nor should point in

void InstructionDecodePair(CBasicObject &bo, unsigned da, unsigned db, Direction ora, Direction orb)
{
  bo.Layer();
  bo.String("{nul {n e}} {del {b n}} {del {e n}} {nor {e n}} {nor {e n}} {nor {e n}} {nor {e n}} {nor {b n}}");
  bo.String("{del {w n}} {del {s e}} {nul {n e}} {del {b n}} {nul {n e}} {nul {n e}} {nul {n e}} {del {b n}}");
  bo.String("{del {f n}} {nul {n e}} {del {s e}} {del {e n}} {nul {n e}} {nul {n e}} {nul {n e}} {del {b n}}");
  bo.String("{nor {f e}} {del {w n}} {del {f e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nor {b n}}");
  bo.String("{nor {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {s e}} {del {b n}} {del {e n}} {nor {b n}}");
  bo.String("{nor {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {w n}} {del {s e}} {nul {n e}} {del {b n}}");
  bo.String("{nor {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {f n}} {nul {n e}} {del {s e}} {del {e n}}");
  bo.String("{nor {w n}} {del {w n}} {del {w n}} {nor {w n}} {nor {w n}} {del {w n}} {del {f n}} {nul {n e}}");

  bo.Layer();
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {b n}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nor {b n}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {del {s e}} {del {b n}} {del {e n}} {nor {b n}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {del {w n}} {del {s e}} {nul {n e}} {del {b n}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {del {f n}} {nul {n e}} {del {s e}} {del {e n}} {nul {n e}} {nul {n e}}");
  bo.String("{del {w n}} {nor {w n}} {nor {w n}} {del {w n}} {del {f n}} {del {s e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {s e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");

  if (da & 0x00000020)
    bo.cells[0][2][0].part = nor;
  if (da & 0x00000010)
    bo.cells[0][3][1].part = nor;
  if (da & 0x00000002)
    bo.cells[0][6][4].part = nor;
  if (da & 0x00000001)
    bo.cells[0][7][5].part = nor;
  if (da & 0x00000008)
    bo.cells[1][4][2].part = nor;
  if (da & 0x00000004)
    bo.cells[1][5][3].part = nor;

  if (db & 0x00000020)
    bo.cells[0][0][2].part = nor;
  if (db & 0x00000010)
    bo.cells[0][1][3].part = nor;
  if (db & 0x00000002)
    bo.cells[0][4][6].part = nor;
  if (db & 0x00000001)
    bo.cells[0][5][7].part = nor;
  if (db & 0x00000008)
    bo.cells[1][2][4].part = nor;
  if (db & 0x00000004)
    bo.cells[1][3][5].part = nor;

  bo.cells[0][7][0].or1 = ora;
  bo.cells[0][7][0].or2 = ((ora==west)?north:east);

  bo.cells[0][0][7].or1 = orb;
  bo.cells[0][0][7].or2 = ((orb==east)?north:east);

  bo.Terminal("i4",1,1,1,true,north);
  bo.Terminal("i3",2,1,2,true,north);
  bo.Terminal("i2",3,1,3,true,north);
  bo.Terminal("i1",4,1,4,true,north);
  bo.Terminal("i0",5,1,5,true,north);
  bo.Terminal("ig",6,1,6,true,north);

  bo.Terminal("o4",1,0,1,false,south);
  bo.Terminal("o3",2,0,2,false,south);
  bo.Terminal("o2",3,0,3,false,south);
  bo.Terminal("o1",4,0,4,false,south);
  bo.Terminal("o0",5,0,5,false,south);
  bo.Terminal("og",6,0,6,false,south);

  bo.Terminal("da",0,0,7,false,ora);
  bo.Terminal("db",7,0,0,false,orb);

  bool x,y,z,u,v,w,s,t,r;

  x = da&0x00000020;
  y = da&0x00000010;
  z = !(x||y);
  v = da&0x00000008;
  w = da&0x00000004;
  u = !(v||w);
  s = da&0x00000002;
  t = da&0x00000001;
  r = !(s||t);

  bo.SetOutputs(0,0,2,x);
  bo.SetOutputs(1,0,3,y);
  bo.SetOutputs(0,0,3,z);
  bo.SetOutputs(0,0,4,!z);
  bo.SetOutputs(0,0,5,z&&u);
  bo.SetOutputs(0,0,6,!(z&&u));
  bo.SetOutputs(2,1,4,v);
  bo.SetOutputs(3,1,5,w);
  bo.SetOutputs(2,1,5,u);
  bo.SetOutputs(1,1,5,!u);
  bo.SetOutputs(0,1,5,!u);
  bo.SetOutputs(4,0,6,s);
  bo.SetOutputs(5,0,7,t);
  bo.SetOutputs(4,0,7,r);
  bo.SetOutputs(3,0,7,!r);
  bo.SetOutputs(2,0,7,!r);
  bo.SetOutputs(1,0,7,!r);
  bo.SetOutputs(0,0,7,z&&u&&r);

  x = db&0x00000020;
  y = db&0x00000010;
  z = !(x||y);
  v = db&0x00000008;
  w = db&0x00000004;
  u = !(v||w);
  s = db&0x00000002;
  t = db&0x00000001;
  r = !(s||t);

  bo.SetOutputs(2,0,0,x);
  bo.SetOutputs(3,0,1,y);
  bo.SetOutputs(3,0,0,z);
  bo.SetOutputs(4,0,0,!z);
  bo.SetOutputs(5,0,0,z&&u);
  bo.SetOutputs(6,0,0,!(z&&u));
  bo.SetOutputs(4,1,2,v);
  bo.SetOutputs(5,1,3,w);
  bo.SetOutputs(5,1,2,u);
  bo.SetOutputs(5,1,1,!u);
  bo.SetOutputs(5,1,0,!u);
  bo.SetOutputs(6,0,4,s);
  bo.SetOutputs(7,0,5,t);
  bo.SetOutputs(7,0,4,r);
  bo.SetOutputs(7,0,3,!r);
  bo.SetOutputs(7,0,2,!r);
  bo.SetOutputs(7,0,1,!r);
  bo.SetOutputs(7,0,0,z&&u&&r);

}

// This is like the above, but the A decoder serialises b0,b1 and b2
// and the output is always to the west. A serial encoder should be
// attached, and the encoded signal can be decoded with a serial
// decoder.
//
// lowest six bits of da,db determine the value to decode, with bit 0 being
// the bit that is always 1 - i.e. the gated read signal
// da is for the west,front decoder, db is for the other
//
// You can also specify which direction the output nor should point in

void InstructionDecodePairSerialOut(CBasicObject &bo, unsigned da, unsigned db, Direction orb)
{
  bo.Layer();
  bo.String("{nul {n e}} {del {b n}} {del {e n}} {nor {e n}} {nor {e n}} {nor {e n}} {nor {e n}} {nor {b n}}");
  bo.String("{del {w n}} {del {s e}} {nul {n e}} {del {b n}} {nul {n e}} {nul {n e}} {nul {n e}} {del {b n}}");
  bo.String("{del {f n}} {nul {n e}} {del {s e}} {del {e n}} {nul {n e}} {nul {n e}} {nul {n e}} {del {b n}}");
  bo.String("{nor {f e}} {del {w n}} {del {f e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nor {b n}}");
  bo.String("{nor {f e}} {nul {n e}} {del {w n}} {del {f n}} {del {s e}} {del {b n}} {del {e n}} {nor {b n}}");
  bo.String("{del {f e}} {nul {n e}} {nul {n e}} {del {w n}} {del {f n}} {del {s e}} {nul {n e}} {del {b n}}");
  bo.String("{del {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {w n}} {del {f n}} {del {s e}} {del {e n}}");
  bo.String("{nor {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {w n}} {del {f n}} {nul {n e}}");

  bo.Layer();
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {b n}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nor {b n}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {del {s e}} {del {b n}} {del {e n}} {nor {b n}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {del {s e}} {nul {n e}} {del {b n}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nor {f n}} {nor {w n}} {nul {n e}} {del {s e}} {del {e n}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nor {f n}} {nor {b e}} {nor {w n}} {nul {n e}} {del {s e}} {nul {n e}} {nul {n e}}");
  bo.String("{del {w n}} {nor {w n}} {nul {n e}} {del {w n}} {del {n e}} {nul {n e}} {del {s e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");

  if (da & 0x00000020)
    bo.cells[0][2][0].part = nor;
  if (da & 0x00000010)
    bo.cells[0][3][1].part = nor;
  if (da & 0x00000001)
    bo.cells[0][7][3].part = nor;

  if (db & 0x00000020)
    bo.cells[0][0][2].part = nor;
  if (db & 0x00000010)
    bo.cells[0][1][3].part = nor;
  if (db & 0x00000002)
    bo.cells[0][4][6].part = nor;
  if (db & 0x00000001)
    bo.cells[0][5][7].part = nor;
  if (db & 0x00000008)
    bo.cells[1][2][4].part = nor;
  if (db & 0x00000004)
    bo.cells[1][3][5].part = nor;

  bo.cells[0][0][7].or1 = orb;
  bo.cells[0][0][7].or2 = ((orb==east)?north:east);

  bo.Terminal("i4",1,1,1,true,north);
  bo.Terminal("i3",2,1,2,true,north);
  bo.Terminal("i2",3,1,3,true,north);
  bo.Terminal("i1",4,1,4,true,north);
  bo.Terminal("i0",5,1,5,true,north);
  bo.Terminal("ig",6,1,6,true,north);

  bo.Terminal("o4",1,0,1,false,south);
  bo.Terminal("o3",2,0,2,false,south);
  bo.Terminal("o2",3,0,3,false,south);
  bo.Terminal("o1",4,0,4,false,south);
  bo.Terminal("o0",5,0,5,false,south);
  bo.Terminal("og",6,0,6,false,south);

  bo.Terminal("da",0,0,7,false,west);
  bo.Terminal("db",7,0,0,false,orb);
  bo.Terminal("pt",0,1,6,false,west);

  bool x,y,z,u,v,w,s,t,r;

  x = da&0x00000020;
  y = da&0x00000010;
  z = !(x||y);
  t = da&0x00000001;
  r = !t;

  bo.SetOutputs(0,0,2,x);
  bo.SetOutputs(1,0,3,y);
  bo.SetOutputs(0,0,3,z);
  bo.SetOutputs(0,0,4,!z);
  bo.SetOutputs(0,0,5,!z);
  bo.SetOutputs(0,0,6,!z);
  bo.SetOutputs(3,0,7,t);
  bo.SetOutputs(2,0,7,t);
  bo.SetOutputs(1,0,7,t);
  bo.SetOutputs(0,0,7,z&&r);

  bo.SetOutputs(3,1,5,true);
  bo.SetOutputs(2,1,4,true);
  bo.SetOutputs(1,1,5,true);

  x = db&0x00000020;
  y = db&0x00000010;
  z = !(x||y);
  v = db&0x00000008;
  w = db&0x00000004;
  u = !(v||w);
  s = db&0x00000002;
  t = db&0x00000001;
  r = !(s||t);

  bo.SetOutputs(2,0,0,x);
  bo.SetOutputs(3,0,1,y);
  bo.SetOutputs(3,0,0,z);
  bo.SetOutputs(4,0,0,!z);
  bo.SetOutputs(5,0,0,z&&u);
  bo.SetOutputs(6,0,0,!(z&&u));
  bo.SetOutputs(4,1,2,v);
  bo.SetOutputs(5,1,3,w);
  bo.SetOutputs(5,1,2,u);
  bo.SetOutputs(5,1,1,!u);
  bo.SetOutputs(5,1,0,!u);
  bo.SetOutputs(6,0,4,s);
  bo.SetOutputs(7,0,5,t);
  bo.SetOutputs(7,0,4,r);
  bo.SetOutputs(7,0,3,!r);
  bo.SetOutputs(7,0,2,!r);
  bo.SetOutputs(7,0,1,!r);
  bo.SetOutputs(7,0,0,z&&u&&r);

}

// Like InstructionDecodePair, but bits 1 to 3 of db are masked out
// for the call instruction.
// lowest six bits of da,db determine the value to decode, with bit 0 being
// the bit that is always 1 - i.e. the gated read signal
// da is for the west,front decoder, db is for the other
//
// You can also specify which direction the output nor should point in
void InstructionDecodePairCall(CBasicObject &bo, unsigned da, unsigned db, Direction ora, Direction orb)
{
  bo.Layer();
  bo.String("{nul {n e}} {del {b n}} {del {e n}} {nor {e n}} {nor {e n}} {nor {e n}} {nor {e n}} {nor {b n}}");
  bo.String("{del {w n}} {del {s e}} {nul {n e}} {del {b n}} {nul {n e}} {nul {n e}} {nul {n e}} {del {b n}}");
  bo.String("{del {f n}} {nul {n e}} {del {s e}} {del {e n}} {nul {n e}} {nul {n e}} {nul {n e}} {del {b n}}");
  bo.String("{nor {f e}} {del {w n}} {del {f e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {b n}}");
  bo.String("{nor {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {s e}} {nul {n e}} {nul {n e}} {del {b n}}");
  bo.String("{nor {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {w n}} {del {s e}} {nul {n e}} {del {b n}}");
  bo.String("{nor {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {f n}} {nul {n e}} {del {s e}} {del {e n}}");
  bo.String("{nor {w n}} {del {w n}} {del {w n}} {nor {w n}} {nor {w n}} {del {w n}} {del {f n}} {nul {n e}}");

  bo.Layer();
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {del {w n}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {del {f n}} {nul {n e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{del {w n}} {nor {w n}} {nor {w n}} {del {w n}} {del {f n}} {del {s e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {s e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");

  if (da & 0x00000020)
    bo.cells[0][2][0].part = nor;
  if (da & 0x00000010)
    bo.cells[0][3][1].part = nor;
  if (da & 0x00000002)
    bo.cells[0][6][4].part = nor;
  if (da & 0x00000001)
    bo.cells[0][7][5].part = nor;
  if (da & 0x00000008)
    bo.cells[1][4][2].part = nor;
  if (da & 0x00000004)
    bo.cells[1][5][3].part = nor;

  if (db & 0x00000020)
    bo.cells[0][0][2].part = nor;
  if (db & 0x00000010)
    bo.cells[0][1][3].part = nor;
  if (db & 0x00000001)
    bo.cells[0][5][7].part = nor;

  bo.cells[0][7][0].or1 = ora;
  bo.cells[0][7][0].or2 = ((ora==west)?north:east);

  bo.cells[0][0][7].or1 = orb;
  bo.cells[0][0][7].or2 = ((orb==east)?north:east);

  bo.Terminal("i4",1,1,1,true,north);
  bo.Terminal("i3",2,1,2,true,north);
  bo.Terminal("i2",3,1,3,true,north);
  bo.Terminal("i1",4,1,4,true,north);
  bo.Terminal("i0",5,1,5,true,north);
  bo.Terminal("ig",6,1,6,true,north);

  bo.Terminal("o4",1,0,1,false,south);
  bo.Terminal("o3",2,0,2,false,south);
  bo.Terminal("o2",3,0,3,false,south);
  bo.Terminal("o1",4,0,4,false,south);
  bo.Terminal("o0",5,0,5,false,south);
  bo.Terminal("og",6,0,6,false,south);
  bo.Terminal("og2",7,0,6,false,front);

  bo.Terminal("da",0,0,7,false,ora);
  bo.Terminal("db",7,0,0,false,orb);

  bool x,y,z,u,v,w,s,t,r;

  x = da&0x00000020;
  y = da&0x00000010;
  z = !(x||y);
  v = da&0x00000008;
  w = da&0x00000004;
  u = !(v||w);
  s = da&0x00000002;
  t = da&0x00000001;
  r = !(s||t);

  bo.SetOutputs(0,0,2,x);
  bo.SetOutputs(1,0,3,y);
  bo.SetOutputs(0,0,3,z);
  bo.SetOutputs(0,0,4,!z);
  bo.SetOutputs(0,0,5,z&&u);
  bo.SetOutputs(0,0,6,!(z&&u));
  bo.SetOutputs(2,1,4,v);
  bo.SetOutputs(3,1,5,w);
  bo.SetOutputs(2,1,5,u);
  bo.SetOutputs(1,1,5,!u);
  bo.SetOutputs(0,1,5,!u);
  bo.SetOutputs(4,0,6,s);
  bo.SetOutputs(5,0,7,t);
  bo.SetOutputs(4,0,7,r);
  bo.SetOutputs(3,0,7,!r);
  bo.SetOutputs(2,0,7,!r);
  bo.SetOutputs(1,0,7,!r);
  bo.SetOutputs(0,0,7,z&&u&&r);

  x = db&0x00000020;
  y = db&0x00000010;
  z = !(x||y);
  t = db&0x00000001;
  r = !t;

  bo.SetOutputs(2,0,0,x);
  bo.SetOutputs(3,0,1,y);
  bo.SetOutputs(3,0,0,z);
  bo.SetOutputs(4,0,0,!z);
  bo.SetOutputs(5,0,0,z);
  bo.SetOutputs(6,0,0,!z);
  bo.SetOutputs(7,0,5,t);
  bo.SetOutputs(7,0,4,t);
  bo.SetOutputs(7,0,3,t);
  bo.SetOutputs(7,0,2,t);
  bo.SetOutputs(7,0,1,t);
  bo.SetOutputs(7,0,0,z&&r);

}


// lowest six bits of da,db,dc,dd determine the value to decode,
// with bit 0 being the bit that is always 1 - i.e. the gated read signal
// da is for the west,front,south decoder, db is for the ebs decoder
// dc is for           wfn                 dd is for     ebn
//
//
// da and dc bust have bits 2 and 3 the same
// db and dd must have bits 2 and 3 the same
//
// You can also specify which direction the output nor should point in

void InstructionDecodeQuad(CBasicObject &bo, unsigned da, unsigned db, unsigned dc, unsigned dd, Direction ora, Direction orb, Direction orc, Direction ord)
{
  if ((da & 0x0000000c) ^ (dc & 0x0000000c))
  {
    std::cout << "Warning: InstructionDecodeQuad has incompatable a and c words" << std::endl;
  }
  if ((db & 0x0000000c) ^ (dd & 0x0000000c))
  {
    std::cout << "Warning: InstructionDecodeQuad has incompatable b and d words" << std::endl;
  }

  bo.Layer();
  bo.String("{nul {n e}} {del {b n}} {del {e n}} {nor {e n}} {nor {e n}} {nor {e n}} {nor {e n}} {nor {b n}}");
  bo.String("{del {w n}} {del {s e}} {nul {n e}} {del {b n}} {nul {n e}} {nul {n e}} {nul {n e}} {del {b n}}");
  bo.String("{del {f n}} {nul {n e}} {del {s e}} {del {e n}} {nul {n e}} {nul {n e}} {nul {n e}} {del {b n}}");
  bo.String("{nor {f e}} {del {w n}} {del {f e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nor {b n}}");
  bo.String("{nor {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {s e}} {del {b n}} {del {e n}} {nor {b n}}");
  bo.String("{nor {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {w n}} {del {s e}} {nul {n e}} {del {b n}}");
  bo.String("{nor {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {f n}} {nul {n e}} {del {s e}} {del {e n}}");
  bo.String("{nor {w n}} {del {w n}} {del {w n}} {nor {w n}} {nor {w n}} {del {w n}} {del {f n}} {nul {n e}}");

  bo.Layer();
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {b n}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nor {b n}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {del {s e}} {del {b n}} {del {e n}} {nor {b n}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {del {w n}} {del {s e}} {nul {n e}} {del {b n}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {del {f n}} {nul {n e}} {del {s e}} {del {e n}} {nul {n e}} {nul {n e}}");
  bo.String("{del {w n}} {nor {w n}} {nor {w n}} {del {w n}} {del {f n}} {del {s e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {s e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");

  bo.Layer();
  bo.String("{nul {n e}} {del {b n}} {del {e n}} {nor {e n}} {nor {e n}} {del {e n}} {del {e n}} {nor {b n}}");
  bo.String("{del {w n}} {del {s e}} {nul {n e}} {del {b n}} {nul {n e}} {nul {n e}} {nul {n e}} {del {b n}}");
  bo.String("{del {f n}} {nul {n e}} {del {s e}} {del {e n}} {nul {n e}} {nul {n e}} {nul {n e}} {del {b n}}");
  bo.String("{nor {f e}} {del {w n}} {del {f e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nor {b n}}");
  bo.String("{nor {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {s e}} {del {b n}} {del {e n}} {nor {b n}}");
  bo.String("{del {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {w n}} {del {s e}} {nul {n e}} {del {b n}}");
  bo.String("{del {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {f n}} {nul {n e}} {del {s e}} {del {e n}}");
  bo.String("{nor {s w}} {del {w n}} {del {w n}} {nor {w n}} {nor {w n}} {del {w n}} {del {f n}} {nul {n e}}");

  if (da & 0x00000020)
    bo.cells[0][2][0].part = nor;
  if (da & 0x00000010)
    bo.cells[0][3][1].part = nor;
  if (da & 0x00000002)
    bo.cells[0][6][4].part = nor;
  if (da & 0x00000001)
    bo.cells[0][7][5].part = nor;
  if (da & 0x00000008)
    bo.cells[1][4][2].part = nor;
  if (da & 0x00000004)
    bo.cells[1][5][3].part = nor;

  if (db & 0x00000020)
    bo.cells[0][0][2].part = nor;
  if (db & 0x00000010)
    bo.cells[0][1][3].part = nor;
  if (db & 0x00000002)
    bo.cells[0][4][6].part = nor;
  if (db & 0x00000001)
    bo.cells[0][5][7].part = nor;
  if (db & 0x00000008)
    bo.cells[1][2][4].part = nor;
  if (db & 0x00000004)
    bo.cells[1][3][5].part = nor;

  if (dc & 0x00000020)
    bo.cells[2][2][0].part = nor;
  if (dc & 0x00000010)
    bo.cells[2][3][1].part = nor;
  if (dc & 0x00000002)
    bo.cells[2][6][4].part = nor;
  if (dc & 0x00000001)
    bo.cells[2][7][5].part = nor;
  if (dc & 0x00000008)
    bo.cells[1][4][2].part = nor;
  if (dc & 0x00000004)
    bo.cells[1][5][3].part = nor;

  if (dd & 0x00000020)
    bo.cells[2][0][2].part = nor;
  if (dd & 0x00000010)
    bo.cells[2][1][3].part = nor;
  if (dd & 0x00000002)
    bo.cells[2][4][6].part = nor;
  if (dd & 0x00000001)
    bo.cells[2][5][7].part = nor;
  if (dd & 0x00000008)
    bo.cells[1][2][4].part = nor;
  if (dd & 0x00000004)
    bo.cells[1][3][5].part = nor;


  bo.cells[0][7][0].or1 = ora;
  bo.cells[0][7][0].or2 = ((ora==west)?north:east);

  bo.cells[0][0][7].or1 = orb;
  bo.cells[0][0][7].or2 = ((orb==east)?north:east);

  bo.cells[2][7][0].or1 = orc;
  bo.cells[2][7][0].or2 = ((orc==west)?north:east);

  bo.cells[2][0][7].or1 = ord;
  bo.cells[2][0][7].or2 = ((ord==east)?north:east);

  bo.Terminal("i4",1,2,1,true,north);
  bo.Terminal("i3",2,2,2,true,north);
  bo.Terminal("i2",3,2,3,true,north);
  bo.Terminal("i1",4,2,4,true,north);
  bo.Terminal("i0",5,2,5,true,north);
  bo.Terminal("ig",6,2,6,true,north);

  bo.Terminal("o4",1,0,1,false,south);
  bo.Terminal("o3",2,0,2,false,south);
  bo.Terminal("o2",3,0,3,false,south);
  bo.Terminal("o1",4,0,4,false,south);
  bo.Terminal("o0",5,0,5,false,south);
  bo.Terminal("og",6,0,6,false,south);

  bo.Terminal("da",0,0,7,false,ora);
  bo.Terminal("db",7,0,0,false,orb);
  bo.Terminal("dc",0,2,7,false,orc);
  bo.Terminal("dd",7,2,0,false,ord);

  bool x,y,z,u,v,w,s,t,r;

  x = da&0x00000020;
  y = da&0x00000010;
  z = !(x||y);
  v = da&0x00000008;
  w = da&0x00000004;
  u = !(v||w);
  s = da&0x00000002;
  t = da&0x00000001;
  r = !(s||t);

  bo.SetOutputs(0,0,2,x);
  bo.SetOutputs(1,0,3,y);
  bo.SetOutputs(0,0,3,z);
  bo.SetOutputs(0,0,4,!z);
  bo.SetOutputs(0,0,5,z&&u);
  bo.SetOutputs(0,0,6,!(z&&u));
  bo.SetOutputs(2,1,4,v);
  bo.SetOutputs(3,1,5,w);
  bo.SetOutputs(2,1,5,u);
  bo.SetOutputs(1,1,5,!u);
  bo.SetOutputs(0,1,5,!u);
  bo.SetOutputs(4,0,6,s);
  bo.SetOutputs(5,0,7,t);
  bo.SetOutputs(4,0,7,r);
  bo.SetOutputs(3,0,7,!r);
  bo.SetOutputs(2,0,7,!r);
  bo.SetOutputs(1,0,7,!r);
  bo.SetOutputs(0,0,7,z&&u&&r);

  x = db&0x00000020;
  y = db&0x00000010;
  z = !(x||y);
  v = db&0x00000008;
  w = db&0x00000004;
  u = !(v||w);
  s = db&0x00000002;
  t = db&0x00000001;
  r = !(s||t);

  bo.SetOutputs(2,0,0,x);
  bo.SetOutputs(3,0,1,y);
  bo.SetOutputs(3,0,0,z);
  bo.SetOutputs(4,0,0,!z);
  bo.SetOutputs(5,0,0,z&&u);
  bo.SetOutputs(6,0,0,!(z&&u));
  bo.SetOutputs(4,1,2,v);
  bo.SetOutputs(5,1,3,w);
  bo.SetOutputs(5,1,2,u);
  bo.SetOutputs(5,1,1,!u);
  bo.SetOutputs(5,1,0,!u);
  bo.SetOutputs(6,0,4,s);
  bo.SetOutputs(7,0,5,t);
  bo.SetOutputs(7,0,4,r);
  bo.SetOutputs(7,0,3,!r);
  bo.SetOutputs(7,0,2,!r);
  bo.SetOutputs(7,0,1,!r);
  bo.SetOutputs(7,0,0,z&&u&&r);

  x = dc&0x00000020;
  y = dc&0x00000010;
  z = !(x||y);
  v = dc&0x00000008;
  w = dc&0x00000004;
  u = !(v||w);
  s = dc&0x00000002;
  t = dc&0x00000001;
  r = !(s||t);

  bo.SetOutputs(0,2,2,x);
  bo.SetOutputs(1,2,3,y);
  bo.SetOutputs(0,2,3,z);
  bo.SetOutputs(0,2,4,!z);
  bo.SetOutputs(0,2,5,!z);
  bo.SetOutputs(0,2,6,!z);
  bo.SetOutputs(2,1,4,v);
  bo.SetOutputs(3,1,5,w);
  bo.SetOutputs(2,1,5,u);
  bo.SetOutputs(1,1,5,!u);
  bo.SetOutputs(0,1,5,!u);
  bo.SetOutputs(4,2,6,s);
  bo.SetOutputs(5,2,7,t);
  bo.SetOutputs(4,2,7,r);
  bo.SetOutputs(3,2,7,!r);
  bo.SetOutputs(2,2,7,!r);
  bo.SetOutputs(1,2,7,!r);
  bo.SetOutputs(0,2,7,z&&u&&r);

  x = dd&0x00000020;
  y = dd&0x00000010;
  z = !(x||y);
  v = dd&0x00000008;
  w = dd&0x00000004;
  u = !(v||w);
  s = dd&0x00000002;
  t = dd&0x00000001;
  r = !(s||t);

  bo.SetOutputs(2,2,0,x);
  bo.SetOutputs(3,2,1,y);
  bo.SetOutputs(3,2,0,z);
  bo.SetOutputs(4,2,0,!z);
  bo.SetOutputs(5,2,0,!z);
  bo.SetOutputs(6,2,0,!z);
  bo.SetOutputs(4,1,2,v);
  bo.SetOutputs(5,1,3,w);
  bo.SetOutputs(5,1,2,u);
  bo.SetOutputs(5,1,1,!u);
  bo.SetOutputs(5,1,0,!u);
  bo.SetOutputs(6,2,4,s);
  bo.SetOutputs(7,2,5,t);
  bo.SetOutputs(7,2,4,r);
  bo.SetOutputs(7,2,3,!r);
  bo.SetOutputs(7,2,2,!r);
  bo.SetOutputs(7,2,1,!r);
  bo.SetOutputs(7,2,0,z&&u&&r);

}


// Note that these fixes won't have the correct values set initially - this
// shouldn't matter too much because they get gated with the memory
// read signal
void InstructionDecodeQuadFixWest(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{nor {f e}} {nor {w n}}");
  bo.String("{del {f n}} {nul {n e}}");
  bo.String("{del {f n}} {nul {n e}}");
  bo.String("{nor {n e}} {nor {f n}}");
  bo.String("{del {w n}} {del {f n}}");

  bo.SetOutputs(1,0,0,true);
  bo.SetOutputs(1,0,3,true);
  bo.SetOutputs(1,0,4,true);
  bo.SetOutputs(0,0,4,true);

  bo.Terminal("i",1,0,3,true,north);
  bo.Terminal("o",0,0,3,false,north);
}

void InstructionDecodeQuadFixBack(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{nor {e n}} {del {e n}} {del {e n}} {nor {n e}} {del {b n}}");
  bo.String("{nor {b n}} {nul {n e}} {nul {n e}} {nor {e n}} {del {e n}}");

  bo.SetOutputs(0,0,1,true);
  bo.SetOutputs(3,0,1,true);
  bo.SetOutputs(4,0,1,true);
  bo.SetOutputs(4,0,0,true);

  bo.Terminal("i",3,0,1,true,north);
  bo.Terminal("o",3,0,0,false,north);
}

void InstructionDecode6Bit(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{del {w n}} {del {w n}} {del {b e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{del {f n}} {del {e n}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{del {w n}} {nor {w n}} {del {w n}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{del {f n}} {del {w n}} {del {w n}} {del {w n}} {del {s e}} {del {b n}} {nor {e n}} {nor {e n}} {nor {e n}} {nor {e n}}");
  bo.String("{del {f n}} {nul {n e}} {del {w n}} {del {w n}} {del {w n}} {del {s e}} {nul {n e}} {nor {b n}} {nul {n e}} {nor {b n}}");
  bo.String("{del {f n}} {del {e n}} {del {f n}} {nul {n e}} {nul {n e}} {nul {n e}} {del {s e}} {del {e n}} {nul {n e}} {del {b n}}");
  bo.String("{nul {n e}} {del {f n}} {del {f n}} {nul {n e}} {nul {n e}} {nor {f n}} {nor {w n}} {del {s e}} {del {e n}} {nor {b n}}");
  bo.String("{nul {n e}} {nor {f n}} {nor {f n}} {del {w n}} {nor {w n}} {nor {w n}} {nor {w n}} {del {w n}} {del {s e}} {nor {b n}}");
  bo.String("{nor {w n}} {nor {w n}} {del {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {del {b e}} {del {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {del {b e}} {del {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {del {b e}} {del {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {del {b e}} {del {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {del {w n}} {del {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");

  bo.Layer();
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nor {f n}} {nul {n e}} {nul {n e}} {del {f e}} {del {s e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {del {n e}} {del {f n}} {nul {n e}} {nul {n e}} {nor {f e}} {nor {w n}} {del {s e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nor {f e}} {nor {f e}} {del {n e}} {nul {n e}} {nor {f e}} {nul {n e}} {del {f e}} {del {s e}} {nul {n e}}");
  bo.String("{nor {w n}} {nor {w n}} {del {f e}} {nul {n e}} {nul {n e}} {nor {f e}} {nor {w n}} {nor {w n}} {nor {w n}} {nul {n e}}");
  bo.String("{nul {n e}} {del {b e}} {del {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {del {b e}} {del {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {del {b e}} {del {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {del {w n}} {del {f e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");


  bo.Terminal("i0",2,1,1,true,north);
  bo.Terminal("i1",3,1,2,true,north);
  bo.Terminal("i2",4,1,3,true,north);
  bo.Terminal("i3",5,1,4,true,north);
  bo.Terminal("i4",6,1,5,true,north);
  bo.Terminal("i5",7,1,6,true,north);
  bo.Terminal("ig",8,1,7,true,north);

  bo.Terminal("o0",2,0,1,false,south);
  bo.Terminal("o1",3,0,2,false,south);
  bo.Terminal("o2",4,0,3,false,south);
  bo.Terminal("o3",5,0,4,false,south);
  bo.Terminal("o4",6,0,5,false,south);
  bo.Terminal("o5",7,0,6,false,south);
  bo.Terminal("og",8,0,7,false,south);

  bo.Terminal("omove",0,1,8,false,west);
  bo.Terminal("ogather",5,1,8,false,front);
  bo.Terminal("odispense",0,0,8,false,west);
  bo.Terminal("oreturn",9,0,3,false,east);
  bo.Terminal("omembank",9,1,3,false,east);

  bo.SetOutputs(8,1,8,true);
  bo.SetOutputs(5,1,7,true);
  bo.SetOutputs(6,1,6,true);
  bo.SetOutputs(6,1,8,true);

  bo.SetOutputs(6,0,3,true);
  bo.SetOutputs(7,0,4,true);
  bo.SetOutputs(8,0,3,true);
  bo.SetOutputs(9,0,4,true);
  bo.SetOutputs(9,0,7,true);

  bo.SetOutputs(1,0,2,true);
  bo.SetOutputs(0,0,2,true);
  bo.SetOutputs(0,0,3,true);
  bo.SetOutputs(0,0,4,true);
  bo.SetOutputs(0,0,5,true);
  bo.SetOutputs(1,0,5,true);
  bo.SetOutputs(1,0,6,true);
  bo.SetOutputs(1,1,6,true);
  
  bo.SetOutputs(2,1,5,true);
  bo.SetOutputs(2,1,6,true);

  bo.SetOutputs(6,0,6,true);
  bo.SetOutputs(6,0,7,true);
  bo.SetOutputs(4,0,7,true);
  bo.SetOutputs(3,0,7,true);
  bo.SetOutputs(1,0,8,true);
  bo.SetOutputs(3,1,7,true);
  bo.SetOutputs(1,1,8,true);

  bo.SetOutputs(6,1,3,true);
  bo.SetOutputs(8,1,3,true);

}


