#include "memcounter.cpp"
#include "sflipflop.cpp"

void Mount(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{del {n e} x newfb} {nul {n e}} {del {n e}} {nul {n e}} {del {n e}} {nul {n e}} {del {n e}} {nul {n e}} {del {n e}} {nul {n e}} {del {n e}} {nul {n e}} {del {n e}} {nul {n e}} {del {n e}}");
  bo.Layer();
  bo.String("{del {n e} x newfb} {nul {n e}} {del {n e}} {nul {n e}} {del {n e}} {nul {n e}} {del {n e}} {nul {n e}} {del {n e}} {nul {n e}} {del {n e}} {nul {n e}} {del {n e}} {nul {n e}} {del {n e}}");

  bo.Terminal("0",0,0,0,true,south);
  bo.Terminal("1",2,0,0,true,south);
  bo.Terminal("2",4,0,0,true,south);
  bo.Terminal("3",6,0,0,true,south);
  bo.Terminal("4",8,0,0,true,south);
  bo.Terminal("5",10,0,0,true,south);
  bo.Terminal("6",12,0,0,true,south);
  bo.Terminal("7",14,0,0,true,south);

  bo.Terminal("o0",0,1,0,true,front);
  bo.Terminal("o1",2,1,0,true,front);
  bo.Terminal("o2",4,1,0,true,front);
  bo.Terminal("o3",6,1,0,true,front);
  bo.Terminal("o4",8,1,0,true,front);
  bo.Terminal("o5",10,1,0,true,front);
  bo.Terminal("o6",12,1,0,true,front);
  bo.Terminal("o7",14,1,0,true,front);

}

void SpareDel(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{del {f n}}");

  bo.Terminal("i",0,0,0,true,back);
  bo.Terminal("o",0,0,0,false,north);
}

void SpareDel2(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{del {f n} x neswf}");

  bo.Terminal("i",0,0,0,true,back);
  bo.Terminal("o",0,0,0,false,north);
}

void Edge2FFs(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{nul {n e}} {del {b e}} {nul {n e}} {nul {n e}}");
  bo.String("{nor {n e} x n} {del {b e}} {del {b e}} {del {e n}}");
  bo.String("{del {e n}} {del {e n}} {del {e n}} {nul {n e}}");
  bo.Layer();
  bo.String("{nul {n e}} {del {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nor {w n}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");

  bo.Terminal("i",0,0,2,true,west);
  bo.Terminal("o",0,1,1,false,west);
  bo.Terminal("o2",1,0,1,false,north);
  bo.Terminal("o3",2,0,2,false,east);
}


void Route567(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{nul {n e}} {nor {e n}} {nul {n e}} {nor {e n}}");
  bo.String("{nul {n e}} {nor {b e}} {nul {n e}} {nor {b e}}");
  bo.String("{nul {n e}} {del {b e}} {nul {n e}} {del {b e}}");
  bo.String("{del {f n}} {nor {b e}} {nor {f e}} {nor {b e}}");
  bo.String("{del {f n}} {nor {e n}} {nor {e n}} {del {e n}}");
  bo.Layer();
  bo.String("{nul {n e}} {nor {e n}} {nul {n e}} {nor {e n}}");
  bo.String("{nul {n e}} {nor {b e}} {nul {n e}} {nor {b e}}");
  bo.String("{nul {n e}} {del {b e}} {nul {n e}} {del {b e}}");
  bo.String("{del {f n}} {nor {b e}} {nor {f e}} {nor {b e}}");
  bo.String("{del {f n}} {nor {e n}} {nor {e n}} {del {e n}}");

  bo.SetOutputs(1,0,3,true);
  bo.SetOutputs(1,0,2,true);
  bo.SetOutputs(1,0,0,true);
  bo.SetOutputs(1,0,4,true);
  bo.SetOutputs(2,0,3,true);
  bo.SetOutputs(3,0,3,true);
  bo.SetOutputs(3,0,2,true);
  bo.SetOutputs(3,0,0,true);

  bo.SetOutputs(1,1,3,true);
  bo.SetOutputs(1,1,2,true);
  bo.SetOutputs(1,1,0,true);
  bo.SetOutputs(1,1,4,true);
  bo.SetOutputs(2,1,3,true);
  bo.SetOutputs(3,1,3,true);
  bo.SetOutputs(3,1,2,true);
  bo.SetOutputs(3,1,0,true);

  bo.Terminal("i5_0",0,0,3,true,back);
  bo.Terminal("o5_0",1,0,0,false,east);
  bo.Terminal("i5_1",0,1,3,true,back);
  bo.Terminal("o5_1",1,1,0,false,east);
  bo.Terminal("i5_0",2,0,3,true,back);
  bo.Terminal("o5_0",3,0,0,false,east);
  bo.Terminal("i5_1",2,1,3,true,back);
  bo.Terminal("o5_1",3,1,0,false,east);
}

void MemCounter(CCompoundObject &co)
{
  CBasicObject *mnt;
  CBasicObject *sd;
  CBasicObject *mc0,*mc1,*mc2,*mc3,*mc4;
  CBasicObject *ne2;
  CBasicObject *ff1,*ff2,*ff3;
  CBasicObject *e2ffs;
  CBasicObject *r567;
  CBasicObject *sdrow[4];

  mnt = new CBasicObject;
  sd = new CBasicObject;
  mc0 = new CBasicObject;
  mc1 = new CBasicObject;
  mc2 = new CBasicObject;
  mc3 = new CBasicObject;
  mc4 = new CBasicObject;
  ne2 = new CBasicObject;
  ff1 = new CBasicObject;
  ff2 = new CBasicObject;
  ff3 = new CBasicObject;
  r567 = new CBasicObject;
  e2ffs = new CBasicObject;

  for(unsigned i = 0; i<4; i++)
    sdrow[i] = new CBasicObject;

  Mount(*mnt);
  SpareDel(*sd);
  MemoryCounter0(*mc0);
  MemoryCounter1(*mc1);
  MemoryCounter2(*mc2);
  MemoryCounter3(*mc3);
  MemoryCounter4(*mc4);
  SmallToggleV3(*ff1);
  Edge2FFs(*e2ffs);
  SmallToggleV2(*ff2);
  SmallToggle(*ff3);
  Route567(*r567);
  SpareDel2(*(sdrow[0]));  // This is to avoid a match with 0 on first count
  SpareDel(*(sdrow[1]));
  SpareDel(*(sdrow[2]));
  SpareDel(*(sdrow[3]));

  NegativeEdge2Side(*ne2);

  mc0->Rotate(front);
  mc1->Rotate(front);
  mc2->Rotate(front);
  mc3->Rotate(front);
  mc4->Rotate(front);
  ff1->Rotate(south);
  ff1->Rotate(front);
  ff2->Rotate(south);
  ff2->Rotate(front);
  ff3->Rotate(south);
  ff3->Rotate(front);

  ne2->Rotate(east);

  co.AddObject(mnt,"mnt",0,0,0);
  co.AddObject(sdrow[0],"sdr0","o","mnt.0");
  co.AddObject(mc0,"mc0","o","sdr0.i");
  co.AddObject(sdrow[1],"sdr1","o","mnt.1");
  co.AddObject(mc1,"mc1","o","sdr1.i");
  co.AddObject(sdrow[2],"sdr2","o","mnt.2");
  co.AddObject(mc2,"mc2","o","sdr2.i");
  co.AddObject(sdrow[3],"sdr3","o","mnt.3");
  co.AddObject(mc3,"mc3","o","sdr3.i");
  co.AddObject(sd,"sd","o","mnt.4");
  co.AddObject(mc4,"mc4","o","sd.i");

  co.AddObject(ne2,"ne2","i","mc4.op");
  co.AddObject(e2ffs,"e2ffs","i","ne2.o");
  co.AddObject(ff1,"ff1","t","e2ffs.o");

  co.AddObject(ff2,"ff2","tf","e2ffs.o2");
  co.AddObject(ff3,"ff3","ts","e2ffs.o3");

  co.AddObject(r567,"r567","i5_1","ff1.q");
}
