#ifndef memorycontrol_cpp
#define memorycontrol_cpp

#include "counterstack.cpp"
#include "memcounter2.cpp"
#include "gates.cpp"
#include "memory.cpp"
#include "pulsegen.cpp"
#include "signalpath.cpp"
#include "returncount.cpp"


#include "memoryanddecode.cpp"


void CounterInverter(CBasicObject &bo, bool set)
{
  bo.Layer();
  bo.String("{nor {f e}} {nul {n e}}");
  bo.String("{del {f e}} {nul {n e}}");
  bo.String("{nul {n e}} {nor {w n}}");

  bo.SetOutputs(0,0,0,true);
  bo.SetOutputs(0,0,1,true);
  bo.SetOutputs(1,0,2,set);

  bo.Terminal("i",1,0,2,true,east);
  bo.Terminal("ib",1,0,2,true,back);
  bo.Terminal("o",1,0,2,false,west);
}

void ReadInhibitResetInput(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{del {w n}}");

  bo.Terminal("i",0,0,0,true,east);
  bo.Terminal("o",0,0,0,false,west);
}

void AndLayer0(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{nor {e n}} {nor {b n}} {nor {w n}}");

  bo.Terminal("a",0,0,0,true,front);
  bo.Terminal("o",1,0,0,false,back);
  bo.Terminal("b",2,0,0,true,front);

  bo.SetOutputs(0,0,0,true);
  bo.SetOutputs(2,0,0,true);
}

void AndLayer0Dummy(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{nor {e n}} {nor {b n}}");

  bo.Terminal("a",0,0,0,true,front);
  bo.Terminal("o",1,0,0,false,back);

  bo.SetOutputs(0,0,0,true);
}

void AndLayer1(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{del {b n}} {nor {e n}} {nor {b n}} {nor {w n}} {del {b n}}");

  bo.Terminal("a",0,0,0,true,front);
  bo.Terminal("b",4,0,0,true,front);
  bo.Terminal("o",2,0,0,false,back);

  bo.SetOutputs(1,0,0,true);
  bo.SetOutputs(3,0,0,true);
}

void AndLayer2(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{del {b n}} {nor {e n}} {del {e n}} {del {e n}} {nor {b n}} {del {w n}} {del {w n}} {nor {w n}} {del {b n}}");

  bo.Terminal("a",0,0,0,true,front);
  bo.Terminal("o",4,0,0,false,back);
  bo.Terminal("b",8,0,0,true,front);

  bo.SetOutputs(1,0,0,true);
  bo.SetOutputs(2,0,0,true);
  bo.SetOutputs(3,0,0,true);
  bo.SetOutputs(5,0,0,true);
  bo.SetOutputs(6,0,0,true);
  bo.SetOutputs(7,0,0,true);
}

void ReadGate(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{nul {n e}} {nul {n e}} {del {w n}} {del {w n}} {del {w n}} {del {b n}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {b n}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {del {w n}} {del {f e}} {ufs {e b}} {nor {e n} ef e} {nor {b n}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {del {f e}} {sli {e f}} {sli {w b} ef} {nor {w n}} {del {w n}} {del {w n}} {nor {w n}}");

  bo.Layer();
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {fus {s b}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nor {n e}} {nul {n e}} {nul {n e}}");

  bo.Layer();
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {b e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {b e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {del {w n}} {del {n e}} {nul {n e}} {nul {n e}}");

  bo.Terminal("i",7,0,3,true,front);
  bo.Terminal("o",5,0,0,false,back);
  bo.Terminal("o2",5,0,1,false,north);
  bo.Terminal("read",5,0,2,true,east);
  bo.Terminal("cri",2,0,1,true,south); // input for ORed call and return signals

  bo.SetOutputs(5,0,3,true);
  bo.SetOutputs(6,0,3,true);
  bo.SetOutputs(7,0,3,true);
}

void ReadInhibitResetLogic(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{nul {n e}} {del {b e} nfb} {del {e n} fb} {del {e n} fb} {del {e n} fbe} {nul {n e}} {nul {n e}}");
  bo.String("{del {b e} b} {del {b e} b} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {b e}} {del {b e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {b e}} {del {b e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {b e}} {del {b e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");

  bo.Layer();
  bo.String("{nor {e n} s e} {fus {e n} s} {nul {n e}} {sli {s e} bne} {sli {s w} bne} {nul {n e}} {nul {n e}}");
  bo.String("{del {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");

  bo.Layer();
  bo.String("{del {b e}} {ufs {e s}} {del {s e}} {del {n e}} {del {f e}} {nul {n e}} {nul {n e}}");
  bo.String("{del {b e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");

  bo.Layer();
  bo.String("{del {n e}} {del {e n}} {del {e n}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}} {nul {n e}}");
 
  bo.Terminal("gatheron-attach",1,0,0,false,west);
  bo.Terminal("gather-in",4,2,0,true,back);
  bo.Terminal("full-in",0,2,1,true,front);
  bo.Terminal("i",1,0,4,true,front);
  bo.Terminal("o",4,0,0,false,east);
}

void LoadPathOut(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{del {b e}} {nul {n e}} {nul {n e}}");
  bo.String("{del {b e}} {nul {n e}} {nul {n e}}");
  bo.String("{del {b e}} {del {w n}} {nul {n e}}");
  bo.String("{del {w n}} {nor {w n}} {nul {n e}}");
  bo.String("{nul {n e}} {nor {b e} x b} {del {b e}}");
  bo.String("{nul {n e}} {nul {n e}} {del {b e}}");
  bo.String("{nul {n e}} {nul {n e}} {del {b e}}");
  bo.String("{nul {n e}} {nul {n e}} {del {w n}}");

  bo.Layer();
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {del {b n} x neswb} {nul {n e}}");
  bo.String("{nul {n e}} {nor {b n} x b} {del {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}}");
  bo.String("{nul {n e}} {nul {n e}} {nul {n e}}");

  bo.Terminal("o",0,0,0,false,back);
  bo.Terminal("i",1,0,2,true,east);
}

void MemoryControl(CCompoundObject &co, unsigned *data, unsigned words)
{
  CCompoundObject *mc;
  CCompoundObject *cntstack;
  CBasicObject *nxg[8];
  CBasicObject *al0[4];
  CBasicObject *al1[2];
  CBasicObject *al2;
  CBasicObject *rg;
//  CCompoundObject *callreturnorpathreturn;
//  CCompoundObject *callreturnorpathcall;

  CBasicObject *rinhff;
  CBasicObject *rpulgen,*rpulgeninpath;
  CBasicObject *r4iset;
  CBasicObject *r4gate;
  CCompoundObject *r4cin1,*r4cin2;
  CBasicObject *r4cin3,*r4cin4;
  CBasicObject *cinv,*cinv2;
  CBasicObject *co2rir1,*co2rir2,*co2riror;
  CBasicObject *rirl;
  CCompoundObject *gathersig1;
  CCompoundObject *gatheronsig;
  CBasicObject *loadpathout;
  CBasicObject *returncount;
  CCompoundObject *cnthibitspaths;
  CCompoundObject *memoryanddecode = new CCompoundObject;
  CBasicObject *counterloadenable;
  CCompoundObject *callpath = new CCompoundObject;
  CBasicObject *callincinhibit;
  CCompoundObject *returnpath1,*returnpath2;
  CCompoundObject *callhibit;
  CCompoundObject *callbits[10];
  CBasicObject *returnpulsegen;
  CCompoundObject *returnpathbranch;
  CCompoundObject *returnpathresetbranch;
  CCompoundObject *dispensepath = new CCompoundObject();
  //CCompoundObject *membankpath = new CCompoundObject();

  MemoryAndDecode(*memoryanddecode,data,words);
  SignalPathJointed(*dispensepath,"w 4 i s 6 f 1");

  mc = new CCompoundObject;
  cntstack = new CCompoundObject;
  {for(unsigned i = 0; i<8; i++)
  {
    nxg[i] = new CBasicObject;
  }}

  cnthibitspaths = new CCompoundObject;

  {for(unsigned i = 0; i<4; i++)
  {
    al0[i] = new CBasicObject;
  }}

  {for(unsigned i = 0; i<2; i++)
  {
    al1[i] = new CBasicObject;
  }}

  al2 = new CBasicObject;

  rg = new CBasicObject;
//  callreturnorpathreturn = new CCompoundObject;
//  callreturnorpathcall = new CCompoundObject;

  MemCounter(*mc);
  mc->Rotate(east);
  mc->Rotate(east);

  CounterStack(*cntstack,13);
  {for(unsigned i = 0; i<8; i++)
  {
    NXorGateInStep0(*(nxg[i]));
    nxg[i]->Rotate(west);
    nxg[i]->Rotate(south);
  }}

  CounterHiBitsPaths(*cnthibitspaths);

  {for(unsigned i = 0; i<4; i++)
  {
    AndLayer0(*al0[i]);
  }}

  {for(unsigned i = 0; i<2; i++)
  {
    AndLayer1(*al1[i]);
  }}

  AndLayer2(*al2);
  ReadGate(*rg);
//  SignalPathJointed(*callreturnorpathreturn,"i n 1 i n 1 f 5 i f 1 i w 11 n 0");
//  SignalPathJointed(*callreturnorpathcall,"w 4 n 4 b 6");

  callhibit = new CCompoundObject;

  {for(unsigned i = 0; i<10; i++)
  {
    callbits[i] = new CCompoundObject;
  }}

  SignalPathJointed(*callhibit,"s 4 f 1 n 2 f 1 s 2 f 1");  
  SignalPathJointed(*callbits[9],"s 1 f 4 i f 6 e 2 f 2 n 2 f 1");
  SignalPathJointed(*callbits[8],"s 1 f 5 i f 7 e 1 f 1 n 2 f 1");
  SignalPathJointed(*callbits[7],"s 1 f 6 i f 8 n 2 f 1");
  SignalPathJointed(*callbits[6],"s 1 f 7 i f 7 w 1 f 1 n 2 f 1");
  SignalPathJointed(*callbits[5],"s 1 f 8 i f 6 w 1 f 1 w 1 f 1 n 2 f 1");

  SignalPathJointed(*callbits[4],"s 1 f 4 i f 6 w 2 f 2 n 2 f 1");
  SignalPathJointed(*callbits[3],"s 1 f 5 i f 5 w 3 f 3 n 2 f 1");
  SignalPathJointed(*callbits[2],"s 1 f 6 i f 4 w 4 f 4 n 2 f 1");
  SignalPathJointed(*callbits[1],"s 1 f 7 i f 3 w 5 f 5 n 2 f 1");
  SignalPathJointed(*callbits[0],"s 1 f 8 i f 2 w 6 f 6 n 2 f 1");

  rinhff = new CBasicObject();
  rpulgen = new CBasicObject();
  rpulgeninpath = new CBasicObject();
  r4cin1 = new CCompoundObject();
  r4cin2 = new CCompoundObject();
  r4cin3 = new CBasicObject();
  r4cin4 = new CBasicObject();
  r4gate = new CBasicObject();
  r4iset = new CBasicObject();
  cinv = new CBasicObject();
  cinv2 = new CBasicObject();
  co2rir1 = new CBasicObject();
  co2rir2 = new CBasicObject();
  co2riror = new CBasicObject();
  rirl = new CBasicObject();
  gathersig1 = new CCompoundObject();
  gatheronsig = new CCompoundObject();
  loadpathout = new CBasicObject();
  returncount = new CBasicObject();
  counterloadenable = new CBasicObject();
  callincinhibit = new CBasicObject();
  returnpath1 = new CCompoundObject();
  returnpath2 = new CCompoundObject();
  returnpulsegen = new CBasicObject();
  returnpathbranch = new CCompoundObject();
  returnpathresetbranch = new CCompoundObject();

  SmallSignalFlipFlop(*rinhff,false);
  rinhff->Rotate(east);
  PulseGen2InBackCorner(*rpulgen);
  rpulgen->Rotate(east);
  SignalPath(*r4iset,2,1,1,front,west,north,back,west);

  // Below is the path that leads from the read signal to the right hand side of the counter stack
  // to increment the counter. Notice that this is inhibited when a call instruction is executed.
  SignalPathJointed(*r4cin1,"e 1 s 1 e 17 s 3 f 0");
  SignalPathJointed(*r4cin2,"f 2 e 6 f 0");
  SignalPath(*r4cin3,7,1,1,west,north,front,back,front,true,true);
  SignalPath(*r4cin4,2,1,10,front,west,north,back,front,true,false);
  // Add an extra terminal to r4cin4 to attach the inhibit signal from call path
  r4cin4->Terminal("inhibit",1,0,0,true,south);
  SignalPath(*callincinhibit,1,2,2,north,front,east,south,north);


  r4gate->Layer();
  r4gate->String("{nor {f n} x f}");
  r4gate->String("{nor {f n}}");
  r4gate->Terminal("i",0,0,0,true,back);
  r4gate->Terminal("o",0,0,1,false,front);

  CounterInverter(*cinv,true);

//  SignalPathJointed(*returncount,"f 8 n 1 b 7 n 1 f 7 n 1 b 7 n 1 f 7 n 2 w 0");
  ReturnCount(*returncount);
  returncount->Rotate(west);
  returncount->Rotate(south);

  SignalPathJointed(*returnpath1,"e 11 f 2");
  SignalPathJointed(*returnpath2,"f 6 e 3 s 1 f 3 s 1 b 3 s 4 e 1 f 2 s 2 f 2 i w 1 w 1");
  SignalPathJointed(*returnpathbranch,"n 1 b 1 w 1");
  SignalPathJointed(*returnpathresetbranch,"s 1");
  PulseGen2(*returnpulsegen);
  // Add an extra terminal to this pulse generate to allow the input signal to be passed out again
  returnpulsegen->Terminal("pass",0,0,1,false,front);
  returnpulsegen->Rotate(west);
  returnpulsegen->Rotate(north);

  CounterInverter(*cinv2,false);

  SignalPath(*co2rir1,3,1,6,west,back,north,east,back);

  co2riror->Layer();
  co2riror->String("{nor {b e}}");
  co2riror->String("{nor {b e} x b}");
  co2riror->Terminal("o",0,0,0,false,back);
  co2riror->Terminal("i",0,0,1,true,front);
  co2riror->Terminal("i2",0,0,1,true,south);

//  SignalPath(*loadpathout,2,3,1,west,north,back,east,north,true,false);
  LoadPathOut(*loadpathout);
  loadpathout->Rotate(west);

  SignalPath(*co2rir2,8,3,5,east,back,north,west,north);
  ReadInhibitResetLogic(*rirl);
  SignalPathJointed(*gathersig1,"f 1 s 2 f 4 w 9 n 3 f 0");
  SignalPathJointed(*gatheronsig,"w 35 n 12 f 29 i f 1");

  SignalPath(*counterloadenable,2,3,1,front,south,west,north,west,false,true);
  // Add an extra terminal for addition of the returnpathbranch
  counterloadenable->Terminal("ie",1,4,0,true,east);

  SignalPathJointed(*callpath,"e 8 s 1 w 2 s 1 f 2");

  //SignalPathJointed(*membankpath,"f 5 n 5");

  co.AddObject(mc,"mc",0,0,0);
  co.AddObject(nxg[0],"nxg0","a","mc.mnt.o0");
  co.AddObject(cntstack,"cntstack","cnt.ff0.q2","nxg0.b");
  co.AddObject(nxg[1],"nxg1","a","mc.mnt.o1");
  co.AddObject(nxg[2],"nxg2","a","mc.mnt.o2");
  co.AddObject(nxg[3],"nxg3","a","mc.mnt.o3");
  co.AddObject(nxg[4],"nxg4","a","mc.mnt.o4");
  co.AddObject(nxg[5],"nxg5","a","mc.mnt.o5");
  co.AddObject(nxg[6],"nxg6","a","mc.mnt.o6");
  co.AddObject(nxg[7],"nxg7","a","mc.mnt.o7");

  co.AddObject(cnthibitspaths,"cnt-hi-bits-paths","path0.i","cntstack.cnt.ff8.q2");

  co.AddObject(al0[0],"al0_0","a","nxg0.o");
  co.AddObject(al0[1],"al0_1","a","nxg2.o");
  co.AddObject(al0[2],"al0_2","a","nxg4.o");
  co.AddObject(al0[3],"al0_3","a","nxg6.o");

  co.AddObject(al1[0],"al1_0","a","al0_0.o");
  co.AddObject(al1[1],"al1_1","a","al0_2.o");

  co.AddObject(al2,"al2","a","al1_0.o");

  co.AddObject(rg,"rg","i","al2.o");
//  co.AddObject(callreturnorpathreturn,"callreturnorpathreturn","o","rg.cri");

  co.AddObject(memoryanddecode,"mad","mem.memory-out-gate.gate","rg.o");

  co.AddObject(rinhff,"rinhff","q","rg.read");
  co.AddObject(r4iset,"r4iset","o","rinhff.s");
  co.AddObject(rpulgen,"rpulgen","i","rg.o2");
  co.AddObject(cinv,"cinv","o","cntstack.cnt.ss12.count-in");

  co.AddObject(returncount,"returncount","o","cinv.i");

  co.AddObject(r4cin4,"r4cin4","o","cinv.ib");
  co.AddObject(r4cin3,"r4cin3","o","r4cin4.i");
  co.AddObject(r4cin2,"r4cin2","o","r4cin3.i");
  co.AddObject(r4gate,"r4gate","o","r4cin2.i");
  co.AddObject(r4cin1,"r4cin1","o","r4gate.i");
  co.AddObject(callincinhibit,"callincinhibit","o","r4cin4.inhibit");
  co.AddObject(cinv2,"cinv2","i","cntstack.cnt.ss0.count-out");
  co.AddObject(co2rir1,"co2rir1","i","cinv2.o");
  co.AddObject(co2riror,"co2riror","i","co2rir1.o");
  co.AddObject(rirl,"rirl","i","co2riror.o");
  co.AddObject(co2rir2,"co2rir2","i","rirl.o");

  co.AddObject(loadpathout,"loadpathout","o","co2riror.i2");

  co.AddObject(gathersig1,"gathersig1","o","rirl.gather-in");

  co.AddObject(gatheronsig,"gatheronsig","i","rirl.gatheron-attach");

  co.AddObject(callhibit,"callhibit","o","cntstack.cmux12.b");
  co.AddObject(callbits[9],"callbit9","o","cntstack.cmux11.b");
  co.AddObject(callbits[8],"callbit8","o","cntstack.cmux10.b");
  co.AddObject(callbits[7],"callbit7","o","cntstack.cmux9.b");
  co.AddObject(callbits[6],"callbit6","o","cntstack.cmux8.b");
  co.AddObject(callbits[5],"callbit5","o","cntstack.cmux7.b");
  co.AddObject(callbits[4],"callbit4","o","cntstack.cmux6.b");
  co.AddObject(callbits[3],"callbit3","o","cntstack.cmux5.b");
  co.AddObject(callbits[2],"callbit2","o","cntstack.cmux4.b");
  co.AddObject(callbits[1],"callbit1","o","cntstack.cmux3.b");
  co.AddObject(callbits[0],"callbit0","o","cntstack.cmux2.b");

  co.AddObject(counterloadenable,"counterloadenable","o","cntstack.stack.loadpath.i");
  co.AddObject(callpath,"callpath","i","mad.regstructure.call");
//  co.AddObject(callreturnorpathcall,"callreturnorpathcall","i","mad.regstructure.call2");

  co.AddObject(returnpath1,"returnpath1","i","mad.idecode.oreturn");
  co.AddObject(returnpulsegen,"returnpulsegen","i","returnpath1.o");
  co.AddObject(returnpath2,"returnpath2","i","returnpulsegen.oe");
  co.AddObject(returnpathbranch,"returnpathbranch","o","cntstack.loadpathor.iret");
  co.AddObject(returnpathresetbranch,"returnpathresetbranch","i","returnpulsegen.pass");

  co.AddObject(dispensepath,"dispensepath","i","mad.idecode.odispense");

//  co.AddObject(membankpath,"membankpath","i","mad.membankaddon.omembank");
}

#endif