void SerialDecoder(CBasicObject &bo, bool x, bool y, bool z)
{
  bo.Layer();
  bo.String("{del {b e}} {del {e n}} {del {e n}}");
  bo.String("{del {b e}} {nul {n e}} {nor {f n}}");
  if (y)
    bo.String("{del {b e}} {nor {e n}} {nor {f n}}");
  else
    bo.String("{del {b e}} {del {e n}} {nor {f n}}");
  bo.String("{del {b e}} {nul {n e}} {nor {f n}}");
  bo.String("{del {b e}} {nul {n e}} {del {f n}}");
  bo.String("{del {e n}} {nor {e n}} {nor {e n}}");
  bo.String("{del {f n}} {nul {n e}} {nor {b n}}");
  if (x)
    bo.String("{del {f n}} {nor {e n}} {nor {b n}}");
  else
    bo.String("{del {f n}} {del {e n}} {nor {b n}}");
  if (z)
    bo.String("{del {f n}} {nul {n e}} {nor {b n}}");
  else
    bo.String("{del {f n}} {nul {n e}} {del {b n}}");
  bo.String("{del {f n}} {del {e n}} {del {e n}}");

  bo.SetOutputs(2,0,1,true);
  bo.SetOutputs(1,0,2,y);
  bo.SetOutputs(2,0,3,true);
  bo.SetOutputs(2,0,4,true);
  bo.SetOutputs(1,0,5,true);
  bo.SetOutputs(1,0,7,x);
  bo.SetOutputs(2,0,8,z);
  bo.SetOutputs(2,0,7,!x && !z);
  bo.SetOutputs(2,0,6,x || z);

  bo.Terminal("i",0,0,5,true,west);
  bo.Terminal("o",2,0,5,false,east);
}

void SerialDecoderFolded(CBasicObject &bo, bool x, bool y, bool z)
{
  bo.Layer();
  bo.String("{del {s e}} {del {e n}} {nor {n e}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");

  bo.Layer();
  bo.String("{del {s e}} {nul {n e}} {del {n e}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");

  bo.Layer();
  if (y)
    bo.String("{del {b e}} {nor {e n}} {nor {f n}}");
  else
    bo.String("{del {b e}} {del {e n}} {nor {f n}}");
  bo.String("{del {b e}} {nul {n e}} {nor {f n}}");
  bo.String("{del {b e}} {nul {n e}} {del {f n}}");
  bo.String("{del {e n}} {nor {e n}} {nor {e n}}");
  bo.String("{del {f n}} {nul {n e}} {nor {b n}}");
  if (x)
    bo.String("{del {f n}} {nor {e n}} {nor {b n}}");
  else
    bo.String("{del {f n}} {del {e n}} {nor {b n}}");
  if (z)
    bo.String("{del {f n}} {nul {n e}} {nor {b n}}");
  else
    bo.String("{del {f n}} {nul {n e}} {del {b n}}");
  bo.String("{del {f n}} {del {e n}} {del {e n}}");

  bo.SetOutputs(2,0,0,true);
  bo.SetOutputs(2,1,0,true);
  bo.SetOutputs(1,2,0,y);
  bo.SetOutputs(2,2,1,true);
  bo.SetOutputs(2,2,2,true);
  bo.SetOutputs(1,2,3,true);
  bo.SetOutputs(1,2,5,x);
  bo.SetOutputs(2,2,6,z);
  bo.SetOutputs(2,2,5,!x && !z);
  bo.SetOutputs(2,2,4,x || z);

  bo.Terminal("i",0,2,3,true,west);
  bo.Terminal("o",2,2,3,false,east);
}

// 8/7/06 compact version of folded decoder, reduced part count
void SerialDecoderCompact(CBasicObject &bo, bool x, bool y, bool z)
{
  bo.Layer();
  bo.String("{nul {s e}} {del {s e}} {nor {n e}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");


  bo.Layer();
  bo.String("{nul {s e}} {del {s e}} {del {n e}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");
  bo.String("{nul {s e}} {nul {e n}} {nul {e n}}");

  bo.Layer();
  bo.String("{nul {s e}} {del {b n}} {del {n e}}");
  bo.String("{nul {s e}} {del {b n}} {nul {e n}}");
  bo.String("{nul {s e}} {del {b n}} {nul {e n}}");
  bo.String("{nul {s e}} {del {n e}} {nul {e n}}");
  bo.String("{nul {s e}} {del {f n}} {nul {e n}}");
  bo.String("{nul {s e}} {del {f n}} {nul {e n}}");
  bo.String("{nul {s e}} {del {f n}} {nul {e n}}");
  bo.String("{nul {s e}} {del {f n}} {nul {e n}}");

  bo.Layer();
  if (y)
    bo.String("{nul {n e}} {nor {e n}} {nor {f n}}");
  else
    bo.String("{nul {n e}} {del {n e}} {nor {f n}}");
  bo.String("{nul {n e}} {nul {n e}} {nor {f n}}");
  bo.String("{nul {n e}} {nul {n e}} {del {f n}}");
  bo.String("{nul {n e}} {nor {e n}} {nor {e n}}");
  bo.String("{nul {n e}} {nul {n e}} {nor {b n}}");
  if (x)
    bo.String("{nul {n e}} {nor {e n}} {nor {b n}}");
  else
    bo.String("{nul {n e}} {del {n e}} {nor {b n}}");
  if (z)
    bo.String("{nul {n e}} {nul {n e}} {nor {b n}}");
  else
    bo.String("{nul {n e}} {nul {n e}} {del {b n}}");
  bo.String("{nul {n e}} {del {n e}} {del {e n}}");

  bo.SetOutputs(2,1,0,true);
  bo.SetOutputs(2,2,0,true);
  bo.SetOutputs(1,3,0,y);
  bo.SetOutputs(2,3,1,true);
  bo.SetOutputs(2,3,2,true);
  bo.SetOutputs(1,3,3,true);
  bo.SetOutputs(1,3,5,x);
  bo.SetOutputs(2,3,6,z);
  bo.SetOutputs(2,3,5,!x && !z);
  bo.SetOutputs(2,3,4,x || z);

  bo.Terminal("i",1,2,3,true,south);
  bo.Terminal("o",2,3,3,false,east);
}

