#include "objects.cpp"
#include "library\blockmanager.cpp"
#include "library\detect.cpp"
#include "library\memorycontrol.cpp"
#include "library\orientation.cpp"
#include "library\constructor.cpp"

#define USE_TESTPARTS

// A line of test blocks for placing in front of the constructor
void TestParts(CBasicObject &bo)
{
  std::string tmp;

  bo.Layer();

#include "testparts.cpp"

  char orString[] = "{n e}";
  char *dirString = "neswfb";

  {for(unsigned i = 0; i<7; i++)
  {
    if ((Part)(i+1) != push)
    {
      for(unsigned j = 0; j<10; j++)
      {
        tmp += "{";
        tmp += PartToString((Part)(i+1));
	tmp += " {s f}";
        tmp += " e} {nul {n e}} ";      
      }
    }
  }}
 
  bo.String(tmp.c_str());

  bo.Terminal("attach",(tmp.length()/12) + 40,0,0,false,east);
}

void RequestBlockSignal(CBasicObject &bo)
{
  for(unsigned i = 0; i<4; i++)
  {
    bo.Layer();
    bo.String("{nul {n e}} {nul {n e}}");
    bo.String("{nul {n e}} {del {s e}}");
  }
  bo.Layer();
  bo.String("{del {e n}} {del {e n}}");
  bo.String("{nul {n e}} {del {f e}}");

  bo.Terminal("i",0,4,0,true,west);
  bo.Terminal("o",1,0,1,false,front);
}


void OrientatorPulseGen(CBasicObject &bo)
{
  bo.Layer();
  bo.String("{del {b n}} {del {e n}} {del {e n}} {del {e n} x nesfb}");
  bo.String("{del {b n}} {del {w n}} {del {w n}} {del {f n}}");
  bo.String("{del {b n}} {del {f n}} {del {e n}} {del {e n}}");
  bo.String("{del {w n}} {del {w n}} {del {w n}} {del {f n}}");

  bo.Terminal("o",0,0,0,false,west);
}

void PConst(CCompoundObject &co)
{

#include "srm.cpp"

  unsigned proglen = sizeof(prog)/(sizeof(prog[0]));
 
  CCompoundObject *blockManager = new CCompoundObject;
  CCompoundObject *mc = new CCompoundObject;
  CBasicObject *detect = new CBasicObject;
  CBasicObject *testParts = new CBasicObject;
  CBasicObject *cms = new CBasicObject;
  CBasicObject *rbs = new CBasicObject;
  CCompoundObject *cons = new CCompoundObject;
  CBasicObject *opg = new CBasicObject;
  BlockManager(*blockManager,16,15,26); // for full memory
//  BlockManager(*blockManager,16,15,3);    // for reduced size memory
  Detect(*detect);
  TestParts(*testParts);
  MemoryControl(*mc,prog,proglen);
  RequestBlockSignal(*rbs);
  SignalPath(*cms,5,13,10,west,back,south,east,west);
  Constructor(*cons,18);
  OrientatorPulseGen(*opg);

  cons->Mirror(east);
  detect->Rotate(north);
  rbs->Rotate(north);
  opg->Rotate(west);
  opg->Rotate(west);

  co.AddObject(blockManager,"blockManager",0,0,0);
  co.AddObject(detect,"detect","requestPart","blockManager.junction.request-block");

#ifdef USE_TESTPARTS
  co.AddObject(testParts,"testParts","attach","detect.partInput");
#endif

  co.AddObject(rbs,"rbs","o","blockManager.bep.bp.ireq");

  co.AddObject(mc,"mc","dispensepath.o","rbs.i");

  co.AddObject(cons,"cons","path1.c","blockManager.ottr.o");

  co.AddObject(cms,"cms","o","cons.path1.i");

  co.AddObject(opg,"opg","o","blockManager.bep.bp.ipul");


}

int main(void)
{
  CCompoundObject co;
  CCompoundObject pc1;

  PConst(pc1);

  co.AddObject(&pc1,"pc1",0,0,0);

  std::ofstream osg("pconst.grd");
  std::ofstream ost("pconst.trm");

  co.ResolveConnections(&co,0,0,0);
  co.Output(osg,ost,0,0,0);
  ShowCount();
  return 0;
}
