// CBlocks3D.cpp : Defines the class behaviors for the application.
//
#include "stdafx.h"
#include "afxadv.h"

#include <string>
#include <fstream>

#include "CBlocks3D.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "CBlocks3DDoc.h"
#include "CBlocks3DView.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCBlocks3DApp

BEGIN_MESSAGE_MAP(CCBlocks3DApp, CWinApp)
	//{{AFX_MSG_MAP(CCBlocks3DApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_RUNANIMATION, OnFileRunAnimation)
	ON_COMMAND(ID_FILE_MRU_FILE1, OnFileMruFile1)
	ON_COMMAND(ID_FILE_MRU_FILE2, OnFileMruFile2)
	ON_COMMAND(ID_FILE_MRU_FILE3, OnFileMruFile3)
	ON_COMMAND(ID_FILE_MRU_FILE4, OnFileMruFile4)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCBlocks3DApp construction

CCBlocks3DApp::CCBlocks3DApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

CCBlocks3DApp::~CCBlocks3DApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CCBlocks3DApp object

CCBlocks3DApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CCBlocks3DApp initialization

BOOL CCBlocks3DApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_CBLOCKTYPE,
		RUNTIME_CLASS(CCBlocks3DDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CCBlocks3DView));
	AddDocTemplate(pDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
//	if (!ProcessShellCommand(cmdInfo))
//		return FALSE;

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CCBlocks3DApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CCBlocks3DApp message handlers

void CCBlocks3DApp::ProcessFileOpen(std::ifstream &is)
{
	CCBlocks3DDoc *doctmp;
	CStimuli *stitmp;
	CTerminals *termtmp;
	CUniverseViews *uvtmp;
	CMonitor *montmp;

	unsigned startTime = 0;

	if (is)
	{
		std::string gridfile,termfile,stimfile,inifile,uvfile;
		std::string monfile;
		std::string tmp;


		while(is)
		{
			std::getline(is,tmp);

			if (tmp.rfind(".grd") == tmp.length()-4)
			{
				gridfile = tmp;
			}
			if (tmp.rfind(".trm") == tmp.length()-4)
			{
				termfile = tmp;
			}
			if (tmp.rfind(".sti") == tmp.length()-4)
			{
				stimfile = tmp;
			}
			if (tmp.rfind(".ini") == tmp.length()-4)
			{
				inifile = tmp;
			}
			if (tmp.rfind(".uvw") == tmp.length()-4)
			{
				uvfile = tmp;
			}
			if (tmp.rfind(".mon") == tmp.length()-4)
			{
				monfile = tmp;
			}
			
			bool alldigits = true;

			for(unsigned i = 0; alldigits && i<tmp.length(); i++)
			{
				alldigits = alldigits && isdigit(tmp[i]);
			}

			if (alldigits)
			{
				startTime = atoi(tmp.c_str());
			}

		}

		// Save the recent file list and restore it again in a minute - this is a hack to prevent OpenDocumentFile
		// from adding a .grd file to the recent file list.
		
		std::vector<std::string> rfl;
		bool saverfl = false;

		if (m_pRecentFileList)
		{
			for(unsigned i = 0; i<m_pRecentFileList->GetSize(); i++)
			{
				rfl.push_back((LPCSTR)(*m_pRecentFileList)[i]);
			}
			saverfl = true;
		}

		if (gridfile.length() && (doctmp = (CCBlocks3DDoc *)OpenDocumentFile(gridfile.c_str())))
		{
			if (saverfl)
			{
#if 0
				{for(unsigned i = m_pRecentFileList->GetSize(); i; i--)
				{
					m_pRecentFileList->Remove(i-1);
				}}
#endif
				for(unsigned i = rfl.size(); i; i--)
				{
					m_pRecentFileList->Add(rfl[i-1].c_str());
				}
			}

			termtmp = NULL;

			// if there is a terminal file, open it
			if (termfile.length())
			{
				std::ifstream termis(termfile.c_str());

				if (termis)
				{
					termtmp = new CTerminals(termis);
				}
			}

			stitmp = NULL;

			// if there is a stimulus file, open it
			if (stimfile.length())
			{
				std::ifstream stimis(stimfile.c_str());

				if (stimis)
				{
					stitmp = new CStimuli(stimis,termtmp,&(doctmp->U));

					while(startTime--)
					{
						stitmp->Apply(NULL);
					}
				}
			}

			uvtmp = NULL;

			// if there is a unvierse view file, open it
			if (uvfile.length())
			{
				uvtmp = new CUniverseViews(uvfile);
			}
				
			montmp = NULL;

			if (monfile.length())
			{
				std::ifstream monis(monfile.c_str());

				if (monis)
				{
					montmp = new CMonitor(monis,termtmp);
				}
			}

			// if there is an ini file, open it and apply it to the document
			// TODO - may not need ini files

			doctmp->SetSupport(termtmp,stitmp,uvtmp,montmp);
		}
		else
		{
			// TODO - error could not open file
		}
	}
}


void CCBlocks3DApp::OnFileOpen() 
{
	CFileDialog fdial(TRUE,"prj",NULL,0,"CBlocks3D project file (*.prj)|*.prj||",NULL);

	if (fdial.DoModal() == IDOK)
	{
		std::ifstream is(fdial.GetPathName());

		if (is)
		{
			AfxGetApp()->AddToRecentFileList(fdial.GetPathName());

			ProcessFileOpen(is);
		}
	}
}

void CCBlocks3DApp::ProcessRecentFileItem(unsigned i)
{
	char pathbuffer[1024];
	char *fnamepos;

	if (m_pRecentFileList->GetSize() > i)
	{
		GetFullPathName((*m_pRecentFileList)[i],1024,pathbuffer,&fnamepos);

		*fnamepos = (char)0;

		SetCurrentDirectory(pathbuffer);

		std::ifstream is((*m_pRecentFileList)[i]);

		if (is)
		{
			ProcessFileOpen(is);
		}
	}
}

void CCBlocks3DApp::OnFileMruFile1() 
{
	ProcessRecentFileItem(0);
}

void CCBlocks3DApp::OnFileMruFile2() 
{
	ProcessRecentFileItem(1);
}

void CCBlocks3DApp::OnFileMruFile3()
{
	ProcessRecentFileItem(2);
}

void CCBlocks3DApp::OnFileMruFile4()
{
	ProcessRecentFileItem(3);
}

void CCBlocks3DApp::OnFileRunAnimation()
{
	CFileDialog fdial(TRUE,"asf",NULL,0,"Animation specification file (*.asf)|*.asf||",NULL);

	if (fdial.DoModal() == IDOK)
	{
		std::ifstream is(fdial.GetPathName());

		if (is)
		{
			((CMainFrame *)m_pMainWnd)->ao = new CAnimoutput(is);
		}
	}
}
