// CBlocks3DDoc.cpp : implementation of the CCBlocks3DDoc class
//

#include "stdafx.h"

#include <fstream>
#include <vector>
#include <string>

using namespace std;

#include "CBlocks3D.h"

#include "CBlocks3DDoc.h"
#include "CBlocks3DView.h"
#include "RegionsDialog.h"
#include "MemoryDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

DWORD WINAPI ThreadFunc(LPVOID p)
{
	CCBlocks3DDoc *pclass = (CCBlocks3DDoc *)p;

	while(pclass->runthread)
	{
 	    while(pclass->suspendthread && pclass->stepthread)
		{
		 	pclass->ack = 1;
			Sleep(0);
		}

		pclass->stepthread = 1;
		pclass->ack = 0;
#if 0
		if (pclass->animfile && pclass->U.GetIteration()%pclass->frameevery == 0)
		{
			pclass->U.DrawAnim(*(pclass->animfile));
			(*(pclass->animfile)) << -1 << endl;
		}
#endif
		if (pclass->rununtil == 0 || pclass->U.iters < pclass->rununtil)
		{
			pclass->U.moveView = false;
			pclass->ApplyStimuli();
			pclass->U.Process();
			pclass->U.DoMove();
			pclass->U.Update();
			pclass->U.Clean();

			if (pclass->U.moveView)
			{
				Direction moveViewDir = pclass->U.moveViewDir;

				pclass->GetFirstView()->xp += DirectionToX(moveViewDir);
				pclass->GetFirstView()->yp += DirectionToY(moveViewDir);
				pclass->GetFirstView()->zp += DirectionToZ(moveViewDir);
			}

			if (pclass->mon)
			{
				pclass->mon->MonitorCheck(&(pclass->U));
			}
		}
		else
		{
			pclass->suspendthread = 1;
			pclass->goingslow = false;
		}
	}

	pclass->runack = 1;

	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CCBlocks3DDoc

IMPLEMENT_DYNCREATE(CCBlocks3DDoc, CDocument)

BEGIN_MESSAGE_MAP(CCBlocks3DDoc, CDocument)
	//{{AFX_MSG_MAP(CCBlocks3DDoc)
	ON_COMMAND(ID_RUN_GO, OnRunGo)
	ON_UPDATE_COMMAND_UI(ID_RUN_GO, OnUpdateRunGo)
	ON_UPDATE_COMMAND_UI(ID_RUN_STEP, OnUpdateRunStep)
	ON_COMMAND(ID_RUN_STOP, OnRunStop)
	ON_UPDATE_COMMAND_UI(ID_RUN_STOP, OnUpdateRunStop)
	ON_COMMAND(ID_RUN_GOSLOW, OnRunGoslow)
	ON_UPDATE_COMMAND_UI(ID_RUN_GOSLOW, OnUpdateRunGoslow)
	ON_COMMAND(ID_RUN_STEP, OnRunStep)
	ON_COMMAND(ID_VIEW_REGIONS, OnViewRegions)
	ON_COMMAND(ID_TOOLS_MEMORY, OnToolsMemory)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCBlocks3DDoc construction/destruction

void CCBlocks3DDoc::ConstructorCall(void)
{
	runthread = 1;
	suspendthread = 1;
	stepthread = 1;
	ack = 0;
	runack = 0;
	trm = NULL;
	sti = NULL;
	uv = NULL;
	mon = NULL;
	goingslow = 0;
	rununtil = 0;

	threadhandle = CreateThread(NULL,0,&ThreadFunc,this,0,&threadid);
	//SetThreadPriority(threadhandle,THREAD_PRIORITY_BELOW_NORMAL);
}

void CCBlocks3DDoc::DestructorCall(void)
{
	runthread = 0;

	suspendthread = 0;

	while(runack == 0)
		Sleep(0);

	CloseHandle(threadhandle);

	if (trm)
		delete trm;

	if (sti)
		delete sti;

	if (uv)
		delete uv;

	if (mon)
		delete mon;
}

void CCBlocks3DDoc::SetSupport(CTerminals *t, CStimuli *s, CUniverseViews *u, CMonitor *m)
{
	if (trm)
		delete trm;
	if (sti)
		delete sti;
	if (uv)
		delete uv;
	if (mon)
		delete mon;

	trm = t;
	sti = s;
	uv = u;
	mon = m;
}

CCBlocks3DDoc::CCBlocks3DDoc()
{
	// TODO: add one-time construction code here
	ConstructorCall();
}

CCBlocks3DDoc::~CCBlocks3DDoc()
{
	DestructorCall();
}

BOOL CCBlocks3DDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	DestructorCall();
	ConstructorCall();

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CCBlocks3DDoc serialization

void CCBlocks3DDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CCBlocks3DDoc diagnostics

#ifdef _DEBUG
void CCBlocks3DDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CCBlocks3DDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCBlocks3DDoc commands

void CCBlocks3DDoc::OnRunGo() 
{
	suspendthread = 0;	
}

void CCBlocks3DDoc::OnUpdateRunGo(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(suspendthread && !goingslow);	
}

void CCBlocks3DDoc::OnRunStep() 
{
	stepthread = 0;	
}

void CCBlocks3DDoc::OnUpdateRunStep(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(suspendthread && !goingslow);	
}

void CCBlocks3DDoc::OnRunStop() 
{
	suspendthread = 1;
	goingslow = false;
}

void CCBlocks3DDoc::OnUpdateRunStop(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(!suspendthread || goingslow);
}

BOOL CCBlocks3DDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (IsModified())
		TRACE0("Warning: OnOpenDocument replaces an unsaved document.\n");

	DeleteContents();
	SetModifiedFlag();  // dirty during de-serialize

	unsigned l = strlen(lpszPathName);
	int filetype = 0;

	if (l>=4)
	{
		if (!stricmp(lpszPathName+l-4,".grd"))
			filetype = 1;
	}
	
	if (!filetype)
		return FALSE;

	if (filetype)
	{
		std::ifstream is(lpszPathName);

		if (is)
		{
		  U.Load(is);
		}
	}

	SetModifiedFlag(FALSE);     // start off with unmodified

#ifdef _MAC
	WIN32_FIND_DATA fileData;
	HANDLE hFind = FindFirstFile(lpszPathName, &fileData);
	ASSERT(hFind != (HANDLE)-1);
	VERIFY(FindClose(hFind));

	if ((fileData.wFinderFlags & kIsStationery) != 0)
	{
		SetModifiedFlag();
		if (m_pDocTemplate != NULL)
			m_pDocTemplate->SetDefaultTitle(this);
	}
#endif

	return TRUE;
}

// WS - Modified from CDocument::OnSaveDocument, this function
// saves a document without any of the business with the archive.
BOOL CCBlocks3DDoc::OnSaveDocument(LPCTSTR lpszPathName) 
{
	bool didsuspend = false;

	if (suspendthread == 0)
	{
		suspendthread = 1;
		while(ack == 0)
			Sleep(0);

		didsuspend = true;
	}

	ofstream os(lpszPathName);

	if (os)
	{
		U.Save(os);
	}
	else
		; // TODO - report error

	if (didsuspend)
	{
		suspendthread = 0;
		while(ack == 1)
			Sleep(0);
	}


#ifdef _MAC
	RecordDataFileOwner(lpszPathName, AfxGetAppName());
#endif

	SetModifiedFlag(FALSE);     // back to unmodified

	return TRUE;        // success
}

void CCBlocks3DDoc::ApplyStimuli(void)
{
	if (sti)
		sti->Apply(&U);
}

void CCBlocks3DDoc::OnRunGoslow() 
{
	goingslow = 1;
	stepthread = 0;
}

void CCBlocks3DDoc::OnUpdateRunGoslow(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(suspendthread && !goingslow);	
}



void CCBlocks3DDoc::OnViewRegions() 
{
	// TODO: Add your command handler code here
	CRegionsDialog rd(&U);

	rd.DoModal();
}

std::vector<unsigned> CCBlocks3DDoc::ReadMemoryFile(std::ifstream &is)
{
	std::vector<unsigned> rval;
	char c;
	std::string token;
	bool started = false;

	while(is.get(c))
	{
		if (started)
		{
			if (c==',')
			{
				rval.push_back(atoi(token.c_str()));
				token = "";
			}
			else
			{
				token += c;
			}
		}

		if (c=='{')
		{
			started = true;
		}
	}

	return rval;
}

void CCBlocks3DDoc::OnToolsMemory()
{
	CMemoryDialog md;

	if (md.DoModal() == IDOK)
	{
		std::ifstream is(md.m_memfile);

		if (is)
		{
			std::vector<unsigned> data = ReadMemoryFile(is);

			this->U.WriteToMemory(md.m_x,md.m_y,md.m_z,md.m_offset,data);
		}
	}
}

