// CBlocks3DDoc.h : interface of the CCBlocks3DDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CBLOCKS3DDOC_H__D3F8F6EC_8D02_11D9_B040_BF1E5D05A949__INCLUDED_)
#define AFX_CBLOCKS3DDOC_H__D3F8F6EC_8D02_11D9_B040_BF1E5D05A949__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Engine\Universe.h"
#include "Support\universeviews.h"
#include "Support\monitor.h"

class CCBlocks3DView;

class CCBlocks3DDoc : public CDocument
{
protected: // create from serialization only
	CCBlocks3DDoc();
	DECLARE_DYNCREATE(CCBlocks3DDoc)

// Attributes
public:
	CUniverse U;
	DWORD threadid;
	HANDLE threadhandle;
	DWORD runthread,suspendthread,stepthread;
	DWORD goingslow;
	DWORD ack;
	DWORD runack;
	UINT rununtil;

	CTerminals *trm;
	CStimuli *sti;
	CUniverseViews *uv;
	CMonitor *mon;

// Operations
public:
	void ConstructorCall(void);
	void DestructorCall(void);

	void SetSupport(CTerminals *t, CStimuli *s, CUniverseViews *uv, CMonitor *m);
	void ApplyStimuli(void);
	CCBlocks3DView *GetFirstView(void) {return (CCBlocks3DView *)(m_viewList.GetHead());}

	std::vector<unsigned> CCBlocks3DDoc::ReadMemoryFile(std::ifstream &is);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCBlocks3DDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CCBlocks3DDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CCBlocks3DDoc)
	afx_msg void OnRunGo();
	afx_msg void OnUpdateRunGo(CCmdUI* pCmdUI);
	afx_msg void OnUpdateRunStep(CCmdUI* pCmdUI);
	afx_msg void OnRunStop();
	afx_msg void OnUpdateRunStop(CCmdUI* pCmdUI);
	afx_msg void OnRunGoslow();
	afx_msg void OnUpdateRunGoslow(CCmdUI* pCmdUI);
	afx_msg void OnRunStep();
	afx_msg void OnViewRegions();
	afx_msg void OnToolsMemory();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CBLOCKS3DDOC_H__D3F8F6EC_8D02_11D9_B040_BF1E5D05A949__INCLUDED_)
