// cubeview.h : interface of the CCubeView class
//
// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1997 Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.
class CSettingsDialog;

class CCBlocks3DView : public CView
{
protected: // create from serialization only
	CCBlocks3DView();
	DECLARE_DYNCREATE(CCBlocks3DView)

// Attributes
public:
	CCBlocks3DDoc* GetDocument();

    CPalette    m_cPalette;
    CPalette    *m_pOldPalette;
	CRect		m_oldRect;
	float		m_fRadius;
	CClientDC	*m_pDC;

	float xp,yp,zp;
	float az,alt;
	CString description;

	CString	animFolder;
	CString	animPrefix;
	
	unsigned animSteps;
	unsigned animIndex;
	int animLast;

// Operations
public:
	void Init();
	void CreateRGBPalette(void);
    BOOL bSetupPixelFormat(void);
    unsigned char ComponentFromIndex(int i, UINT nbits, UINT shift);
    void DrawScene(void);
	void UpdateIterations(void);
	BOOL WriteViewToDIB( LPCTSTR szFile );


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCBlocks3DView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CCBlocks3DView();
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	BOOL	m_play;

// Generated message map functions
protected:
	//{{AFX_MSG(CCBlocks3DView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnRunSettings();
	afx_msg void OnUpdateRunSettings(CCmdUI* pCmdUI);
	afx_msg void OnWriteEps();
	afx_msg void OnToolsSavebitmap();
	afx_msg void OnToolsAnimation();
	afx_msg void OnViewCentreOfMass();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnFileSaveTerminals();
};

#ifndef _DEBUG  
inline CCBlocks3DDoc* CCBlocks3DView::GetDocument()
   { return (CCBlocks3DDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
