#define BLOCK_CPP

#include "..\stdafx.h"

#include "Block.h"
#include "Universe.h"
#include "..\Support\Stimulus.h"

/*
int DirectionToX(Direction p)
{
	switch(p)
	{
	case east:
		return 1;
	case west:
		return -1;
	default:
		return 0;
	}
}

int DirectionToY(Direction p)
{
	switch(p)
	{
	case north:
		return 1;
	case south:
		return -1;
	default:
		return 0;
	}
}

int DirectionToZ(Direction p)
{
	switch(p)
	{
	case front:
		return 1;
	case back:
		return -1;
	default:
		return 0;
	}
}

Direction OppositeDir(Direction p)
{
	switch(p)
	{
	case north:
		return south;
		break;
	case east:
		return west;
		break;
	case south:
		return north;
		break;
	case west:
		return east;
		break;
	case front:
		return back;
		break;
	case back:
		return front;
		break;
	}
}
*/

Direction GetTranslatedDir(Direction p, Direction np, Direction ep, Direction fp)
{
	switch(p)
	{
	case north:
		return np;
		break;
	case east:
		return ep;
		break;
	case south:
		return OppositeDir(np);
		break;
	case west:
		return OppositeDir(ep);
		break;
	case front:
		return fp;
		break;
	case back:
		return OppositeDir(fp);
		break;
	}
}

Direction GetFrontPos(Direction np, Direction ep)
{
	if (np != back && ep != back && np != front && ep != front)
	{
		if (ep == (Direction)((np+1)%4))
			return front;
		else
			return back;
	}

	if (np == back)
		return (Direction)((ep + 3)%4);

	if (np == front)
		return (Direction)((ep + 1)%4);

	if (ep == back)
		return (Direction)((np + 1)%4);

	if (ep == front)
		return (Direction)((np + 3)%4);
}

#if 0

bool ProcessNothing(CBlock *b, CUniverseCell *U)
{
	return false;
}

bool ProcessDelta(CBlock *b, CUniverseCell *U)
{
			if (b->GetInput(OppositeDir(b->northpos),U))
			{
				b->buffer = (northmask |
					      eastmask | 
						  southmask |
						  westmask |
						  frontmask |
						  backmask) ^ (1<<OppositeDir(b->northpos));
			}
			else
			{
				b->buffer = 0;
			}

			return ((b->buffer ^ b->output) & (1<<b->northpos));
}

bool ProcessNor(CBlock *b, CUniverseCell *U)
{
			bool i = b->GetInput(OppositeDir(b->northpos),U);
			i = i || b->GetInput(b->eastpos,U);
			i = i || b->GetInput(b->frontpos,U);
			i = i || b->GetInput(OppositeDir(b->eastpos),U);
			i = i || b->GetInput(OppositeDir(b->frontpos),U);

			b->buffer = ((!i) << b->northpos);

			return ((b->buffer ^ b->output) & (1<<b->northpos));
}

bool ProcessPush(CBlock *b, CUniverseCell *U)
{
			if (b->GetInput(OppositeDir(b->northpos),U))
			{
				U->parent->MakeMove(
					b->x+DirectionToX(b->northpos),
					b->y+DirectionToY(b->northpos),
					b->z+DirectionToZ(b->northpos),
					b->northpos
					); 

				return true;
			}
			else
			{
				return false;
			}
}

bool ProcessSlide(CBlock *b, CUniverseCell *U)
{
			if (b->GetInput(OppositeDir(b->northpos),U))
			{
				U->parent->MakeMove(
					b->x+DirectionToX(b->northpos),
					b->y+DirectionToY(b->northpos),
					b->z+DirectionToZ(b->northpos),
					b->eastpos
					); 

				return true;
			}
			else
			{
				return false;
			}
}

bool ProcessRotate(CBlock *b, CUniverseCell *U)
{
			if (b->GetInput(OppositeDir(b->northpos),U))
			{
				U->parent->Rotate(
					b->x+DirectionToX(b->northpos),
					b->y+DirectionToY(b->northpos),
					b->z+DirectionToZ(b->northpos),
					b->northpos);

				return true;
			}
			else
			{
				return false;
			}
}

bool ProcessFuse(CBlock *b, CUniverseCell *U)
{
			if (b->GetInput(OppositeDir(b->northpos),U))
			{
				U->parent->Connect(
					b->x+DirectionToX(b->northpos),
					b->y+DirectionToY(b->northpos),
					b->z+DirectionToZ(b->northpos),
					b->eastpos,true
					); 

				return true;
			}
			else
			{
				return false;
			}
}

bool ProcessUnFuse(CBlock *b, CUniverseCell *U)
{
			if (b->GetInput(OppositeDir(b->northpos),U))
			{
				U->parent->Connect(
					b->x+DirectionToX(b->northpos),
					b->y+DirectionToY(b->northpos),
					b->z+DirectionToZ(b->northpos),
					b->eastpos,false
					); 

				return true;
			}
			else
			{
				return false;
			}
}

bool ProcessKeypress(CBlock *b, CUniverseCell *U)
{
		b->SetOutput(b->northpos,U->parent->press,U);
		return ((b->buffer ^ b->output) & (1<<b->northpos));
}

bool ProcessSignal(CBlock *b, CUniverseCell *U)
{
		b->SetOutput(b->northpos,true,U);
		return true;
}

bool ProcessSlideOn(CBlock *b, CUniverseCell *U)
{
				U->parent->MakeMove(
					b->x+DirectionToX(b->northpos),
					b->y+DirectionToY(b->northpos),
					b->z+DirectionToZ(b->northpos),
					b->eastpos
					); 

				return true;
}
#endif

CBlock::CBlock(int xp, int yp, int zp, Type t)
{
	x = xp;
	y = yp;
	z = zp;
	tp = t;
	northpos = north;
	eastpos = east;
	frontpos = front;

	buffer = output = 0;
	connect = 0;

	for(unsigned i = 0; i<6; i++)
	{
		neighbour[i] = NULL;
	}

	move = NULL;
	moveinto = NULL;

	torotate = false;

	region = NULL;
	stim = NULL;

#if 0
	switch(tp)
	{
	case delta:
		pf = ProcessDelta;
		break;
	case nor:
		pf = ProcessNor;
		break;
	case push:
		pf = ProcessPush;
		break;
	case slide:
		pf = ProcessSlide;
		break;
	case rotate:
		pf = ProcessRotate;
		break;
	case fuse:
		pf = ProcessFuse;
		break;
	case unfuse:
		pf = ProcessUnFuse;
		break;
	case keypress:
		pf = ProcessKeypress;
		break;
	case signal:
		pf = ProcessSignal;
		break;
	case slideon:
		pf = ProcessSlideOn;
		break;
	default:
		pf = ProcessNothing;
		break;
	}
#endif
}

CBlock::~CBlock(void)
{
	for(unsigned i = 0; i<6; i++)
	{
		if (neighbour[i])
			neighbour[i]->neighbour[OppositeDir(i)] = NULL;
	}
}

bool CBlock::Process(CUniverseCell *U)
{
	bool rval = false;

	switch(tp)
	{
	case delta:
		{
			bool i = GetInput(OppositeDir(northpos));

#if 0
			SetOutput(northpos,i,U);
			SetOutput(eastpos,i,U);
			SetOutput(frontpos,i,U);
			SetOutput(OppositeDir(eastpos),i,U);
			SetOutput(OppositeDir(frontpos),i,U);
#endif
			// 17/2/08 - hopefully this is faster...
			if (i)
			{
				buffer = (northmask |
					      eastmask | 
						  southmask |
						  westmask |
						  frontmask |
						  backmask) ^ (1<<OppositeDir(northpos));
			}
			else
			{
				buffer = 0;
			}

			rval = ((buffer ^ output) & (1<<northpos));
		}
		break;
	case nor:
		{
			bool i = GetInput(OppositeDir(northpos));
			i = i || GetInput(eastpos);
			i = i || GetInput(frontpos);
			i = i || GetInput(OppositeDir(eastpos));
			i = i || GetInput(OppositeDir(frontpos));

			buffer = ((!i) << northpos);

			rval = ((buffer ^ output) & (1<<northpos));
		}
		break;
	case push:
		{
			bool i = GetInput(OppositeDir(northpos));

			if (i)
			{
				U->parent->MakeMove(
					x+DirectionToX(northpos),
					y+DirectionToY(northpos),
					z+DirectionToZ(northpos),
					northpos
					); 
			}
		}
		break;
	case slide:
		{
			bool i = GetInput(OppositeDir(northpos));

			if (i)
			{
				U->parent->MakeMove(
					x+DirectionToX(northpos),
					y+DirectionToY(northpos),
					z+DirectionToZ(northpos),
					eastpos
					); 
			}

		}
		break;
	case rotate:
		{
			bool i = GetInput(OppositeDir(northpos));

			if (i)
			{
				U->parent->Rotate(
					x+DirectionToX(northpos),
					y+DirectionToY(northpos),
					z+DirectionToZ(northpos),
					northpos);		
			}
		}
		break;
	case fuse:
	case unfuse:
		{
			bool i = GetInput(OppositeDir(northpos));

			if (i)
			{
				U->parent->Connect(
					x+DirectionToX(northpos),
					y+DirectionToY(northpos),
					z+DirectionToZ(northpos),
					eastpos,tp==fuse
					); 
			}

			rval = i;
		}
		break;
	case keypress:
		SetOutput(northpos,U->parent->press);
		rval = ((buffer ^ output) & (1<<northpos));
		break;
	case signal:
		SetOutput(northpos,true);
		break;
	case slideon:
		{
				U->parent->MakeMove(
					x+DirectionToX(northpos),
					y+DirectionToY(northpos),
					z+DirectionToZ(northpos),
					eastpos
					); 
		}
		break;
	default:
		break;
	}

	return rval;
}

__forceinline bool CBlock::GetInput(Direction d)
{
	if (neighbour[d])
		return (neighbour[d]->output) & (1<<OppositeDir(d));
	else
		return false;
}

__forceinline void CBlock::SetOutput(Direction d, bool v)
{
	if (v)
		buffer = buffer | (1<<d);
	else
		buffer = buffer & (~(1<<d));
}

void CBlock::ApplyStimulus(Direction d)
{
	output = output | (1<<d);
}

bool CBlock::Update(CUniverseCell *U)
{
	bool rval = false;

	if (move && !move->cancel)
	{
		buffer = blockmove.buffer;
		connect = blockmove.connect;
		region = blockmove.region;
		stim = blockmove.stim;

		if (stim)
		{
			if (stim->Move(move->dir))
			{
				U->parent->moveView = true;
				U->parent->moveViewDir = move->dir;
			}
		}

		tp = blockmove.tp;
		northpos = blockmove.northpos;
		eastpos = blockmove.eastpos;
		frontpos = blockmove.frontpos;

#if 1 // not necessary - all neighbours should have been set
		for(unsigned i = 0; i<6; i++)
		{
			neighbour[i] = U->parent->GetBlockNoAdd(x+DirectionToX(i),
											  y+DirectionToY(i),
											  z+DirectionToZ(i));
			if (neighbour[i])
				neighbour[i]->neighbour[OppositeDir(i)] = this;
		}
#endif

		rval = true;
	}

	output = buffer;

	move = NULL;
	torotate = false;

	return rval;
}

void CBlock::DoMove(void)
{
	if (!move || move->cancel)
		return;

	// If the block in the opposite direction of the move is
	// going to move, or is not going to move in the same
	// direction as this block, then this block will be
	// empty on the next timestep
	if (!moveinto->move || !move->SameDirection(moveinto->move))
	{
		blockmove.tp = empty;
		blockmove.connect = 0;
		blockmove.buffer = 0;
		blockmove.region = NULL;
		blockmove.stim = NULL;
	}
	else
	{
		blockmove.northpos = moveinto->northpos;
		blockmove.eastpos = moveinto->eastpos;
		blockmove.frontpos = moveinto->frontpos;
		blockmove.tp = moveinto->tp;
		blockmove.region = moveinto->region;
		blockmove.stim = moveinto->stim;

		blockmove.buffer = moveinto->buffer;
		blockmove.connect = moveinto->connect;
	}
}

// Here, d specifies the axis of the block to be rotated - i.e. if d is north then
// the block is rotated about its northpos axis.
void CBlock::RotateAboutAxis(Direction d)
{
	Direction tmp;

	switch(d)
	{
	case north:
			tmp = eastpos;
			eastpos = OppositeDir(frontpos);
			frontpos = tmp;
			break;
	case south:
			tmp = eastpos;
			eastpos = frontpos;
			frontpos = OppositeDir(tmp);
			break;
	case west:
			tmp = northpos;
			northpos = OppositeDir(frontpos);
			frontpos = tmp;
			break;
	case east:
			tmp = northpos;
			northpos = frontpos;
			frontpos = OppositeDir(tmp);
			break;
	case back:
			tmp = northpos;
			northpos = eastpos;
			eastpos = OppositeDir(tmp);
			break;
	case front:
			tmp = northpos;
			northpos = OppositeDir(eastpos);
			eastpos = tmp;
			break;
	}
}

bool CBlock::DoRotate(void)
{
	bool rval = false;
	Direction tmp;

	if (torotate)
	{
		rval = true;

		switch(rotateaxis)
		{
		case north:
			/*
			tmpb = connect[east];
			connect[east] = connect[front];
			connect[front] = connect[west];
			connect[west] = connect[back];
			connect[back] = tmpb;
			*/
			buffer = (buffer & (northmask | southmask)) |
					 ((buffer & frontmask) >> (front - east)) |
					 ((buffer & westmask) << (front - west)) |
					 ((buffer & backmask) >> (back - west)) |
					 ((buffer & eastmask) << (back - east));

			/*
			tmpb = buffer[east];
			buffer[east] = buffer[front];
			buffer[front] = buffer[west];
			buffer[west] = buffer[back];
			buffer[back] = tmpb;
            */
			if (northpos == north)
				RotateAboutAxis(north);
			else if (northpos == south)
				RotateAboutAxis(south);
			else if (eastpos == north)
				RotateAboutAxis(east);
			else if (eastpos == south)
				RotateAboutAxis(west);
			else if (frontpos == north)
				RotateAboutAxis(front);
			else if (frontpos == south)
				RotateAboutAxis(back);
			break;
		case south:
			/*
			tmpb = connect[east];
			connect[east] = connect[back];
			connect[back] = connect[west];
			connect[west] = connect[front];
			connect[front] = tmpb;
			*/
			buffer = (buffer & (northmask | southmask)) |
					 ((buffer & backmask) >> (back - east)) |
					 ((buffer & westmask) << (back - west)) |
					 ((buffer & frontmask) >> (front - west)) |
					 ((buffer & eastmask) << (front - east));

			/*
			tmpb = buffer[east];
			buffer[east] = buffer[back];
			buffer[back] = buffer[west];
			buffer[west] = buffer[front];
			buffer[front] = tmpb;
			*/

			if (northpos == north)
				RotateAboutAxis(south);
			else if (northpos == south)
				RotateAboutAxis(north);
			else if (eastpos == north)
				RotateAboutAxis(west);
			else if (eastpos == south)
				RotateAboutAxis(east);
			else if (frontpos == north)
				RotateAboutAxis(back);
			else if (frontpos == south)
				RotateAboutAxis(front);
			break;
		case west:
			/*
			tmpb = connect[north];
			connect[north] = connect[front];
			connect[front] = connect[south];
			connect[south] = connect[back];
			connect[back] = tmpb;
			*/

			buffer = (buffer & (eastmask | westmask)) |
			((buffer & frontmask) >> (front - north)) |
			((buffer & southmask) << (front - south)) |
			((buffer & backmask) >> (back - south)) |
			((buffer & northmask) << (back - north));

			/*
			tmpb = buffer[north];
			buffer[north] = buffer[front];
			buffer[front] = buffer[south];
			buffer[south] = buffer[back];
			buffer[back] = tmpb;
			*/

			if (northpos == west)
				RotateAboutAxis(north);
			else if (northpos == east)
				RotateAboutAxis(south);
			else if (eastpos == west)
				RotateAboutAxis(east);
			else if (eastpos == east)
				RotateAboutAxis(west);
			else if (frontpos == west)
				RotateAboutAxis(front);
			else if (frontpos == east)
				RotateAboutAxis(back);
			break;
		case east:
			/*
			tmpb = connect[north];
			connect[north] = connect[back];
			connect[back] = connect[south];
			connect[south] = connect[front];
			connect[front] = tmpb;
			*/

			buffer = (buffer & (eastmask | westmask)) |
			((buffer & backmask) >> (back - north)) |
			((buffer & southmask) << (back - south)) |
			((buffer & frontmask) >> (front - south)) |
			((buffer & northmask) << (front - north));

			/*
			tmpb = buffer[north];
			buffer[north] = buffer[back];
			buffer[back] = buffer[south];
			buffer[south] = buffer[front];
			buffer[front] = tmpb;
			*/

			if (northpos == west)
				RotateAboutAxis(south);
			else if (northpos == east)
				RotateAboutAxis(north);
			else if (eastpos == west)
				RotateAboutAxis(west);
			else if (eastpos == east)
				RotateAboutAxis(east);
			else if (frontpos == west)
				RotateAboutAxis(back);
			else if (frontpos == east)
				RotateAboutAxis(front);
			break;
		case back:
			/*
			tmpb = connect[north];
			connect[north] = connect[west];
			connect[west] = connect[south];
			connect[south] = connect[east];
			connect[east] = tmpb;
			*/

			buffer = (buffer & (frontmask | backmask)) |
			((buffer & westmask) >> (west - north)) |
			((buffer & southmask) << (west - south)) |
			((buffer & eastmask) << (south - east)) |
			((buffer & northmask) << (east - north));

			/*
			tmpb = buffer[north];
			buffer[north] = buffer[west];
			buffer[west] = buffer[south];
			buffer[south] = buffer[east];
			buffer[east] = tmpb;
			*/

			if (northpos == back)
				RotateAboutAxis(north);
			else if (northpos == front)
				RotateAboutAxis(south);
			else if (eastpos == back)
				RotateAboutAxis(east);
			else if (eastpos == front)
				RotateAboutAxis(west);
			else if (frontpos == back)
				RotateAboutAxis(front);
			else if (frontpos == front)
				RotateAboutAxis(back);

			break;
		case front:
			/*
			tmpb = connect[north];
			connect[north] = connect[east];
			connect[east] = connect[south];
			connect[south] = connect[west];
			connect[west] = tmpb;
			*/

			buffer = (buffer & (frontmask | backmask)) |
			((buffer & eastmask) >> (east - north)) |
			((buffer & southmask) >> (south - east)) |
			((buffer & westmask) >> (west - south)) |
			((buffer & northmask) << (west - north));

			/*
			tmpb = buffer[north];
			buffer[north] = buffer[east];
			buffer[east] = buffer[south];
			buffer[south] = buffer[west];
			buffer[west] = tmpb;
			*/

			if (northpos == front)
				RotateAboutAxis(north);
			else if (northpos == back)
				RotateAboutAxis(south);
			else if (eastpos == front)
				RotateAboutAxis(east);
			else if (eastpos == back)
				RotateAboutAxis(west);
			else if (frontpos == front)
				RotateAboutAxis(front);
			else if (frontpos == back)
				RotateAboutAxis(back);

			break;
		}
	}

	return rval;
}

unsigned CBlock::Move(CMove *m, CBlock *mb)
{
	if (move == m)
		return 0;

	if (move && !move->SameDirection(m))
	{
		move->cancel = true;
		return MOVE_BAD;
	}

	move = m;
	moveinto = mb;

	unsigned rval = 0;

	if (tp != empty)
	{
		for(unsigned i = 0; i<6; i++)
		{
			if ((connect & (1<<i)) || i==move->dir)
				rval += (1<<i);
		}
	}

	return rval;
}

void CBlock::Rotate(Direction d)
{
	torotate = true;
	rotateaxis = d;
}

void CBlock::ResolveConnections(CUniverseCell *U)
{
	for(unsigned i = 0; i<6; i++)
	{
		if (connect & (1<<i))
		{
			CBlock *b = U->parent->GetBlockNoAdd(x+DirectionToX((Direction)i),y+DirectionToY((Direction)i),z+DirectionToZ((Direction)i));

			if (b && b->tp != empty)
			{
				if (! (
					 b->connect & (1 << OppositeDir((Direction)i) ) 
					) )
					connect ^= (1<<i);
			}
			else
				connect ^= (1<<i);
		}
	}
}

void CBlock::SetNeighbours(CUniverseCell *U)
{
	for(unsigned i = 0; i<6; i++)
	{
		neighbour[i] = U->parent->GetBlockNoAdd(x+DirectionToX((Direction)i),y+DirectionToY((Direction)i),z+DirectionToZ((Direction)i));

		if (neighbour[i])
			neighbour[i]->neighbour[OppositeDir(i)] = this;
	}
}

#if 0
void CBlock::UnsetNeighbours(CUniverseCell *U)
{
	for(unsignd i = 0; i<6; i++)
	{
	}
}
#endif
