#include "../stdafx.h"

#include "gl\gl.h"
#include "gl\glu.h"

#include "Block.h"
#include "Universe.h"

#define CUBE_SIZE 0.45
#define CUBE_BOUND 0.5
#define CUBE_BOUND_LINES 0.455
#define CON_BOUND 0.475
#define CON_SIZE 0.3
#define SIGNAL_SIZE 0.2
#define SIGNAL_SIZE_LARGE 0.5


struct CColourValue
{
	float red,green,blue;
};

void DrawNorthQuad(CColourValue fw,
				   CColourValue fe,
				   CColourValue bw,
				   CColourValue be)
{
		glColor3f(fw.red, fw.green, fw.blue);
		glVertex3f(-CUBE_SIZE, CUBE_SIZE,CUBE_SIZE);

		glColor3f(fe.red, fe.green, fe.blue);
		glVertex3f(CUBE_SIZE, CUBE_SIZE,CUBE_SIZE);

		glColor3f(be.red, be.green, be.blue);
		glVertex3f(CUBE_SIZE, CUBE_SIZE,-CUBE_SIZE);

		glColor3f(bw.red, bw.green, bw.blue);
		glVertex3f(-CUBE_SIZE, CUBE_SIZE,-CUBE_SIZE);
}

void DrawSouthQuad(CColourValue fw,
				   CColourValue fe,
				   CColourValue bw,
				   CColourValue be)
{
		glColor3f(fw.red, fw.green, fw.blue);
		glVertex3f(-CUBE_SIZE, -CUBE_SIZE,CUBE_SIZE);

		glColor3f(bw.red, bw.green, bw.blue);
		glVertex3f(-CUBE_SIZE, -CUBE_SIZE,-CUBE_SIZE);

		glColor3f(be.red, be.green, be.blue);
		glVertex3f(CUBE_SIZE, -CUBE_SIZE,-CUBE_SIZE);

		glColor3f(fe.red, fe.green, fe.blue);
		glVertex3f(CUBE_SIZE, -CUBE_SIZE,CUBE_SIZE);
}

void DrawEastQuad(CColourValue fn,
				   CColourValue fs,
				   CColourValue bn,
				   CColourValue bs)
{
		glColor3f(fn.red, fn.green, fn.blue);
		glVertex3f(CUBE_SIZE, CUBE_SIZE,CUBE_SIZE);

		glColor3f(fs.red, fs.green, fs.blue);
		glVertex3f(CUBE_SIZE, -CUBE_SIZE,CUBE_SIZE);

		glColor3f(bs.red, bs.green, bs.blue);
		glVertex3f(CUBE_SIZE, -CUBE_SIZE,-CUBE_SIZE);

		glColor3f(bn.red, bn.green, bn.blue);
		glVertex3f(CUBE_SIZE, CUBE_SIZE,-CUBE_SIZE);
}

void DrawWestQuad(CColourValue fn,
				   CColourValue fs,
				   CColourValue bn,
				   CColourValue bs)
{
		glColor3f(fn.red, fn.green, fn.blue);
		glVertex3f(-CUBE_SIZE, CUBE_SIZE,CUBE_SIZE);

		glColor3f(bn.red, bn.green, bn.blue);
		glVertex3f(-CUBE_SIZE, CUBE_SIZE,-CUBE_SIZE);

		glColor3f(bs.red, bs.green, bs.blue);
		glVertex3f(-CUBE_SIZE, -CUBE_SIZE,-CUBE_SIZE);

		glColor3f(fs.red, fs.green, fs.blue);
		glVertex3f(-CUBE_SIZE, -CUBE_SIZE,CUBE_SIZE);
}

void DrawFrontQuad(CColourValue ne,
				   CColourValue nw,
				   CColourValue se,
				   CColourValue sw)
{
		glColor3f(ne.red, ne.green, ne.blue);
		glVertex3f(CUBE_SIZE, CUBE_SIZE,CUBE_SIZE);

		glColor3f(nw.red, nw.green, nw.blue);
		glVertex3f(-CUBE_SIZE, CUBE_SIZE,CUBE_SIZE);

		glColor3f(sw.red, sw.green, sw.blue);
		glVertex3f(-CUBE_SIZE, -CUBE_SIZE,CUBE_SIZE);

		glColor3f(se.red, se.green, se.blue);
		glVertex3f(CUBE_SIZE, -CUBE_SIZE,CUBE_SIZE);

}

void DrawBackQuad(CColourValue ne,
				   CColourValue nw,
				   CColourValue se,
				   CColourValue sw)
{
		glColor3f(ne.red, ne.green, ne.blue);
		glVertex3f(CUBE_SIZE, CUBE_SIZE,-CUBE_SIZE);

		glColor3f(se.red, se.green, se.blue);
		glVertex3f(CUBE_SIZE, -CUBE_SIZE,-CUBE_SIZE);

		glColor3f(sw.red, sw.green, sw.blue);
		glVertex3f(-CUBE_SIZE, -CUBE_SIZE,-CUBE_SIZE);

		glColor3f(nw.red, nw.green, nw.blue);
		glVertex3f(-CUBE_SIZE, CUBE_SIZE,-CUBE_SIZE);
}

void DrawNorthOutput(void)
{
		glColor3f(1,0,0);
		glVertex3f(-SIGNAL_SIZE, CUBE_BOUND,SIGNAL_SIZE);

//		glColor3f(1,0,0);
		glVertex3f(SIGNAL_SIZE, CUBE_BOUND,SIGNAL_SIZE);

//		glColor3f(1,0,0);
		glVertex3f(SIGNAL_SIZE, CUBE_BOUND,-SIGNAL_SIZE);

//		glColor3f(1,0,0);
		glVertex3f(-SIGNAL_SIZE, CUBE_BOUND,-SIGNAL_SIZE);
}

void DrawSouthOutput(void)
{
		glColor3f(1,0,0);
		glVertex3f(-SIGNAL_SIZE, -CUBE_BOUND,SIGNAL_SIZE);

//		glColor3f(1,0,0);
		glVertex3f(-SIGNAL_SIZE, -CUBE_BOUND,-SIGNAL_SIZE);

//		glColor3f(1,0,0);
		glVertex3f(SIGNAL_SIZE, -CUBE_BOUND,-SIGNAL_SIZE);

//		glColor3f(1,0,0);
		glVertex3f(SIGNAL_SIZE, -CUBE_BOUND,SIGNAL_SIZE);
}

void DrawEastOutput(void)
{
		glColor3f(1,0,0);
		glVertex3f(CUBE_BOUND, SIGNAL_SIZE,SIGNAL_SIZE);

//		glColor3f(1,0,0);
		glVertex3f(CUBE_BOUND, -SIGNAL_SIZE,SIGNAL_SIZE);

//		glColor3f(1,0,0);
		glVertex3f(CUBE_BOUND, -SIGNAL_SIZE,-SIGNAL_SIZE);

//		glColor3f(1,0,0);
		glVertex3f(CUBE_BOUND, SIGNAL_SIZE,-SIGNAL_SIZE);
}

void DrawWestOutput(void)
{
		glColor3f(1,0,0);
		glVertex3f(-CUBE_BOUND, SIGNAL_SIZE,SIGNAL_SIZE);

//		glColor3f(1,0,0);
		glVertex3f(-CUBE_BOUND, SIGNAL_SIZE,-SIGNAL_SIZE);

//		glColor3f(1,0,0);
		glVertex3f(-CUBE_BOUND, -SIGNAL_SIZE,-SIGNAL_SIZE);

//		glColor3f(1,0,0);
		glVertex3f(-CUBE_BOUND, -SIGNAL_SIZE,SIGNAL_SIZE);
}

void DrawFrontOutput(void)
{
		glColor3f(1,0,0);
		glVertex3f(SIGNAL_SIZE, SIGNAL_SIZE,CUBE_BOUND);

//		glColor3f(1,0,0);
		glVertex3f(-SIGNAL_SIZE, SIGNAL_SIZE,CUBE_BOUND);

//		glColor3f(1,0,0);
		glVertex3f(-SIGNAL_SIZE, -SIGNAL_SIZE,CUBE_BOUND);

//		glColor3f(1,0,0);
		glVertex3f(SIGNAL_SIZE, -SIGNAL_SIZE,CUBE_BOUND);
}

void DrawBackOutput(void)
{
		glColor3f(1,0,0);
		glVertex3f(SIGNAL_SIZE, SIGNAL_SIZE,-CUBE_BOUND);

//		glColor3f(1,0,0);
		glVertex3f(SIGNAL_SIZE, -SIGNAL_SIZE,-CUBE_BOUND);

//		glColor3f(1,0,0);
		glVertex3f(-SIGNAL_SIZE, -SIGNAL_SIZE,-CUBE_BOUND);

//		glColor3f(1,0,0);
		glVertex3f(-SIGNAL_SIZE, SIGNAL_SIZE,-CUBE_BOUND);
}

void DrawNorthOutputLarge(void)
{
		glColor3f(1,0,0);
		glVertex3f(-SIGNAL_SIZE_LARGE, CUBE_BOUND,SIGNAL_SIZE_LARGE);

//		glColor3f(1,0,0);
		glVertex3f(SIGNAL_SIZE_LARGE, CUBE_BOUND,SIGNAL_SIZE_LARGE);

//		glColor3f(1,0,0);
		glVertex3f(SIGNAL_SIZE_LARGE, CUBE_BOUND,-SIGNAL_SIZE_LARGE);

//		glColor3f(1,0,0);
		glVertex3f(-SIGNAL_SIZE_LARGE, CUBE_BOUND,-SIGNAL_SIZE_LARGE);
}

void DrawSouthOutputLarge(void)
{
		glColor3f(1,0,0);
		glVertex3f(-SIGNAL_SIZE_LARGE, -CUBE_BOUND,SIGNAL_SIZE_LARGE);

//		glColor3f(1,0,0);
		glVertex3f(-SIGNAL_SIZE_LARGE, -CUBE_BOUND,-SIGNAL_SIZE_LARGE);

//		glColor3f(1,0,0);
		glVertex3f(SIGNAL_SIZE_LARGE, -CUBE_BOUND,-SIGNAL_SIZE_LARGE);

//		glColor3f(1,0,0);
		glVertex3f(SIGNAL_SIZE_LARGE, -CUBE_BOUND,SIGNAL_SIZE_LARGE);
}

void DrawEastOutputLarge(void)
{
		glColor3f(1,0,0);
		glVertex3f(CUBE_BOUND, SIGNAL_SIZE_LARGE,SIGNAL_SIZE_LARGE);

//		glColor3f(1,0,0);
		glVertex3f(CUBE_BOUND, -SIGNAL_SIZE_LARGE,SIGNAL_SIZE_LARGE);

//		glColor3f(1,0,0);
		glVertex3f(CUBE_BOUND, -SIGNAL_SIZE_LARGE,-SIGNAL_SIZE_LARGE);

//		glColor3f(1,0,0);
		glVertex3f(CUBE_BOUND, SIGNAL_SIZE_LARGE,-SIGNAL_SIZE_LARGE);
}

void DrawWestOutputLarge(void)
{
		glColor3f(1,0,0);
		glVertex3f(-CUBE_BOUND, SIGNAL_SIZE_LARGE,SIGNAL_SIZE_LARGE);

//		glColor3f(1,0,0);
		glVertex3f(-CUBE_BOUND, SIGNAL_SIZE_LARGE,-SIGNAL_SIZE_LARGE);

//		glColor3f(1,0,0);
		glVertex3f(-CUBE_BOUND, -SIGNAL_SIZE_LARGE,-SIGNAL_SIZE_LARGE);

//		glColor3f(1,0,0);
		glVertex3f(-CUBE_BOUND, -SIGNAL_SIZE_LARGE,SIGNAL_SIZE_LARGE);
}

void DrawFrontOutputLarge(void)
{
		glColor3f(1,0,0);
		glVertex3f(SIGNAL_SIZE_LARGE, SIGNAL_SIZE_LARGE,CUBE_BOUND);

//		glColor3f(1,0,0);
		glVertex3f(-SIGNAL_SIZE_LARGE, SIGNAL_SIZE_LARGE,CUBE_BOUND);

//		glColor3f(1,0,0);
		glVertex3f(-SIGNAL_SIZE_LARGE, -SIGNAL_SIZE_LARGE,CUBE_BOUND);

//		glColor3f(1,0,0);
		glVertex3f(SIGNAL_SIZE_LARGE, -SIGNAL_SIZE_LARGE,CUBE_BOUND);
}

void DrawBackOutputLarge(void)
{
		glColor3f(1,0,0);
		glVertex3f(SIGNAL_SIZE_LARGE, SIGNAL_SIZE_LARGE,-CUBE_BOUND);

//		glColor3f(1,0,0);
		glVertex3f(SIGNAL_SIZE_LARGE, -SIGNAL_SIZE_LARGE,-CUBE_BOUND);

//		glColor3f(1,0,0);
		glVertex3f(-SIGNAL_SIZE_LARGE, -SIGNAL_SIZE_LARGE,-CUBE_BOUND);

//		glColor3f(1,0,0);
		glVertex3f(-SIGNAL_SIZE_LARGE, SIGNAL_SIZE_LARGE,-CUBE_BOUND);
}

void DrawNorthConnect(void)
{
		glColor3f(0,1,0);
		glVertex3f(-CON_SIZE, CON_BOUND,CON_SIZE);

//		glColor3f(0,1,0);
		glVertex3f(CON_SIZE, CON_BOUND,CON_SIZE);

//		glColor3f(0,1,0);
		glVertex3f(CON_SIZE, CON_BOUND,-CON_SIZE);

//		glColor3f(0,1,0);
		glVertex3f(-CON_SIZE, CON_BOUND,-CON_SIZE);
}

void DrawSouthConnect(void)
{
		glColor3f(0,1,0);
		glVertex3f(-CON_SIZE, -CON_BOUND,CON_SIZE);

//		glColor3f(0,1,0);
		glVertex3f(-CON_SIZE, -CON_BOUND,-CON_SIZE);

//		glColor3f(0,1,0);
		glVertex3f(CON_SIZE, -CON_BOUND,-CON_SIZE);

//		glColor3f(0,1,0);
		glVertex3f(CON_SIZE, -CON_BOUND,CON_SIZE);
}

void DrawEastConnect(void)
{
		glColor3f(0,1,0);
		glVertex3f(CON_BOUND, CON_SIZE,CON_SIZE);

//		glColor3f(0,1,0);
		glVertex3f(CON_BOUND, -CON_SIZE,CON_SIZE);

//		glColor3f(0,1,0);
		glVertex3f(CON_BOUND, -CON_SIZE,-CON_SIZE);

//		glColor3f(0,1,0);
		glVertex3f(CON_BOUND, CON_SIZE,-CON_SIZE);
}

void DrawWestConnect(void)
{
		glColor3f(0,1,0);
		glVertex3f(-CON_BOUND, CON_SIZE,CON_SIZE);

//		glColor3f(0,1,0);
		glVertex3f(-CON_BOUND, CON_SIZE,-CON_SIZE);

//		glColor3f(0,1,0);
		glVertex3f(-CON_BOUND, -CON_SIZE,-CON_SIZE);

//		glColor3f(0,1,0);
		glVertex3f(-CON_BOUND, -CON_SIZE,CON_SIZE);
}

void DrawFrontConnect(void)
{
		glColor3f(0,1,0);
		glVertex3f(CON_SIZE, CON_SIZE,CON_BOUND);

//		glColor3f(0,1,0);
		glVertex3f(-CON_SIZE, CON_SIZE,CON_BOUND);

//		glColor3f(0,1,0);
		glVertex3f(-CON_SIZE, -CON_SIZE,CON_BOUND);

//		glColor3f(0,1,0);
		glVertex3f(CON_SIZE, -CON_SIZE,CON_BOUND);
}

void DrawBackConnect(void)
{
		glColor3f(0,1,0);
		glVertex3f(CON_SIZE, CON_SIZE,-CON_BOUND);

//		glColor3f(0,1,0);
		glVertex3f(CON_SIZE, -CON_SIZE,-CON_BOUND);

//		glColor3f(0,1,0);
		glVertex3f(-CON_SIZE, -CON_SIZE,-CON_BOUND);

//		glColor3f(0,1,0);
		glVertex3f(-CON_SIZE, CON_SIZE,-CON_BOUND);
}


void DrawColourCube(CColourValue normalcolours[2][2][2],
				   Direction np, Direction ep, Direction fp)
{
	static CColourValue cubecolours[2][2][2];

#define CCASSIGN(b1,b2,b3) \
	cubecolours \
				[b1&&(np==north) || b2&&(ep==north) || b3&&(fp==north) ||\
				 !b1&&(OppositeDir(np)==north) || !b2&&(OppositeDir(ep)==north) || !b3&&(OppositeDir(fp)==north)] \
				[b1&&(np==east) || b2&&(ep==east) || b3&&(fp==east) ||\
				 !b1&&(OppositeDir(np)==east) || !b2&&(OppositeDir(ep)==east) || !b3&&(OppositeDir(fp)==east)] \
				[b1&&(np==front) || b2&&(ep==front) || b3&&(fp==front) ||\
				 !b1&&(OppositeDir(np)==front) || !b2&&(OppositeDir(ep)==front) || !b3&&(OppositeDir(fp)==front)] \
			= normalcolours[b1][b2][b3];

	CCASSIGN(1,1,1);
	CCASSIGN(1,1,0);
	CCASSIGN(1,0,1);
	CCASSIGN(1,0,0);
	CCASSIGN(0,1,1);
	CCASSIGN(0,1,0);
	CCASSIGN(0,0,1);
	CCASSIGN(0,0,0);

#undef CCASSIGN
	DrawNorthQuad(cubecolours[1][0][1],
				  cubecolours[1][1][1],
				  cubecolours[1][0][0],
				  cubecolours[1][1][0]);
	DrawSouthQuad(cubecolours[0][0][1],
				  cubecolours[0][1][1],
				  cubecolours[0][0][0],
				  cubecolours[0][1][0]);
	DrawEastQuad(cubecolours[1][1][1],
				  cubecolours[0][1][1],
				  cubecolours[1][1][0],
				  cubecolours[0][1][0]);
	DrawWestQuad(cubecolours[1][0][1],
				  cubecolours[0][0][1],
				  cubecolours[1][0][0],
				  cubecolours[0][0][0]);
	DrawFrontQuad(cubecolours[1][1][1],
				  cubecolours[1][0][1],
				  cubecolours[0][1][1],
				  cubecolours[0][0][1]);
	DrawBackQuad(cubecolours[1][1][0],
				  cubecolours[1][0][0],
				  cubecolours[0][1][0],
				  cubecolours[0][0][0]);
}

void DrawOutputs(unsigned char output, bool isnor)
{
	if (!isnor)
	{
		if (output & northmask)
			DrawNorthOutput();
		if (output & southmask)
			DrawSouthOutput();
		if (output & eastmask)
			DrawEastOutput();
		if (output & westmask)
			DrawWestOutput();
		if (output & frontmask)
			DrawFrontOutput();
		if (output & backmask)
			DrawBackOutput();
	}
	else
	{
		if (output & northmask)
			DrawNorthOutputLarge();
		if (output & southmask)
			DrawSouthOutputLarge();
		if (output & eastmask)
			DrawEastOutputLarge();
		if (output & westmask)
			DrawWestOutputLarge();
		if (output & frontmask)
			DrawFrontOutputLarge();
		if (output & backmask)
			DrawBackOutputLarge();
	}
}

void DrawConnects(unsigned char connect)
{
	if (connect & (1<<north))
		DrawNorthConnect();
	if (connect & (1<<south))
		DrawSouthConnect();
	if (connect & (1<<east))
		DrawEastConnect();
	if (connect & (1<<west))
		DrawWestConnect();
	if (connect & (1<<front))
		DrawFrontConnect();
	if (connect & (1<<back))
		DrawBackConnect();
}


CColourValue SlideOnCubeColours[2][2][2] =
{
		{ { {0.5,0.5,0.5},{0.5,0.5,0.5} }, { {0.5,0.5,0.5}, {0.5,0.5,0.5} }},
		{ { {0.3,0.3,0.3},{0.3,0.3,0.3} }, { {0.1,0.1,0.1}, {0.1,0.1,0.1} }},
};


CColourValue TypeColours[CBlock::numtypes][2][2][2] =
{
	/* layout is SWB, SWF, SEB, SEF
	 *           NWB, NWF, NEB, NEF */
	/* empty (not used) */
	{
		{ { {0,0,0},{0,0,0} }, { {0,0,0}, {0,0,0} }},
		{ { {0,0,0},{0,0,0} }, { {0,0,0}, {0,0,0} }},
	},
	/* delta */
	{
		{ { {0,0,1},{0,0,1} }, { {0,0,1}, {0,0,1} }},
		{ { {1,1,0},{1,1,0} }, { {1,1,0}, {1,1,0} }},
	},
	/* nor */
	{
		{ { {0,0,1},{0,0,1} }, { {0,0,1}, {0,0,1} }},
		{ { {0,1,0},{0,1,0} }, { {0,1,0}, {0,1,0} }},
	},
	/* push */
	{
		{ { {0,0,1},{0,0,1} }, { {0,0,1}, {0,0,1} }},
		{ { {1,0,1},{1,0,1} }, { {1,0,1}, {1,0,1} }},
	},
	/* slide */
	{
		{ { {0,0,1},{0,0,1} }, { {0.5,0,1}, {0.5,0,1} }},
		{ { {1,0,0},{1,0,0} }, { {1,0,0}, {1,0,0} }},
	},
	/* rotate */
	{
		{ { {0,0,1},{0,0,1} }, { {0,0,1}, {0,0,1} }},
		{ { {0,1,1},{0,1,1} }, { {0,1,1}, {0,1,1} }},
	},
	/* fuse */
	{
		{ { {0,0,1},{0,0,1} }, { {0.05,0.5,1}, {0.05,0.5,1} }},
		{ { {1,1,1},{1,1,1} }, { {1,1,1}, {1,1,1} }},
	},
	/* unfuse */
	{
		{ {  {0,0,1}, {0,0,1} }, { {0.5,0.5,0.1},{0.5,0.5,0.1} }},
		{ { {0.1,0.1,0.1},{0.1,0.1,0.1} }, { {0.1,0.1,0.1}, {0.1,0.1,0.1} }},
	},
	/* keypress */
	{
		{ {  {0,0,0.5}, {0,0,0.5} }, { {0,0,0.5},{0,0,0.5} }},
		{ { {0,0.5,1},{0,0.5,1} }, { {0,0.5,1}, {0,0.5,1} }},
	},
	/* signal */
	{
		{ { {0,0.5,0},{0,0.5,0} }, { {0,0.5,0}, {0,0.5,0} }},
		{ { {0,1,0},{0,1,0} }, { {0,1,0}, {0,1,0} }},
	},
	/* slideon */
	{
		{ { {0,1,0},{0,1,0} }, { {0.5,1,0}, {0.5,1,0} }},
		{ { {1,0,0},{1,0,0} }, { {1,0,0}, {1,0,0} }},
	},
};

// Function to draw schematic representation for slideon. 
void DrawSlideOn(Direction np, Direction ep, Direction fp)
{
	glColor3f(1.0,1.0,1.0);

#if 0
	glBegin(GL_LINE_LOOP);

		glVertex3f(CUBE_BOUND_LINES,CUBE_BOUND_LINES,CUBE_BOUND_LINES);
		glVertex3f(CUBE_BOUND_LINES,CUBE_BOUND_LINES,-CUBE_BOUND_LINES);
		glVertex3f(CUBE_BOUND_LINES,-CUBE_BOUND_LINES,-CUBE_BOUND_LINES);
		glVertex3f(CUBE_BOUND_LINES,-CUBE_BOUND_LINES,CUBE_BOUND_LINES);

	glEnd();

	glBegin(GL_LINE_LOOP);

		glVertex3f(-CUBE_BOUND_LINES,-CUBE_BOUND_LINES,CUBE_BOUND_LINES);
		glVertex3f(-CUBE_BOUND_LINES,-CUBE_BOUND_LINES,-CUBE_BOUND_LINES);
		glVertex3f(-CUBE_BOUND_LINES,CUBE_BOUND_LINES,-CUBE_BOUND_LINES);
		glVertex3f(-CUBE_BOUND_LINES,CUBE_BOUND_LINES,CUBE_BOUND_LINES);

	glEnd();

	glBegin(GL_LINES);

		glVertex3f(CUBE_BOUND_LINES,CUBE_BOUND_LINES,CUBE_BOUND_LINES);
		glVertex3f(-CUBE_BOUND_LINES,CUBE_BOUND_LINES,CUBE_BOUND_LINES);
		glVertex3f(CUBE_BOUND_LINES,CUBE_BOUND_LINES,-CUBE_BOUND_LINES);
		glVertex3f(-CUBE_BOUND_LINES,CUBE_BOUND_LINES,-CUBE_BOUND_LINES);
		glVertex3f(CUBE_BOUND_LINES,-CUBE_BOUND_LINES,-CUBE_BOUND_LINES);
		glVertex3f(-CUBE_BOUND_LINES,-CUBE_BOUND_LINES,-CUBE_BOUND_LINES);
		glVertex3f(CUBE_BOUND_LINES,-CUBE_BOUND_LINES,CUBE_BOUND_LINES);
		glVertex3f(-CUBE_BOUND_LINES,-CUBE_BOUND_LINES,CUBE_BOUND_LINES);

	glEnd();
#endif

	glBegin(GL_LINES);

		glVertex3f(	CUBE_BOUND_LINES*(DirectionToX(np)-0.95*DirectionToX(ep)),
					CUBE_BOUND_LINES*(DirectionToY(np)-0.95*DirectionToY(ep)),
					CUBE_BOUND_LINES*(DirectionToZ(np)-0.95*DirectionToZ(ep)));
		glVertex3f(	CUBE_BOUND_LINES*(DirectionToX(np)+0.95*DirectionToX(ep)),
					CUBE_BOUND_LINES*(DirectionToY(np)+0.95*DirectionToY(ep)),
					CUBE_BOUND_LINES*(DirectionToZ(np)+0.95*DirectionToZ(ep)));
		glVertex3f(	CUBE_BOUND_LINES*(DirectionToX(np)+0.95*DirectionToX(ep)),
					CUBE_BOUND_LINES*(DirectionToY(np)+0.95*DirectionToY(ep)),
					CUBE_BOUND_LINES*(DirectionToZ(np)+0.95*DirectionToZ(ep)));
		glVertex3f(	CUBE_BOUND_LINES*(DirectionToX(np)+0.75*DirectionToX(ep)-0.2*DirectionToX(fp)),
					CUBE_BOUND_LINES*(DirectionToY(np)+0.75*DirectionToY(ep)-0.2*DirectionToY(fp)),
					CUBE_BOUND_LINES*(DirectionToZ(np)+0.75*DirectionToZ(ep)-0.2*DirectionToZ(fp)));
		glVertex3f(	CUBE_BOUND_LINES*(DirectionToX(np)+0.95*DirectionToX(ep)),
					CUBE_BOUND_LINES*(DirectionToY(np)+0.95*DirectionToY(ep)),
					CUBE_BOUND_LINES*(DirectionToZ(np)+0.95*DirectionToZ(ep)));
		glVertex3f(	CUBE_BOUND_LINES*(DirectionToX(np)+0.75*DirectionToX(ep)+0.2*DirectionToX(fp)),
					CUBE_BOUND_LINES*(DirectionToY(np)+0.75*DirectionToY(ep)+0.2*DirectionToY(fp)),
					CUBE_BOUND_LINES*(DirectionToZ(np)+0.75*DirectionToZ(ep)+0.2*DirectionToZ(fp)));

	glEnd();
}

// Function to write EPS calls for slideon. 
void WriteEPSSlideOn(Direction np, Direction ep, Direction fp, std::ofstream &os)
{
	unsigned char bv;
	GLfloat p[4]; 

	glRasterPos3f(CUBE_BOUND_LINES,CUBE_BOUND_LINES,CUBE_BOUND_LINES);

	glGetBooleanv(GL_CURRENT_RASTER_POSITION_VALID,&bv);
	
	if (bv)
	{
		glGetFloatv(GL_CURRENT_RASTER_POSITION,p);

		os << p[0] << " " << p[1] << std::endl;
	}

#if 0

	glBegin(GL_LINE_LOOP);

		glVertex3f(CUBE_BOUND_LINES,CUBE_BOUND_LINES,CUBE_BOUND_LINES);
		glVertex3f(CUBE_BOUND_LINES,CUBE_BOUND_LINES,-CUBE_BOUND_LINES);
		glVertex3f(CUBE_BOUND_LINES,-CUBE_BOUND_LINES,-CUBE_BOUND_LINES);
		glVertex3f(CUBE_BOUND_LINES,-CUBE_BOUND_LINES,CUBE_BOUND_LINES);

	glEnd();

	glBegin(GL_LINE_LOOP);

		glVertex3f(-CUBE_BOUND_LINES,-CUBE_BOUND_LINES,CUBE_BOUND_LINES);
		glVertex3f(-CUBE_BOUND_LINES,-CUBE_BOUND_LINES,-CUBE_BOUND_LINES);
		glVertex3f(-CUBE_BOUND_LINES,CUBE_BOUND_LINES,-CUBE_BOUND_LINES);
		glVertex3f(-CUBE_BOUND_LINES,CUBE_BOUND_LINES,CUBE_BOUND_LINES);

	glEnd();

	glBegin(GL_LINES);

		glVertex3f(CUBE_BOUND_LINES,CUBE_BOUND_LINES,CUBE_BOUND_LINES);
		glVertex3f(-CUBE_BOUND_LINES,CUBE_BOUND_LINES,CUBE_BOUND_LINES);
		glVertex3f(CUBE_BOUND_LINES,CUBE_BOUND_LINES,-CUBE_BOUND_LINES);
		glVertex3f(-CUBE_BOUND_LINES,CUBE_BOUND_LINES,-CUBE_BOUND_LINES);
		glVertex3f(CUBE_BOUND_LINES,-CUBE_BOUND_LINES,-CUBE_BOUND_LINES);
		glVertex3f(-CUBE_BOUND_LINES,-CUBE_BOUND_LINES,-CUBE_BOUND_LINES);
		glVertex3f(CUBE_BOUND_LINES,-CUBE_BOUND_LINES,CUBE_BOUND_LINES);
		glVertex3f(-CUBE_BOUND_LINES,-CUBE_BOUND_LINES,CUBE_BOUND_LINES);

	glEnd();

	glBegin(GL_LINES);

		glVertex3f(	CUBE_BOUND_LINES*(DirectionToX(np)-DirectionToX(ep)),
					CUBE_BOUND_LINES*(DirectionToY(np)-DirectionToY(ep)),
					CUBE_BOUND_LINES*(DirectionToZ(np)-DirectionToZ(ep)));
		glVertex3f(	CUBE_BOUND_LINES*(DirectionToX(np)+DirectionToX(ep)),
					CUBE_BOUND_LINES*(DirectionToY(np)+DirectionToY(ep)),
					CUBE_BOUND_LINES*(DirectionToZ(np)+DirectionToZ(ep)));
		glVertex3f(	CUBE_BOUND_LINES*(DirectionToX(np)+DirectionToX(ep)),
					CUBE_BOUND_LINES*(DirectionToY(np)+DirectionToY(ep)),
					CUBE_BOUND_LINES*(DirectionToZ(np)+DirectionToZ(ep)));
		glVertex3f(	CUBE_BOUND_LINES*(DirectionToX(np)+0.8*DirectionToX(ep)-0.2*DirectionToX(fp)),
					CUBE_BOUND_LINES*(DirectionToY(np)+0.8*DirectionToY(ep)-0.2*DirectionToY(fp)),
					CUBE_BOUND_LINES*(DirectionToZ(np)+0.8*DirectionToZ(ep)-0.2*DirectionToZ(fp)));
		glVertex3f(	CUBE_BOUND_LINES*(DirectionToX(np)+DirectionToX(ep)),
					CUBE_BOUND_LINES*(DirectionToY(np)+DirectionToY(ep)),
					CUBE_BOUND_LINES*(DirectionToZ(np)+DirectionToZ(ep)));
		glVertex3f(	CUBE_BOUND_LINES*(DirectionToX(np)+0.8*DirectionToX(ep)+0.2*DirectionToX(fp)),
					CUBE_BOUND_LINES*(DirectionToY(np)+0.8*DirectionToY(ep)+0.2*DirectionToY(fp)),
					CUBE_BOUND_LINES*(DirectionToZ(np)+0.8*DirectionToZ(ep)+0.2*DirectionToZ(fp)));

	glEnd();
#endif
}



bool CBlock::Draw(void)
{
	if (tp==empty || (region && !region->IsVisible()))
		return false;

    glPushMatrix();

        glTranslatef((float)x, (float)y, (float)z);

#if 1
		if (tp == slideon)
		{
			DrawSlideOn(northpos,eastpos,frontpos);
			glBegin(GL_QUADS);
			DrawColourCube(SlideOnCubeColours,northpos,eastpos,frontpos);

//			DrawOutputs(output);
//			DrawConnects(connect);
		}
		else
#endif
		{
			glBegin(GL_QUADS);
			DrawColourCube(TypeColours[tp],northpos,eastpos,frontpos);
			DrawOutputs(output,tp==nor);
			DrawConnects(connect);
		}


		glEnd();

    glPopMatrix();

	return true;
}

void CBlock::WriteEPS(std::ofstream &os)
{
	if (tp==empty)
		return;

    glPushMatrix();

        glTranslatef((float)x, (float)y, (float)z);

		if (tp == slideon)
		{
			WriteEPSSlideOn(northpos,eastpos,frontpos,os);
		}
		else
		{
			// TODO
			// At present, WriteEPS only supports the SlideOn part.
		}

//		DrawOutputs(output);
//		DrawConnects(connect);

		glEnd();

    glPopMatrix();
}

unsigned CUniverseCell::Draw(void)
{
	unsigned total = 0;
	for(unsigned i = 0; i<CELL_X; i++)
		for(unsigned j = 0; j<CELL_Y; j++)
			for(unsigned k = 0; k<CELL_Z; k++)
				total += (blocks[i][j][k]->Draw())?1:0;

	return total;
}

void CUniverseCell::WriteEPS(std::ofstream &os)
{
	for(unsigned i = 0; i<CELL_X; i++)
		for(unsigned j = 0; j<CELL_Y; j++)
			for(unsigned k = 0; k<CELL_Z; k++)
				blocks[i][j][k]->WriteEPS(os);
}

void CUniverse::Draw(void)
{
	unsigned total = 0;

	total += cells.Draw();

	totalDrawn = total;
}

void CUniverse::WriteEPS(std::ofstream &os)
{
	cells.WriteEPS(os);
}

