// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "CBlocks3D.h"

#include "MainFrm.h"
#include "CBlocks3DDoc.h"
#include "CBlocks3DView.h"
#include "docenum.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define TIMER_INTERVAL 50

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_SEPARATOR,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	ao = NULL;
	statewait = 0;
	animstate = 0;
	waittime = 0;
}

CMainFrame::~CMainFrame()
{
	if (ao) delete ao;
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	SetTimer(1,TIMER_INTERVAL,NULL);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::OnTimer(UINT nIDEvent) 
{
   CDocEnumerator it;
   CDocument* pdoc;
   while ((pdoc=it.Next())!=NULL) 
      pdoc->UpdateAllViews(NULL);

   m_wndToolBar.OnUpdateCmdUI(this,false);
//   m_wndToolBar.Invalidate(FALSE);

   // Now do any processing required for animating
   if (statewait)
   {
	   waittime += TIMER_INTERVAL;

	   switch(animstate)
	   {
	   case 0:
		   if (waittime > 12000)
		   {
			   statewait = 0;
			   animstate = 1;
		   }
		   break;
	   case 1:
		   if (waittime > 100)
		   {
			   statewait = 0;
			   animstate = 2;
		   }
		   break;
	   case 2:
		   if (waittime > 100)
		   {
			   statewait = 0;
			   animstate = 3;
		   }
		   break;
	   case 3:
		   if (waittime > 100)
		   {
			   statewait = 0;
			   animstate = 0;
			   if (ao) ao->index++;
		   }
		   break;
	   default:
		   break;
	   }
   }
   else if (ao)
   {
	    statewait = 1;
		waittime = 0;

		CAnimitem *i = &(ao->items[ao->index]);

		switch(animstate)
		{
		case 0:
			{
			std::string cmd = i->grdFile + std::string(".gz");
			::ShellExecute(NULL,NULL,"c:\\bin\\gunzip.exe",cmd.c_str(),NULL,SW_HIDE);
			}
			break;
		case 1:
			{
			::MoveFile(i->grdFile.c_str(),(i->grdFile + std::string(".grd")).c_str());
			}
			break;
		case 2:
			{
			doctmp = (CCBlocks3DDoc *)(theApp.OpenDocumentFile((i->grdFile+std::string(".grd")).c_str()));

			POSITION pos = doctmp->GetFirstViewPosition();
			CCBlocks3DView* pView = (CCBlocks3DView *)doctmp->GetNextView(pos);

			int x=0,y=0,z=0;
			doctmp->U.FindOrigin(x,y,z);

			pView->alt = i->alt;
			pView->az = i->az;
			pView->xp = i->x+x;
			pView->yp = i->y+y;
			pView->zp = i->z+z;

			pView->GetParentFrame()->ShowWindow( SW_SHOWMAXIMIZED );

			pView->DrawScene();
			}
			break;
		case 3:
			{
			POSITION pos = doctmp->GetFirstViewPosition();
			CCBlocks3DView* pView = (CCBlocks3DView *)doctmp->GetNextView(pos);

			CString filename;
			
			filename.Format("%s\\%s%.6d.bmp",ao->outputPath.c_str(),ao->outputPrefix.c_str(),ao->index);

			pView->WriteViewToDIB(filename);

			doctmp->OnCloseDocument();

			::DeleteFile((i->grdFile + std::string(".grd")).c_str());
			}
			break;
		default:
			break;
		}
	}
}
