// RegionsDialog.cpp : implementation file
//

#include "stdafx.h"
#include "CBlocks3D.h"
#include "RegionsDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRegionsDialog dialog


CRegionsDialog::CRegionsDialog(CUniverse *u, CWnd* pParent /*=NULL*/)
	: CDialog(CRegionsDialog::IDD, pParent)
{
	universe = u;

	//{{AFX_DATA_INIT(CRegionsDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

HTREEITEM FindInThisLevel(CTreeCtrl *tc, HTREEITEM i, std::string s)
{
	if (tc->ItemHasChildren(i))
	{
		for(HTREEITEM c = tc->GetChildItem(i); c; c=tc->GetNextSiblingItem(c))
		{
			if (tc->GetItemText(c) == s.c_str())
			{
				return c;
			}
		}

		return NULL;
	}
	else
	{
		return NULL;
	}
}

HTREEITEM InsertInThisLevel(CTreeCtrl *tc, HTREEITEM i, std::string s)
{
	HTREEITEM ni = tc->InsertItem(s.c_str(),i);
	tc->SetItemData(ni,(DWORD)(NULL));

	return ni;
}

HTREEITEM InsertIntoTree(CTreeCtrl *tc, std::string s)
{
	HTREEITEM current = tc->GetRootItem(), next;
	std::string beforedot,afterdot = s;
	unsigned n;

	while(afterdot.size())
	{
		n = afterdot.find_first_of('.');

		if (n == std::string::npos)
		{
			beforedot = afterdot;
			afterdot = "";
		}
		else
		{
			beforedot = afterdot.substr(0,n);
			afterdot = afterdot.substr(n+1);
		}

		next = FindInThisLevel(tc,current,beforedot);

		if (!next)
		{
			next = InsertInThisLevel(tc,current,beforedot);
		}

		current = next;
	}

	return current;
}

void CRegionsDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRegionsDialog)
	DDX_Control(pDX, IDC_REGIONTREE, m_TreeCtrl);
	//}}AFX_DATA_MAP

	if (!pDX->m_bSaveAndValidate)
	{
		CTreeCtrl *tc = &m_TreeCtrl;
		tc->DeleteAllItems();
		tc->ModifyStyle(TVS_CHECKBOXES,0);
		tc->ModifyStyle(0,TVS_CHECKBOXES);
		tc->SetCheck(tc->InsertItem("root",NULL),TRUE);


		if (universe)
		{	
			for(std::list<CRegion *>::iterator i = universe->GetRegions().begin(); i!=universe->GetRegions().end(); i++)
			{
				HTREEITEM ti = InsertIntoTree(tc,(*i)->GetID());

				tc->SetItemData(ti,(DWORD)(*i));
				tc->SetCheck(ti,(*i)->IsVisibleCheck());
			}

		}
	}
	else
	{
		CTreeCtrl *tc = &m_TreeCtrl;

		if (universe)
		{
			for(HTREEITEM ti = tc->GetRootItem(),titmp; ti;)
			{

				CRegion *r = (CRegion *)(tc->GetItemData(ti));

				if (r)
				{
					bool allchecked = true;
					for(HTREEITEM wu = ti; wu; wu = tc->GetParentItem(wu))
					{
						allchecked = allchecked && tc->GetCheck(wu);
					}

					
					r->SetVisible(!!allchecked,tc->GetCheck(ti));
				}

				titmp = tc->GetChildItem(ti);
				
				if (!titmp)
					titmp = tc->GetNextSiblingItem(ti);

				for(HTREEITEM wu = ti; !titmp;)
				{
					titmp = tc->GetParentItem(wu);
					if (titmp)
					{
						wu = titmp;
						titmp = tc->GetNextSiblingItem(titmp);
					}
					else
						break;
				}

				ti = titmp;
			}

		}
	}
}


BEGIN_MESSAGE_MAP(CRegionsDialog, CDialog)
	//{{AFX_MSG_MAP(CRegionsDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRegionsDialog message handlers

BOOL CRegionsDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
