#include "stimulus.h"

void CStimulus::Apply(CUniverse *u)
{

	if (index < stimulus.size())
	{
		if (stimulus[index].second && u && terminal)
			u->ApplyStimulus(terminal->xpos,terminal->ypos,terminal->zpos,terminal->face);


		if (count >= stimulus[index].first)
		{
			index++;

			if (index >= stimulus.size() && loop)
			{
				index = 0;
			}
		}
	}

	while(bindex < blocks.size() && blocks[bindex].first == count)
	{
		if (u && terminal)
		{
			CBlock *b = new CBlock(terminal->xpos,terminal->ypos,terminal->zpos,blocks[bindex].second.t);

			b->northpos = blocks[bindex].second.northpos;
			b->eastpos = blocks[bindex].second.eastpos;
			b->frontpos = GetFrontPos(b->northpos,b->eastpos);

			u->AddBlock(b);
		}

		bindex ++;
	}

	count++;
}

bool CStimulus::Move(Direction dir)
{
	terminal->xpos += DirectionToX(dir);
	terminal->ypos += DirectionToY(dir);
	terminal->zpos += DirectionToZ(dir);

	return (terminal->fullname == "pc1.mc.mad.mem.memory-module-a.m.i0");
}

CStimuli::CStimuli(std::istream &is, CTerminals *t, CUniverse *u)
{
	std::string term;
	std::string tmp;
	bool error = false;

	while(is && !error)
	{
		is >> term;

		if (!is)
			break;

		is >> tmp;

		if (tmp == "{")
		{
			CStimulus *tmpsti = new CStimulus;
			bool done = false;
			unsigned currenttime = 0;
			bool signal;

			if (t)
			{
				tmpsti->terminal = t->Lookup(term);

				if (tmpsti->terminal)
				{
					CBlock *b = u->GetBlock(tmpsti->terminal->xpos,tmpsti->terminal->ypos,tmpsti->terminal->zpos);

					if (b)
					{
						b->stim = tmpsti;
					}
				}
			}
			else
			{
				tmpsti->terminal = NULL;
			}

			while(is && !error && !done)
			{
				is >> tmp;

				if (tmp=="}")
				{
					stimuli.push_back(tmpsti);
					done = true;
				}
				else if (tmp=="loop")
				{
					tmpsti->loop = true;
				}
				else
				{
					if (tmp.substr(0,2) == "b=")
					{
						currenttime = atoi(tmp.substr(2).c_str());
						is >> tmp;
						
						CBlock::Type t = (CBlock::Type)(atoi(tmp.c_str()));
		
						is >> tmp;

						Direction np = (Direction)(atoi(tmp.c_str()));

						is >> tmp;

						Direction ep = (Direction)(atoi(tmp.c_str()));

						tmpsti->blocks.push_back(std::pair<unsigned,CBlockInfo>(currenttime,CBlockInfo(t,np,ep)));
					}
					else
					{
						if (tmp.substr(0,2) == "t=")
						{
							currenttime = atoi(tmp.substr(2).c_str());
							is >> tmp;
						}
					

						signal = (tmp=="1");

						is >> tmp;

						currenttime += atoi(tmp.c_str());

						tmpsti->stimulus.push_back(std::pair<unsigned,bool>(currenttime,signal));
					}
				}
			}
		}
		else
		{
			error = true;
		}
	}
}

void CStimuli::Apply(CUniverse *u)
{
	for(std::vector<CStimulus *>::iterator i = stimuli.begin(); i != stimuli.end(); i++)
	{
		(*i)->Apply(u);
	}
}