#ifndef STIMULUS_H
#define STIMULUS_H

#include <string>
#include <iostream>
#include <vector>

#include "..\Engine\Universe.h"
#include "terminal.h"
#include "..\Engine\Block.h"

class CBlockInfo
{
public:
	CBlockInfo(CBlock::Type t_, Direction np, Direction ep) : t(t_), northpos(np), eastpos(ep) {}

	CBlock::Type t;
	Direction northpos,eastpos;
};

class CStimulus
{
public:
	CStimulus() : index(0), count(0), bindex(0), terminal(NULL), loop(false) {}

	void Apply(CUniverse *u);
	bool Move(Direction dir);
public:
	CTerminal *terminal;
	std::vector<std::pair<unsigned,bool> > stimulus;
	std::vector<std::pair<unsigned,CBlockInfo> > blocks;

	unsigned index;
	unsigned bindex;
	unsigned count;
	bool loop;
};

class CStimuli
{
public:
	CStimuli(std::istream &is, CTerminals *t, CUniverse *u);
	void Apply(CUniverse *u);

	std::vector<CStimulus *> stimuli;
};

#endif