#include "..\stdafx.h"

#include <string>

#include "terminal.h"

void CTerminal::Write(std::ostream &os)
{
	std::string prefix = fullname.substr(0,fullname.rfind("."));
	std::string name = fullname.substr(fullname.rfind(".")+1);

	os << "object " << prefix << std::endl;
	os << "{" << std::endl;
	os << name << std::endl;
	os << xpos << " " << ypos << " " << zpos << std::endl;
	os << (int)face << std::endl;
	os << (int)input << std::endl;
	os << "}" << std::endl;
}

CTerminals::CTerminals(std::istream &is)
{
	std::string prefix;
	std::string tmp;
	bool error = false;
	int level = 0;

	while(is && !error)
	{
		is >> tmp;

		if (!is)
			break;

		if (tmp == "object")
		{
			is >> tmp;
			prefix = prefix + tmp;
			prefix = prefix + ".";
			is >> tmp;

			if (tmp != "{")
				error = true;

			level++;
		}
		else if (tmp == "}")
		{
			level--;

			if (level)
			{
				prefix = prefix.substr(0,prefix.size()-1);
				if (prefix.rfind(".") != std::string::npos)
				{
					prefix = prefix.substr(0,prefix.rfind(".")+1);
				}
				else
				{
					prefix.erase();
				}
			}
			else
			{
				prefix.erase();
			}
		}
		else
		{
			int x,y,z;
			int ii;
			bool ib;
			int fi;
			Direction face;

			is >> x >> y >> z;
			is >> fi >> ii;

			ib = !!ii;
			face = (Direction)fi;

			terminals.push_back(CTerminal(prefix+tmp,x,y,z,ib,face));
		}
	}
}

CTerminal *CTerminals::Lookup(std::string name)
{
	for(std::vector<CTerminal>::iterator i = terminals.begin(); i!=terminals.end(); i++)
	{
		if ((*i).fullname == name)
			return &(*i);
	}

	return NULL;
}

void CTerminals::WriteTerminals(std::ostream &os)
{
	for(std::vector<CTerminal>::iterator i = terminals.begin(); i!=terminals.end(); i++)
	{
		i->Write(os);
	}
}
