#include "universeviews.h"

#include <fstream>

CUniverseViews::CUniverseViews(std::string filename) : filename(filename)
{
	float x,y,z,alt,az;
	char description[256];
	char *descriptionptr;

	std::ifstream is(filename.c_str());

	while (is)
	{
		is >> x >> y >> z >> alt >> az;
		is.getline(description,256);
		descriptionptr = description;

		while(*descriptionptr && isspace(*descriptionptr))
		{
			descriptionptr++;
		}

		if (is)
		{
			universeviews.push_back(CUniverseView(std::string(descriptionptr),x,y,z,alt,az));
		}
	}
}
	
void CUniverseViews::Write(void)
{
	std::ofstream os(filename.c_str());

	if (os)
	{
		for(std::vector<CUniverseView>::iterator i = universeviews.begin(); i!=universeviews.end(); i++)
		{
			os << i->x << " " << i->y << " " << i->z << " " << i->alt << " " << i->az << " ";
			os << i->description << std::endl;
		}
	}
}
