// CDocEnumerator Enumerates all the documents in an application.

#include "StdAfx.h"
#include "DocEnum.h"

//////////////////
// ctor loads all doc pointers into private array.
//
CDocEnumerator::CDocEnumerator() {
   CWinApp* pApp = AfxGetApp();
   POSITION pos = pApp->GetFirstDocTemplatePosition();
   while (pos!=NULL) {
      CDocTemplate* pDocTemplate = pApp->GetNextDocTemplate(pos);
      POSITION pos2 = pDocTemplate->GetFirstDocPosition();
      while (pos2!=NULL) {
         m_doclist.Add(pDocTemplate->GetNextDoc(pos2));
      }
   }
   Reset();
}

//////////////////
// Fetch next document.
//
CDocument* CDocEnumerator::Next() {
   if (++m_iPos < m_doclist.GetSize()) {
      return (CDocument*)m_doclist[m_iPos];
   }
   return NULL;
}

